////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

 // stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__5E12FC48_0A58_11D5_8A94_E09F8D324901__INCLUDED_)
#define AFX_STDAFX_H__5E12FC48_0A58_11D5_8A94_E09F8D324901__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#ifdef ALHEP_WIN #else //Linux,Unix #endif //ALHEP_WIN

#if defined WIN32
#define ALHEP_WIN
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h> // for thread priority operations
//#include <afxwin.h> // MFC
//Disable C4996 warning: 'function' was declared deprecated (VC2008, absent in VC6)
#pragma warning(disable : 4996)
#elif defined WIN64
#define ALHEP_WIN
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h> // for thread priority operations
//#include <afxwin.h> // MFC
//Disable C4996 warning: 'function' was declared deprecated (VC2008, absent in VC6)
#pragma warning(disable : 4996)
#endif

#ifdef linux // win32
#define ALHEP_LINUX
#endif //linux

// TODO: reference additional headers your program requires here
//#include "../classes/Al.h"

////////////////////////////////////////////////////////
//	alhep standard incluces
////////////////////////////////////////////////////////
#include <cstdio>
#include <iostream>
#include <fstream>
//fstream, iomanip, ios, iosfwd, iostream, istream, ostream, sstream, streambuf, and strstream
#include <memory>
//#include <string>
#include <cstdlib> // for memory allocation operations & alol() function

using namespace std;

/*
#if (!__STDC_WANT_SECURE_LIB__)
inline void memcpy_s(void *dest, size_t sizeInBytes, const void *src, size_t count) {
	if (count > sizeInBytes) throw InvalidArgument("memcpy_s: buffer overflow");
	memcpy(dest, src, count);
}

inline void memmove_s(void *dest, size_t sizeInBytes, const void *src, size_t count) {
	if (count > sizeInBytes) throw InvalidArgument("memmove_s: buffer overflow");
	memmove(dest, src, count);
}
#endif //!__STDC_WANT_SECURE_LIB__
*/

#ifndef INT_MIN
#include <limits> // for INT_MIN ect.
//#define INT_MIN	-2147483647-1
#endif //INT_MIN

/*
#ifndef ALHEP_WIN
#if defined(_Ios_Openmode)
#define OPEN_FILE_FLAG_TYPE	std::_Ios_Openmode
#else //Win32
#define OPEN_FILE_FLAG_TYPE	int
#endif //ALHEP_WIN
*/

////////////////////////////////////////////////////////
//	alhep definitions
////////////////////////////////////////////////////////
#define DWORD	unsigned long

////////////////////////////////////////////////////////
//	alhep biuld options
////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// ALTA_DEBUG definition involves the smart memory management engine (20-30% performance lost)
//#define LOG_BUILD_OPTIONS
//#define ALTA_DEBUG
//#define ALTA_DEBUG_CHECKS
//#define D0_ONLY_CALC
#define PF_LESS_THAN
#define USE_PLAIN_ARRAY_FORSEQ // biuld sequence-expressions on CAPtrArray* basis
#define ARR_ADJUST_SIZE // decrease array size (complicated check ==> lower performance)
//extern DWORD URAND8(DWORD);
//extern double URAND8(double);

#ifdef ALTA_DEBUG
#ifndef ALTA_DEBUG_CHECKS
#define ALTA_DEBUG_CHECKS
#endif //!ALTA_DEBUG_CHECKS
#endif //ALTA_DEBUG

////////////////////////////////////////////////////////
//	alhep includes
////////////////////////////////////////////////////////
#include "core/expr/interfaces/headers/IENamedClass.h" // not used now

#include "core/EObject.h"
#include "core/data/headers/Const.h"
//#include "core/util/headers/APtrArray.h"
#include "core/util/headers/APtrSeq.h"
#include "core/util/EPtrArray.h"
#include "core/util/headers/IntArray.h"
#include "core/util/headers/EDoubleArray.h"
#include "core/util/headers/ETimeMark.h"
#include "core/util/headers/Debug.h"
#include "core/util/headers/MemoryManager.h"
#include "core/util/EString.h"
#include "core/util/ESerializable.h"
#include "core/util/headers/EPtrStack.h"
#include "core/util/headers/ECharMap.h"
#include "core/util/headers/VMFileUtils.h"

#include "core/exceptions/headers/EException.h" // uses string object

#include "core/util/headers/EProgressWatch.h"

#include "core/util/headers/ENamedItem.h"
#include "core/util/headers/EMap.h"
#include "core/util/headers/ESimpleMap.h"
#include "core/util/headers/EUtil.h"
#include "core/util/headers/Pos2D.h"

#include "core/util/headers/UXMLparcer.h"	

#include "core/EProperties.h"
#include "core/headers/EAbstractRule.h"
#include "core/Expression.h"
#include "core/util/headers/ExprContainer.h"
#include "core/util/headers/ENumberArray.h"
#include "core/util/headers/ECache.h"

#include "core/ERule.h"
#include "core/headers/ERulesList.h"
#include "core/headers/EReplasement.h"
#include "core/EReplList.h"
#include "core/headers/EPowerReplRule.h"
#include "core/headers/RCollectSymbols.h"
#include "core/headers/RReplaceDenominators.h"
#include "core/headers/ESocketRule.h"
#include "core/headers/RContainCheck.h"
#include "core/util/headers/RMaxPowerToSym.h"
#include "core/util/headers/RArrangeInfinity.h"

#include "core/data/headers/EDataNode.h"
#include "core/data/headers/EData.h"
#include "core/data/headers/EDataNodeImpl.h"

#include "core/ENumber.h"
#include "core/headers/EValue.h"
#include "core/headers/ERealValue.h"
#include "core/headers/EComplexValue.h"
#include "core/ESymbol.h"
#include "core/util/headers/Sequence.h"
#include "core/ESum.h"
#include "core/EProduct.h"
#include "core/expr/headers/EPower.h"

#include "core/EAbstractFunction.h"
#include "functions/headers/EFunction.h"

#include "core/expr/tensors/headers/TIndex.h"
#include "core/expr/interfaces/headers/IETensor.h"
#include "core/expr/tensors/headers/ETensor.h"
#include "core/expr/tensors/headers/ESpinor.h"
#include "core/expr/tensors/headers/EScalar.h"
#include "core/expr/tensors/headers/EMatrix.h"
#include "core/expr/tensors/headers/EMetric.h"
#include "core/expr/tensors/headers/EVector.h"
#include "core/expr/tensors/headers/EGamma.h"
#include "core/expr/tensors/headers/EGammaSpecial.h"
#include "core/expr/tensors/headers/ESProduct.h"
#include "core/expr/tensors/headers/ESGammaProduct.h"
#include "core/expr/tensors/headers/ETensorProduct.h"
#include "core/expr/tensors/headers/EAntisymmetric.h"
#include "core/expr/tensors/headers/ERank3Tensor.h"
#include "core/expr/tensors/headers/ERank4Tensor.h"
#include "core/expr/tensors/headers/EAntiSymmProd.h"
#include "core/expr/tensors/headers/EFuncBondarev.h"
#include "core/expr/tensors/headers/EGellMann.h"

#include "core/expr/headers/FLogN.h"
#include "core/expr/headers/MiscExpressions.h"

#include "core/headers/EBasic.h"
#include "core/support/headers/LSymbolDataBank.h"

#include "lib/headers/ENumVector.h"
#include "lib/headers/EParticle.h"
#include "lib/headers/Kinematics.h"
#include "lib/kinematics/headers/ElasticKinematics.h"
#include "lib/kinematics/headers/InelasticKinematics.h"
#include "lib/kinematics/headers/FourParticleKinematics.h"
#include "lib/kinematics/headers/GeneralKinematics.h"

#include "core/EAbstractProcessor.h"
#include "functions/headers/EFunctionDescription.h"
#include "functions/headers/EFunctionProvider.h"
#include "core/processor/headers/EProcessEnvironment.h"
#include "functions/headers/EFunctionManager.h"
#include "core/EProcessor.h"

#include "core/EFactory.h"

#include "tasks/EAbstractTask.h"
#include "lib/headers/ELibrary.h"
#include "lib/headers/LMath.h"
#include "lib/headers/Graphics.h"
#include "lib/headers/DiracAlgebra.h"
#include "lib/headers/FeynLib.h"
#include "tasks/headers/ESimplifyGammaSequence.h"
#include "tasks/headers/ETestTask.h"
#include "sessions/EAbstractSession.h"
#include "hep/lib/headers/LGammaSeqSimplify.h"

#include "support/headers/ESupport.h"

#include "functions/lib/headers/FSp.h"
#include "functions/lib/headers/FJfunc.h"

#include "lib/headers/EHistogram.h"
#include "lib/headers/AbstractGenerator.h"

#include "lib/simplify/headers/DenCacheLib.h"

#include "hep/particles/headers/PAbstractBoson.h"
#include "hep/particles/headers/PPhoton.h"
#include "hep/particles/headers/PFermion.h"
#include "hep/particles/headers/PBoson.h"
#include "hep/particles/headers/PBosonW.h"
#include "hep/particles/headers/PBosonZ.h"
#include "hep/particles/headers/PNeutrino.h"
#include "hep/util/headers/RParticeReplasement.h"

#include "hep/util/headers/QuarkMixMatrix.h"

#include "hep/diagrams/headers/DElementViewInfo.h"
#include "hep/diagrams/headers/DElement.h"
#include "hep/diagrams/headers/DiagramVertexInfo.h"
#include "hep/diagrams/headers/DVertex.h"
#include "hep/diagrams/headers/DLine.h"
#include "hep/diagrams/headers/DExtLine.h"
#include "hep/diagrams/headers/DIntLine.h"
#include "hep/diagrams/headers/DVPhoton.h"
#include "hep/diagrams/headers/DVFermion.h"

#include "hep/me/headers/MatrixElement.h"

#include "hep/diagrams/headers/DCorrRule.h"
#include "hep/diagrams/headers/DExtLineCorrRule.h"
#include "hep/diagrams/headers/DPropagatorCorrRule.h"
#include "hep/diagrams/headers/DVertexCorrRule.h"
#include "hep/diagrams/headers/DiagCorrRules.h"
#include "hep/diagrams/headers/DiagramPhysics.h"
#include "hep/diagrams/headers/SMPhysics.h"

#include "hep/diagrams/headers/FeynDiagram.h"
#include "hep/diagrams/headers/LDiagLocateView.h"
#include "hep/diagrams/headers/LDiagLocateOrdinary.h"
#include "hep/diagrams/headers/LDiagDrawingPrepare.h"// useless
#include "hep/diagrams/headers/DiagramSet.h"
#include "hep/diagrams/headers/LDrawDiagView.h"
#include "hep/diagrams/headers/LDiagArrange.h"

// old include
#include "hep/headers/FeynDiagramFactory.h"

#include "hep/lib/headers/VIDensData.h"
#include "hep/lib/headers/VirtIntegral.h"
#include "hep/lib/headers/VirtInt0.h"
#include "hep/lib/headers/VirtInt1.h"
#include "hep/lib/headers/VirtInt11.h"
#include "hep/lib/headers/VirtIntC.h"
#include "hep/lib/headers/VirtIntegralLib.h"
#include "hep/lib/headers/VIComposeLib.h"
#include "hep/lib/headers/VIScalarCalcLib.h"

#include "hep/particles/headers/EParticleFunction.h"
#include "hep/fields/headers/EFieldOperator.h"
#include "hep/fields/headers/OpBosonField.h"
#include "hep/fields/headers/OpFermionField.h"
#include "hep/waves/headers/ParticleWaveFunction.h"
#include "hep/waves/headers/WaveFuncBoson.h"
#include "hep/waves/headers/WaveFuncFermion.h"

#include "hep/lib/headers/MESeqFORoute.h"
#include "hep/lib/headers/MEOperatorSeq.h"
#include "hep/lib/headers/MEOpSeqLoopsLib.h"
#include "hep/lib/headers/MEComposeLib.h"
#include "hep/lib/headers/MELib.h"
#include "hep/lib/headers/MESquareLib.h"
#include "hep/lib/headers/AmplCalcLib.h"
#include "hep/lib/headers/LFermionSpinSum.h"
#include "hep/lib/headers/LFiertzTransform.h"
#include "hep/lib/headers/HEPLib.h"
#include "hep/lib/headers/LHEPBasics.h"
#include "hep/lib/headers/LDiagOpSeqRestore.h"
#include "hep/diagrams/headers/LDiagTopologyInspector.h"

#include "lib/simplify/headers/LFactor.h"
#include "lib/headers/SubstSimplify.h"
#include "lib/simplify/headers/ViewSimplify.h"
#include "lib/simplify/headers/LSimplifyMisc.h"

#include "hep/headers/AbstractHEPSession.h"
#include "hep/headers/TestCalculation.h"

#include "lib/files/headers/LFileManager.h"
#include "lib/files/headers/FFortran.h"
#include "lib/files/headers/CodeProcessImpl.h"

#include "hep/lib/headers/LHEPRunProject.h"

#include "lib/files/headers/ParserSymbolsList.h"
#include "lib/files/headers/AbstractFileParser.h"
#include "lib/files/headers/FileParserAdv.h"

#include "scripts/headers/ScriptValue.h"
#include "scripts/headers/ScriptObjectValue.h"
#include "scripts/headers/ScriptValueImpl.h"
#include "hep/diagrams/headers/ScriptValueDiagramSet.h"
#include "scripts/headers/ScriptException.h"
#include "scripts/headers/ScriptParser.h"
#include "scripts/headers/ScriptFuncInfo.h"
#include "scripts/headers/ScriptProcessor.h"
#include "scripts/headers/ScriptFunctionLib.h"
#include "scripts/headers/ScriptErrors.h"

#include "lib/headers/EMathEquRule.h"
#include "lib/files/headers/MathFileParser.h"
#include "hep/diagrams/headers/PhysModelFA.h"
#include "hep/diagrams/headers/SModelLoader.h"

#include "ESessionManager.h"


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__5E12FC48_0A58_11D5_8A94_E09F8D324901__INCLUDED_)
