////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
#ifdef ALHEP_WIN32
	//////////////////////////////// priority change
	//HANDLE alta_thread = GetCurrentThread();
	// THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_IDLE, THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_NORMAL
	BOOL prior_OK = SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_LOWEST);
	if (!prior_OK) printf("*** Warning: can't reduce process priority ***\n");
#endif //ALHEP_WIN32

	//int exit_code = CESessionManager::EXIT_WAIT_KEYHIT;
	CESessionManager* pManager = new CESessionManager();
	int exit_code = pManager->run(argc, argv);
	delete pManager;
	
	if (exit_code != 0) {
		if (exit_code == CESessionManager::EXIT_WAIT_KEYHIT) {
			// wait for key hit
			printf("(paused)\n");
			getchar();
		} else {
			printf("Error: unknown exit code: %ld", exit_code);
		}
	}
	return 0;
}
