////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EFactory.h: interface for the CEFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EFACTORY_H__9DB7A110_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_EFACTORY_H__9DB7A110_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MAX_EDATA_LENGTH	100000
#define MAX_ITEM_LENGTH		20

//##ModelId=3E3FF2CE01C5
class CEFactory : public CEObject  
{
private:
	//##ModelId=3E3FF2CE01CC
	char* m_data;
	//##ModelId=3E3FF2CE01C9
	CEFunctionProvider* m_fp;
public:
	//##ModelId=3E3FF2CE0229
	CEFactory();
	//##ModelId=3E3FF2CE0228
	virtual ~CEFactory();

	//##ModelId=3E3FF2CE0225
	CExpression* fromStream(istream* is, int mode = 0);
	//##ModelId=3E3FF2CE0222
	CExpression* fromFile(const char* filename, int mode = 0);

private:
	//##ModelId=3E3FF2CE021F
	char getSymbolAt(long pos);
	//##ModelId=3E3FF2CE021D
	long skipSpaces(long pos);
	//##ModelId=3E3FF2CE021A
	CExpression* getTensorExpression(long pos, long len);
	//##ModelId=3E3FF2CE0218
	long findNextParam(long pos);
	//##ModelId=3E3FF2CE0215
	char* copySubString(long pos, long len);
	//##ModelId=3E3FF2CE020F
	CExpression* getFunctionExpression(long pos, long len);
	//##ModelId=3E3FF2CE020B
	//long readLine(CFile* pfile, char* buf, char end = '\0');
	long readLine(void* pfile, char* buf, char end = '\0');
	//##ModelId=3E3FF2CE0209
	CExpression* parseMathematicaLine(long pos = 0);
	//##ModelId=3E3FF2CE0206
	CExpression* parseMathematicaSubLine(long pos, int type = 0);
	//##ModelId=3E3FF2CE0204
	CExpression* getSimpleExpression(long pos);

	//##ModelId=3E3FF2CE0201
	long findEndPos(long pos);
	//##ModelId=3E3FF2CE01FF
	long findNextAddItem(long pos);
	//##ModelId=3E3FF2CE01FD
	long findNextProdItem(long pos);
	//long findNextPos(long pos, char sym);
	//##ModelId=3E3FF2CE01F9
	long findNextPos(long pos, char sym, bool skip_brackets = false);
	//long findNextSpecPos(long pos, char sym);
	//##ModelId=3E3FF2CE01F5
	long findNextSpecPos(long pos, char sym, bool skip_brackets = false);
	//##ModelId=3E3FF2CE01F0
	long findNextItem(long pos);
	//##ModelId=3E3FF2CE01EE
	long findItem(long pos);
	//##ModelId=3E3FF2CE01EC
	bool getSign(long pos);
	//##ModelId=3E3FF2CE01EA
	bool getLevel(long pos);

	//##ModelId=3E3FF2CE01E8
	long skipBracket(long pos);
	//##ModelId=3E3FF2CE01E6
	long findBracketEnd(long pos);
	//##ModelId=3E3FF2CE01E4
	long findEndPosX1(long pos);
	//##ModelId=3E3FF2CE01DF
	long findEndPosX2(long pos, int type = 0);
	//##ModelId=3E3FF2CE01DC
	long findEndPosX3(long pos, int type = 0);
	//##ModelId=3E3FF2CE01DA
	long findPower(long pos);
	//##ModelId=3E3FF2CE01D8
	long findItemEnd(long pos);

	//##ModelId=3E3FF2CE01D5
	long lmin(long l1, long l2);
	//##ModelId=3E3FF2CE01CD
	long lmax(long l1, long l2);
};

#endif // !defined(AFX_EFACTORY_H__9DB7A110_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
