////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EObject.cpp: implementation of the CEObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include <typeinfo.h>
//#include <iostream.h>
//#include <fstream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define	LOG_FILE	"log.txt"

const int CEObject::KIND_UNDEFINED	= 0x00;
const int CEObject::KIND_EXPRESSION	= 0x01;
const int CEObject::KIND_STRING		= 0x02;

CEObject::CEObject(bool do_watch)
{
#if defined(ALTA_DEBUG)
	m_memory_watch = NULL;
	m_memory_managed = do_watch;
	if (m_memory_managed) {
		bool watch_accepted = CMemoryManager::add_watch(this);
		if (!watch_accepted) m_memory_managed = false;
	}
#else
	//m_memory_managed = false;
#endif //ALTA_DEBUG
}

CEObject::~CEObject()
{
#if defined(ALTA_DEBUG)
	if (m_memory_managed) CMemoryManager::exclude_watch(this);
#endif //ALTA_DEBUG
}

void CEObject::log(const char *message, int level)
{
	if(level<=dbg_level)
	{
		//printf(typeid(*this).name());
		//printf(message);
		//printf("\n");
		//logfile.
		/*ofstream ofs(LOG_FILE, ios::out|ios::ate);
		if (ofs) {
			//ofs << "< ";
			//ofs << ClassName();
			//ofs << "> ";
			ofs << message;
			ofs << "\n";
			ofs.close();
		}*/
	}
}

void CEObject::log(CEObject* obj, int level)
{
	/*if (obj != NULL) {
		char* s = obj->toLine(STORE_WR_MATHEMATICA);
		log(s, level);
		delete s;
	}
	else log("<NULL>", level);*/
}

char* CEObject::toLine(int mode) {
	const char* cn = ClassName(); if (cn==NULL) cn="NULL";
	char* res = (char*)CMemoryManager::mmalloc(15+CEUtil::length(cn));
	sprintf(res, "<Class: %s>",cn);
	return res;
}

const char* CEObject::ClassName() const { return "<pure CEObject or undefined>"; }

bool CEObject::contain_vector(void * obj)
{
	return false;
}

CEObject* CEObject::copy() const {
	//Warning: attempt to copy unserializable object.
	const char* cn = ClassName(); if (cn==NULL) cn="NULL";
	CEBasic::dbg->log(0, "ERROR: attempt to copy non-serializable object: ", cn);
	CEException::halt("ERROR: attempt to copy non-serializable object");
	return NULL;
}

bool CEObject::obj_equals(CEObject* other) { return (other == this); }

int CEObject::GetObjectKind() { return KIND_UNDEFINED; }
