////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EObject.h: interface for the CEObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EOBJECT_H__9DB7A100_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_EOBJECT_H__9DB7A100_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define dbg_level   10

//##ModelId=3E3FF2D70157
class CEObject
{
#if defined(ALTA_DEBUG)
private:
	bool m_memory_managed;
public:
	CEObject* m_memory_watch;
#endif //ALTA_DEBUG

public:

	static const int KIND_UNDEFINED;
	static const int KIND_EXPRESSION;
	static const int KIND_STRING;
    //static CFile logfile(LOG_FILE, CFile::modeWrite);
    //logfile.Close();

public:
	virtual int GetObjectKind();
	virtual bool contain_vector(void * obj);
    virtual const char* ClassName() const;
    static void log(CEObject* obj, int level = 4);
    //void log(CEObject* obj, int level = 4);
    static void log(const char* message, int level = 4);
    //void log(char* message, int level = 4);

    CEObject(bool do_watch = false);
    virtual ~CEObject();
    virtual char* toLine(int mode = 0);

	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
};

/*CDebug* operator << (CDebug* dbg, CEObject* obj) {
	dbg << obj->toLine(STORE_WR_MATHEMATICA);
	return dbg;
}

CDebug* operator << (CDebug* dbg, const char* message) {
	dbg.out(message, 1);
	return dbg;
}

CDebug* operator << (CDebug* dbg, long val) {
	char* str = (char*)CMemoryManager::mmalloc(10);
	sprintf(str, "%ld", val);
	dbg << str;
	return dbg;
}*/

#endif // !defined(AFX_EOBJECT_H__9DB7A100_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
