////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EProperties.h: interface for the CEProperties class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EPROPERTIES_H__9DB7A107_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_EPROPERTIES_H__9DB7A107_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "EObject.h"

//##ModelId=3E3FF2CD0128
class CEProperties : public CEObject  
{
private:
	//##ModelId=3E3FF2CD0179
	unsigned m_defined_props;
	//##ModelId=3E3FF2CD016E
	unsigned m_props;
	//bool m_isSingleItem;
public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;

	static void SetPropertyTo(unsigned long& lProps, unsigned long fPropMask) { lProps|=fPropMask; }
	static void SetPropertyTo(unsigned long& lProps, unsigned long fPropMask, bool val) { lProps|=fPropMask; if(!val)lProps^=fPropMask; }
	//TODO: move from 'set_property_to' to 'SetPropertyTo'
	static unsigned long set_property_to(unsigned long lprops, unsigned long prop_mask, bool val);
	//##ModelId=3E3FF2CD0169
	static const unsigned PROP_MASK_FIRST;
	//##ModelId=3E3FF2CD0161
	static const unsigned PROP_MASK_IS_SUM;
	//##ModelId=3E3FF2CD015C
	static const unsigned PROP_MASK_IS_PRODUCT;
	//##ModelId=3E3FF2CD0157
	static const unsigned PROP_MASK_COMMUTATIVE;
	//##ModelId=3E3FF2CD014F
	static const unsigned PROP_MASK_SINGLE_ITEM;
	//##ModelId=3E3FF2CD014A
	static const unsigned PROP_MASK_IS_TENSOR;
	//##ModelId=3E3FF2CD0144
	static const unsigned PROP_MASK_IS_SPINOR;
	//##ModelId=3E3FF2CD013F
	static const unsigned PROP_MASK_IS_VIRT_INTEGRAL;
	static const unsigned PROP_MASK_IS_FUNCTION;
	//##ModelId=3E3FF2CD013A
	static const unsigned PROP_MASK_IS_NUMBER;
	static const unsigned PROP_MASK_SELF_CONJUGATED;
	//##ModelId=3E3FF2CD0131
	static const unsigned PROP_MASK_IS_NUMERIC_VALUE;
	static const unsigned PROP_MASK_IS_FIELD_OPERATOR;
	static const unsigned PROP_MASK_IS_WAVE_FUNCTION;
	static const unsigned PROP_MASK_IS_PARTICLE_FUNCTION;
	//##ModelId=3E3FF2CD012C
	static const unsigned PROP_MASK_ALL;
	//##ModelId=3E3FF2CD01E4
	virtual unsigned data();
	//##ModelId=3E3FF2CD01D9
	virtual bool equals(CEProperties* other);
	//##ModelId=3E3FF2CD01D8
	bool isNumber();
	//##ModelId=3E3FF2CD01D7
	bool isProduct();
	//##ModelId=3E3FF2CD01D6
	bool isSum();
	//##ModelId=3E3FF2CD01D5
	CEProperties();
	//##ModelId=3E3FF2CD01D4
	virtual ~CEProperties();

	//##ModelId=3E3FF2CD01CA
	bool isSingleItem();
	//##ModelId=3E3FF2CD01C9
	bool isCommutative();
	//##ModelId=3E3FF2CD01C8
	bool isTensor();
	//##ModelId=3E3FF2CD01C7
	bool isSpinor();

	//##ModelId=3E3FF2CD01C5
	bool getProperty(unsigned prop_mask);
	
	//##ModelId=3E3FF2CD01B5
	bool setSingleItem(bool single = true);
	//##ModelId=3E3FF2CD01A7
	bool setCommutative(bool commutative = true);
	//##ModelId=3E3FF2CD01A5
	bool setTensor(bool is_tensor = true);
	//##ModelId=3E3FF2CD0196
	bool setSpinor(bool is_spinor = true);

	//##ModelId=3E3FF2CD0186
	bool setProperty(unsigned prop_mask, bool value = true);
private:
	//##ModelId=3E3FF2CD017C
	void undefinedPropertyRequest(unsigned props);
};

#endif // !defined(AFX_EPROPERTIES_H__9DB7A107_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
