////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EReplList.h: interface for the CEReplList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EREPLLIST_H__9DB7A106_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_EREPLLIST_H__9DB7A106_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEReplList : public CERulesList  
{
	CEReplList(const CEPtrArray* _rules_list);
public:
	virtual CEString* toString(int mode = 0);
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CERule* GetRuleCopy() const;

	virtual CERule* combine_with(CERule* other);

	void add(CEReplasement* new_repl);
	void add(const CExpression* a, const CExpression* b, bool do_exchange = false);

	bool exchange(int i = 0);
	CExpression* getb(int i = 0);
	CExpression* geta(int i = 0);
	CEReplasement* get(int i = 0);

	int size();
	CEReplList();
	CEReplList(const CExpression* a, const CExpression* b, bool do_exchange = false);
	virtual ~CEReplList();
};

#endif // !defined(AFX_EREPLLIST_H__9DB7A106_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
