////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERule.cpp: implementation of the CERule class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

const int CERule::RULE_ABSTRACT	= 0x00;
const int CERule::RULE_COMPOUND	= 0x01;

CDebug* CERule::dbg = new CDebug("CERule");
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CERule::CERule() : CEAbstractRule()
{

}

CERule::~CERule()
{

}

CEObject* CERule::copy() const { return GetRuleCopy(); }

const char* CERule::ClassName() const
{
	return "CERule";
}

int CERule::GetRuleKind()
{
	return RULE_ABSTRACT;
}

CERule* CERule::combine_with(CERule* other) {
	if (other == NULL) return this;
	CERulesList* r_list = new CERulesList();
	r_list->addRule(this);
	r_list->addRule(other);
	return r_list;
}

void CERule::ResetTimesApplied() {}
DWORD CERule::GetTimesApplied() { return 0; }
