////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERule.h: interface for the CERule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERULE_H__9DB7A105_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_ERULE_H__9DB7A105_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DA036B
class CERule : public CEAbstractRule
{
public:
	static const int RULE_ABSTRACT;
	static const int RULE_COMPOUND;
	
	static CDebug* dbg;

	virtual int GetRuleKind();
	virtual CERule* combine_with(CERule* other);

	//##ModelId=3E3FF2DA0370
	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true) =0;
	//##ModelId=3E3FF2DA036F
	virtual const char* ClassName() const;
	//##ModelId=3E3FF2DA036E
	CERule();
	//##ModelId=3E3FF2DA036D
	virtual ~CERule();

	virtual CEObject* copy() const;
	virtual CERule* GetRuleCopy() const = 0;

	virtual void ResetTimesApplied();
	virtual DWORD GetTimesApplied();
};

#endif // !defined(AFX_ERULE_H__9DB7A105_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
