////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESum.h: interface for the CESum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESUM_H__9DB7A10C_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
#define AFX_ESUM_H__9DB7A10C_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D300DA
class CESum : public CSequence
{
private:
	bool arrangeFactorsAdv();
	bool arrangeFactors2();
	static bool BasesEquals(CExpression* a, CExpression* b);
	static bool BasesLessThan(CExpression* a, CExpression* b);
	static CENumber* exprGetFactor(CExpression* a); // returns cloned result
	static CExpression* exprGetBase(CExpression* a); // returns cloned result
	long expandElement(long num);
public:
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);
	static const char*	CLASS_NAME;
	static const char*	CLASS_TAG_NAME;

	virtual CExpression* add(CExpression* other);
	//virtual void SetAt(long i, CExpression* _new);
	//virtual void SetAtX(long i, CExpression* _new_X);
	virtual CExpression* Im();
	virtual CExpression* Re();
	virtual bool equals(CExpression* other);
	virtual unsigned long props_long();
	CESum* get_n_items(long n);
	virtual CExpression* numeric();
	static CDebug* dbg;
	virtual CExpression* arrangeTensors();
	virtual CExpression* conjugated(int mode = 0);
	virtual CExpression* clone() const;
	virtual CExpression* expand(bool recursive = true);
	virtual const char* ClassName() const;

#ifdef USE_PLAIN_ARRAY_FORSEQ // biuld sequence-expressions on CAPtrArray* basis
	CESum(CEPtrArray* pPtrArray);
#else
	CESum(CAPtrSeq* pPtrArray);
#endif //USE_PLAIN_ARRAY_FORSEQ
	
	CESum();
	virtual ~CESum();

	virtual CExpression* applyRule(CEAbstractRule* rule);
	virtual CExpression* evaluate(int level = 0);
	virtual CExpression* Simplify(int level = 0);
	virtual CExpression* Arrange(int level);
	virtual CEString* toString(int mode = 0);
	virtual void toStream(ostream* os, int mode = 0);

protected:
	bool arrangeSign();
	virtual bool arrangeFactors();
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_ESUM_H__9DB7A10C_0AA0_11D5_8A94_932004EF1C0E__INCLUDED_)
