////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EValue.cpp: implementation of the CEValue class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

const DWORD CEValue::VTYPE_REAL		= 0x01;
const DWORD CEValue::VTYPE_COMPLEX	= 0x02;

CDebug* CEValue::dbg = new CDebug("CEValue");

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CEValue::CEValue():CExpression()
{
}

CEValue::~CEValue()
{
}

CExpression* CEValue::numeric()
{
	dbg->log(0, "Error: CEValue::numeric() not expected");
	//Warning: this should not occur.
	return NULL;
}

void CEValue::collectProperties(CEProperties *props, unsigned int set)
{
	//CExpression::collectProperties(props, set);
	props->setProperty(CEProperties::PROP_MASK_IS_NUMERIC_VALUE, true);
}

unsigned long CEValue::props_long()
{
	unsigned long res = CExpression::props_long();
	res = CEProperties::set_property_to(res,
		CEProperties::PROP_MASK_IS_NUMERIC_VALUE, true);
	return res;
}

CExpression* CEValue::Arrange(int level)
{
	return this;
}

CEString* CEValue::toString(int mode)
{
	CEString* res = new CEString("<Abstract value>");
	return res;
}

CEValue* CEValue::Sqrt(CEValue * var, bool do_delete)
{
	if (var == NULL) return NULL;
	CEValue* res = var->Sqrtx(!do_delete);
	return res;
}

CEValue* CEValue::Abs(CEValue * var, bool do_delete)
{
	if (var == NULL) return NULL;
	return var->Absx(!do_delete);
}

DWORD CEValue::get_val_type()
{
	return 0;
}
