////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// Const.h: interface for the CConst class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONST_H__5737D1A0_D57A_11D5_8A94_A0E94C126417__INCLUDED_)
#define AFX_CONST_H__5737D1A0_D57A_11D5_8A94_A0E94C126417__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2C803BD
class CConst : public CEObject  
{
public:
	//##ModelId=3E3FF2C803DF
	static const char* DN_NUM_VALUES;
	//##ModelId=3E3FF2C803DE
	static const char* DN_VECTORS;
	//##ModelId=3E3FF2C803DD
	static const char* DN_GREEK_LETTERS;
	//##ModelId=3E3FF2C803DC
	static const char* DNV_SQUARE;
	//##ModelId=3E3FF2C803DB
	static const char* DNV_MODULE;
	//##ModelId=3E3FF2C803DA
	static const char* DNV_SYMBOL;
	//##ModelId=3E3FF2C803D9
	static const char DN_DOT;

	//##ModelId=3E3FF2C803D8
	static const char* DV_ZERO;
	//##ModelId=3E3FF2C803D3
	static const char* DV_UNIT;
	//##ModelId=3E3FF2C803D2
	static const char* DV_TWO;
	//##ModelId=3E3FF2C803D1
	static const char* DV_IMAGINARY;
	//##ModelId=3E3FF2C803D0
	static const char* DV_HALF;
	//##ModelId=3E3FF2C803CF
	static const char* DV_GAMMA5;
	static const char* DV_GAMMA_P;
	static const char* DV_GAMMA_M;

	//##ModelId=3E3FF2C803CE
	static const char* DS_METRIC_BASE;
	//##ModelId=3E3FF2C803CD
	static const char* DS_ANTISYMMETRIC_BASE;
	//##ModelId=3E3FF2C803CC
	static const char* DS_SPACE;
	//##ModelId=3E3FF2C803CB
	static const char* DS_GAMMA_SPECIAL_BASE;

	//##ModelId=3E3FF2C803CA
	static const char* GL_ALPHA;
	//##ModelId=3E3FF2C803C9
	static const char* GL_BETA;
	//##ModelId=3E3FF2C803C8
	static const char* GL_GAMMA;
	//##ModelId=3E3FF2C803C6
	static const char* GL_DELTA;
	//##ModelId=3E3FF2C803C5
	static const char* GL_SIGMA;
	//##ModelId=3E3FF2C803C4
	static const char* GL_LAMBDA;
	//##ModelId=3E3FF2C803C3
	static const char* GL_OMEGA;
	//##ModelId=3E3FF2C803C2
	static const char* GL_ETA;
	//##ModelId=3E3FF2C803C1
	static const char* GL_CHI;
	//##ModelId=3E3FF2C803C0
	static const char* GL_PSI;
	//##ModelId=3E3FF2C803BF
	static const char* GL_PHI;
	static const char* GL_PI;

	//////////////////////////////////////////////////////////// Credits
	static const char* EXPR_CORE_TITLE;
	static const char* EXPR_CORE_TITLE_SHORT;
	static const char* EXPR_CORE_BUILD_DATE;
	static const char* EXPR_LOGO_TEXT1;
	static const char* EXPR_LOGO_TEXT2;
	static const char* EXPR_LOGO_TEXT3;
	static const char* EXPR_LOGO_TEXT3b;
	static const char* EXPR_LOGO_TEXT4;
	static const char* EXPR_LOGO_TEXT5;
	static const char* EXPR_LOGO_TEXT_EMPTY;
	static const char* EXPR_AUTHOR_CONTACT;

	static const unsigned EXPR_VERSION_ID;
	static const unsigned EXPR_VERSION_MAJOR;
	static const unsigned EXPR_VERSION_MINOR;
	static const unsigned EXPR_VERSION_BUILD;
	//Note: use 'CESupport::CreateVersionString()' to obtain version string

	// interfaces
	static const long dwIETensor;

	//##ModelId=3E3FF2C803E1
	CConst();
	//##ModelId=3E3FF2C803E0
	virtual ~CConst();

public:
	static const char* GetValidSymMSubst(const char* s, int l=-1); // NULL if unchanged, l>=0 for non-NULL-terminated strings
	static const char* GetValidSymTexSubst(const char* s, int l=-1); // NULL if unchanged, l>=0 for non-NULL-terminated strings
};

#endif // !defined(AFX_CONST_H__5737D1A0_D57A_11D5_8A94_A0E94C126417__INCLUDED_)
