////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EData.h: interface for the CEData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDATA_H__6EDE5257_BAF6_4E99_B5AB_1AF2114AA28A__INCLUDED_)
#define AFX_EDATA_H__6EDE5257_BAF6_4E99_B5AB_1AF2114AA28A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D903A9
class CEData : public CEMap  
{
	//##ModelId=3E3FF2D903BB
public:
	static CDebug* dbg;

	CEMap* get_node(const char* node);
	void pute_to_node(const char* node, CExpression* item, CExpression* val, bool delete_item = false);
	//##ModelId=3E3FF2DA0014
	CEObject* next();
	//##ModelId=3E3FF2DA0013
	void reset_iterator();
	//##ModelId=3E3FF2DA0012
	bool has_next();
	//##ModelId=3E3FF2DA0010
	void store_node(const char* node_id = NULL);
	//##ModelId=3E3FF2DA0007
	void putvalue(CExpression* item, CExpression* val, bool delete_item = false);
	//##ModelId=3E3FF2DA0005
	virtual CExpression* getvalue(CExpression* item);
	//##ModelId=3E3FF2DA0003
	virtual bool contain_vector(void * obj);
	//##ModelId=3E3FF2D903E1
	virtual void putv(const char *id, const char *param, CExpression *expr);
	//##ModelId=3E3FF2D903DF
	virtual CExpression* getvmod(const char *id);
	//##ModelId=3E3FF2D903DD
	virtual CExpression* getvsqr(const char* id);
	//##ModelId=3E3FF2D903DA
	virtual CExpression* getv(const char* id, const char* param = CConst::DNV_SYMBOL);
	//##ModelId=3E3FF2D903D8
	virtual char* toLine(int mode = 0);
	virtual CEString* toString(int mode = 0);
	//##ModelId=3E3FF2D903CE
	virtual void pute(const char* id, CExpression* expr);
	//##ModelId=3E3FF2D903CC
	virtual CExpression* gete(const char* id);
	//##ModelId=3E3FF2D903CB
	CEData();
	//##ModelId=3E3FF2D903CA
	virtual ~CEData();
	
	//##ModelId=3E3FF2D903C9
	virtual long size();
	//##ModelId=3E3FF2D903C0
	virtual void put(const char* id, CEObject* o);
	//##ModelId=3E3FF2D903BE
	virtual CEObject* get(const char* id);

	virtual void put_int(char* id, long _val, bool do_copy_id = true);
	virtual long get_int(const char* id);
	virtual void put_ptr(const char* id, void* _p);
	virtual void* get_ptr(const char* id);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
private:
	//##ModelId=3E3FF2D903AD
	CEDataNode* m_data;
};

#endif // !defined(AFX_EDATA_H__6EDE5257_BAF6_4E99_B5AB_1AF2114AA28A__INCLUDED_)
