////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EDataNodeImpl.h: interface for the CEDataNodeImpl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDATANODEIMPL_H__35F12EE3_CEEC_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EDATANODEIMPL_H__35F12EE3_CEEC_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D602BF
class CEDataNodeImpl : public CEDataNode  
{
public:
	//##ModelId=3E3FF2D602EE
	bool has_next();
	//##ModelId=3E3FF2D602E8
	void reset_iterator();
	//##ModelId=3E3FF2D602E7
	CEObject* next();
	//##ModelId=3E3FF2D602E5
	virtual bool contain_vector(void * obj);
	//##ModelId=3E3FF2D602E3
	virtual char* toLine(int mode = 0);
	virtual CEString* toString(int mode = 0);
	//##ModelId=3E3FF2D602E1
	virtual CEDataNode* getFinalNode(const char* id);
	//##ModelId=3E3FF2D602E0
	virtual long size();
	//##ModelId=3E3FF2D602D8
	virtual void put(const char* id, CEObject* o);  // object is deleted
	//##ModelId=3E3FF2D602D6
	virtual CEObject* get(const char* id);
	//##ModelId=3E3FF2D602D5
	CEDataNodeImpl();
	//##ModelId=3E3FF2D602D4
	virtual ~CEDataNodeImpl();

	virtual void put_int(char* id, long _val, bool do_copy_id = true);
	virtual long get_int(const char* id);
	virtual void put_ptr(const char* id, void* _p);
	virtual void* get_ptr(const char* id);

private:
	//##ModelId=3E3FF2D602D1
	CEMap* m_data;
};

#endif // !defined(AFX_EDATANODEIMPL_H__35F12EE3_CEEC_11D5_90CB_00403393DD18__INCLUDED_)
