////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EException.cpp: implementation of the CEException class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

const char* CEException::INT_ERROR	= "Internal Error";
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEException::CEException() : CEObject(true) { m_msg=NULL; m_error_break=true; m_file_name=NULL; m_line_number=-1; }
CEException::~CEException() { if(m_msg!=NULL){ delete m_msg; m_msg=NULL; } }
CEException::CEException(const char* _message, bool _error_break) : CEObject(true) {
	if (_message != NULL) m_msg=new CEString(_message); else { m_msg=NULL; }
	m_error_break = _error_break;
	m_file_name=NULL; m_line_number=-1;
}

const char* CEException::CLASS_NAME = "CEException";
const char* CEException::ClassName() const { return CLASS_NAME; }
bool CEException::contain_vector(void * obj) {
	if (m_msg == obj) return true;
	return false;
}

CEString* CEException::getMessage() { return m_msg; }
int CEException::getErrCode() { return 0; }
bool CEException::isErrorBreak() { return m_error_break; }

const char* CEException::getFileName() { return m_file_name; }
long CEException::getLineNumber() { return m_line_number; }

// throw undefined internal error
void CEException::halt() { halt(CEException::INT_ERROR); }

void CEException::halt(const char* _msg) {
	std::cout<<"CEException::halt(<<"<<_msg<<")"<<std::endl;
	if(_msg==NULL)_msg="NULL message";
	throw(new CEException(_msg));
	//throw(CEException(_msg));
}

void CEException::halt(const char* _msg, const char* _file_name, long _line_num) {
	if (_msg==NULL) _msg="";//"Unknown exception"; //No message
	CEException* exc=new CEException(_msg);
	exc->m_file_name=_file_name; exc->m_line_number=_line_num;
	throw(exc);
}

void CEException::halt(CDebug* dbg, const char* _msg) {
	if (_msg == NULL) _msg = CEException::INT_ERROR;
	if (dbg != NULL) { dbg->log(0, _msg); }
	halt(_msg);
}
