////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EException.h: interface for the CEException class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EEXCEPTION_H__3FAEFCD5_2C83_43FC_AACE_5EE913750330__INCLUDED_)
#define AFX_EEXCEPTION_H__3FAEFCD5_2C83_43FC_AACE_5EE913750330__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEException : public CEObject  
{
protected:
	CEString* m_msg;
	const char* m_file_name;
	long m_line_number;
	bool m_error_break;
	CEException();
public:
	static const char* INT_ERROR;

	virtual CEString* getMessage();
	virtual int getErrCode();
	CEException(const char* _message, bool _error_break = true);
	virtual ~CEException();
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	const char* getFileName();
	long getLineNumber();
	
	static void halt(); // throw undefined internal error
	static void halt(const char* _msg);
	static void halt(const char* _msg, const char* _file_name, long _line_num);
	static void halt(CDebug* dbg, const char* _msg = NULL);
	virtual bool isErrorBreak();
};

#endif // !defined(AFX_EEXCEPTION_H__3FAEFCD5_2C83_43FC_AACE_5EE913750330__INCLUDED_)
