////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// FLogN.h: interface for the CFLogN class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FLOGN_H__763F20E4_0FB1_410E_B114_66EE4E96F4BC__INCLUDED_)
#define AFX_FLOGN_H__763F20E4_0FB1_410E_B114_66EE4E96F4BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFLogN : public CEAbstractFunction  
{
public:
	static CDebug* dbg;

	CFLogN(const CExpression* _value);
	virtual ~CFLogN();

	virtual CEString* getTitleAdv(unsigned conventions, int mode);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CExpression* clone() const;
	virtual CExpression* evaluate(int level = 0);
	virtual CExpression* Arrange(int level);
	virtual CExpression* applyRule(CEAbstractRule* rule); // no src->0 replacement are allowed

	static const char* CLASS_TAG_NAME;
	virtual const char* get_TAG_Name();
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);
};

#endif // !defined(AFX_FLOGN_H__763F20E4_0FB1_410E_B114_66EE4E96F4BC__INCLUDED_)
