////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// IETensor.h: interface for the IETensor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IETENSOR_H__45D8D72B_EAF2_4C8E_99C5_215DA98E3718__INCLUDED_)
#define AFX_IETENSOR_H__45D8D72B_EAF2_4C8E_99C5_215DA98E3718__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class IETensor
{
public:
	// IETensor interface <BEGIN>
	virtual CExpression* ThisExpr()						=0; // returns this as (CExpression*)
	//virtual IETensor* ThisITensor()					=0; // returns this as (IETensor*)
	virtual CExpression* base()							=0;
	virtual const CExpression* GetBase() const			=0;
	virtual bool setBase(CExpression* _new)				=0;
	virtual int rank() const							=0;
	virtual CExpression* index(int i)					=0; // 1..rank
	virtual const CExpression* GetIndex(int i) const	=0; // 1..rank
	virtual CTIndex* GetTIndex(int i)					=0;	// 1..rank
	virtual const CTIndex* GetTIndexConst(int i) const	=0; // 1..rank
	virtual bool covariance(int i) const				=0;
	virtual bool changeIndex(int i, CExpression* index, bool covariance)	=0;
	virtual bool liftIndex(int i, bool to_covariance)						=0;
	virtual bool setIndex(int i, CExpression* index)						=0;
	virtual CExpression* exchange_subst(IETensor* other, bool other_is_at_right, bool bCalledByOther=false)	=0;
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false)	=0;
	// IETensor interface <END>

	static IETensor* GetIETensor(CExpression* expr); // if (temp->getProperty(CEProperties::PROP_MASK_IS_TENSOR))
};

#endif // !defined(AFX_IETENSOR_H__45D8D72B_EAF2_4C8E_99C5_215DA98E3718__INCLUDED_)
