////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERank3Tensor.cpp: implementation of the CERank3Tensor class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CERank3Tensor::CERank3Tensor(const CExpression* _base,
							 const CExpression* index1, bool covariance1,
							 const CExpression* index2, bool covariance2,
							 const CExpression* index3, bool covariance3)
							 : CETensor(_base)
{
	m_indices->add(CTIndex::CreateVectorIndex(index1, covariance1));
	m_indices->add(CTIndex::CreateVectorIndex(index2, covariance2));
	m_indices->add(CTIndex::CreateVectorIndex(index3, covariance3));
}

CERank3Tensor::~CERank3Tensor() {}

const char* CERank3Tensor::CLASS_NAME = "CERank3Tensor";
const char* CERank3Tensor::ClassName() const { return CLASS_NAME; }

CExpression* CERank3Tensor::clone() const {
	CExpression* res = new CERank3Tensor(GetBase(),
		GetIndex(1), covariance(1),
		GetIndex(2), covariance(2),
		GetIndex(3), covariance(3));
	copyAttributesTo(res);
	return res;
}
