////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EScalar.cpp: implementation of the CEScalar class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEScalar::CEScalar() :CETensor(NULL) // old: gete(CConst::DS_SPACE) in data-storage
{

}

CEScalar::CEScalar(const CExpression* base):CETensor(base)
{
}

CEScalar::~CEScalar()
{

}

void CEScalar::collectProperties(CEProperties* props, unsigned set) {
	//props->setTensor(false);
	props->setCommutative();
}

/*
* do not calls CETensor::props_long();
* and have no ..._IS_TENSOR property.
*/
unsigned long CEScalar::props_long()
{
	unsigned long res = CExpression::props_long();
	res = CEProperties::set_property_to(res,
		CEProperties::PROP_MASK_COMMUTATIVE, true);
	return res;
}
