////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EAntiSymmProd.h: interface for the CEAntiSymmProd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EANTISYMMPROD_H__A6A2B602_8A60_475D_850D_FA42C1DC728A__INCLUDED_)
#define AFX_EANTISYMMPROD_H__A6A2B602_8A60_475D_850D_FA42C1DC728A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEAntiSymmProd : public CEScalar  
{
protected:
	CExpression* m_v[4];

public:
	virtual CExpression* numeric();

	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static const char* CLASS_TAG_NAME;
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;

	CExpression* get_v(int i);

	virtual bool equals(CExpression* other);
	virtual bool less_than(CExpression* other);
	virtual CExpression* expand(bool recursive = true);
	virtual bool contain_vector(void * obj);
	virtual CExpression* Arrange(int level);
	virtual CExpression* applyRule(CEAbstractRule* rule);
	virtual CExpression* clone() const;
	virtual CEString* toString(int mode = 0);

public:
	CEAntiSymmProd(const CExpression* v1, const CExpression* v2, const CExpression* v3, const CExpression* v4);
	virtual ~CEAntiSymmProd();

public:
	static bool InvolveAsymmProd(CExpression* src); // works inline, true if changed
private:
	static bool InvolveAsymmProdImpl(CESum* src);  // works inline, true if changed
	static bool InvolveAsymmProdImpl(CEProduct* src);  // works inline, true if changed

protected:
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
public:
	virtual unsigned long props_long();
};

#endif // !defined(AFX_EANTISYMMPROD_H__A6A2B602_8A60_475D_850D_FA42C1DC728A__INCLUDED_)
