////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EAntisymmetric.h: interface for the CEAntisymmetric class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EANTISYMMETRIC_H__F374EF4E_CFB8_4B33_92F4_2B3D57ADE360__INCLUDED_)
#define AFX_EANTISYMMETRIC_H__F374EF4E_CFB8_4B33_92F4_2B3D57ADE360__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D5005D
class CEAntisymmetric : public CETensor  
{
public:
	static CExpression* m_AntisymmetricBase;
	static const CExpression* GetAntisymmetricBase();

public:
	virtual CExpression* Arrange(int level);
	static bool parse_product_for_zero(CEProduct* seq);
	static bool parse_product_for_zero(CEProduct* seq, CEAntisymmetric* asym);
	//##ModelId=3E3FF2D5007D
	virtual CExpression* clone() const;
	//##ModelId=3E3FF2D5007A
	void move_index(int from_pos, int dest_pos = 1);
	//##ModelId=3E3FF2D50079
	virtual const char* ClassName() const;
	//##ModelId=3E3FF2D5005F
	static const char* CLASS_NAME;
	
	//##ModelId=3E3FF2D50076
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	//##ModelId=3E3FF2D5006D
	CEAntisymmetric(const CExpression* index1, bool covariance1,
		const CExpression* index2, bool covariance2,
		const CExpression* index3, bool covariance3,
		const CExpression* index4, bool covariance4);
	//##ModelId=3E3FF2D50064
	virtual ~CEAntisymmetric();

	virtual bool less_than(CExpression* other);

	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static const char* CLASS_TAG_NAME;
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

protected:
	//##ModelId=3E3FF2D50062
	CExpression* unite_formula(CEAntisymmetric* other);
	//##ModelId=3E3FF2D50060
	CExpression* unite(CEAntisymmetric* other);
};

#endif // !defined(AFX_EANTISYMMETRIC_H__F374EF4E_CFB8_4B33_92F4_2B3D57ADE360__INCLUDED_)
