////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EGamma.h: interface for the CEGamma class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EGAMMA_H__BF8FC206_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EGAMMA_H__BF8FC206_C3EE_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DD0399
class CEGamma : public CEVector  
{
public:
	static CExpression* m_SymGamma;
	static const CExpression* GetBaseSymGamma(); // returns constant ref, but never NULL

public:
	virtual unsigned long props_long();
	virtual CExpression* exchange_subst(IETensor* other, bool other_is_at_right, bool bCalledByOther=false);
	static const char* CLASS_NAME;
	virtual CExpression* unite_with(IETensor *other, bool other_is_at_right=true, bool bCalledByOther=false);
	virtual CExpression* clone() const;
	virtual const char* ClassName() const;
	CEGamma(const CExpression* index, bool covariance);
	virtual ~CEGamma();

protected:
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_EGAMMA_H__BF8FC206_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
