////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EGammaSpecial.h: interface for the CEGammaSpecial class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EGAMMASPECIAL_H__E607BAA0_030E_11D6_8A94_936FB66AA46C__INCLUDED_)
#define AFX_EGAMMASPECIAL_H__E607BAA0_030E_11D6_8A94_936FB66AA46C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEGammaSpecial : public CEScalar  
{
	int m_value; // 0 for gamma_{5}, 1 for gamma_{+} and -1 for gamma_{-}

	void setGammaValue(int _value); // note: this function should not be public
	void inverseGammaValue(); // note: this function should not be public
public:
	int getGammaValue();

	virtual unsigned long props_long();
	virtual CExpression* exchange_subst(IETensor* other, bool other_is_at_right, bool bCalledByOther=false);
	virtual bool equals(CExpression* other);
	virtual bool less_than(CExpression* other);
	virtual CExpression* clone() const;
	static const char* CLASS_NAME;

	CEGammaSpecial(int _value);
	virtual ~CEGammaSpecial();

	virtual CExpression* conjugated(int mode = 0);
	virtual CEString* toString(int mode = 0);

	virtual CExpression* unite_with(IETensor *other, bool other_is_at_right=true, bool bCalledByOther=false);
	virtual const char* ClassName() const;

public:
	static CExpression* m_symGammaSpecialBase;
	const static CExpression* GetGammaSpecialBase(); // never returns NULL

public:
	static CExpression* expandGammaPM(CExpression* src);
	static CExpression* expandGammaPM_ruleImpl(CExpression* src, CEPtrArray* data_arr);
protected:
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_EGAMMASPECIAL_H__E607BAA0_030E_11D6_8A94_936FB66AA46C__INCLUDED_)
