////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EMatrix.h: interface for the CEMatrix class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EMATRIX_H__BF8FC203_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EMATRIX_H__BF8FC203_C3EE_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ETensor.h"

class CEMatrix : public CETensor  
{
	int m_Symmetry; // 1: symmetric
public:
	static const char* CLASS_NAME;

	virtual const char* ClassName() const;
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	virtual CEString* toString(int mode = 0);
	virtual CExpression* clone() const;

	virtual CExpression* Arrange(int level); // for symmetric ones
	CEMatrix(const CExpression* base,
		const CExpression* index1, const CExpression* index2,
		bool covariance1, bool covariance2, int _symm=0);
	CEMatrix(const CExpression* base,
		const CTIndex* index1, const CTIndex* index2,
		int _symm=0);
	virtual ~CEMatrix();

};

#endif // !defined(AFX_EMATRIX_H__BF8FC203_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
