////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EMetric.h: interface for the CEMetric class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EMETRIC_H__B77F2500_F0A9_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EMETRIC_H__B77F2500_F0A9_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEMetric : public CEMatrix  
{
public:
	static CExpression* m_MetricBase;
	static const CExpression* GetMetricBase();
	static CExpression* m_refDeltaSym; // to cache dataStorageCalls;
	static CExpression* GetDeltaSymRef();

public:
	virtual CExpression* expand(bool recursive = true);
	virtual CExpression* Arrange(int level);
	virtual const char* ClassName() const;
	static const char* CLASS_NAME;
	
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	virtual CEString* toString(int mode = 0);
	virtual CExpression* clone() const;
	CEMetric(const CExpression* index1, const CExpression* index2, bool covariance1, bool covariance2);
	CEMetric(const CTIndex* index1, const CTIndex* index2);
	virtual ~CEMetric();

	virtual bool less_than(CExpression* other);
};

#endif // !defined(AFX_EMETRIC_H__B77F2500_F0A9_11D5_90CB_00403393DD18__INCLUDED_)
