////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERank4Tensor.h: interface for the CERank4Tensor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERANK4TENSOR_H__77C42E1D_0099_4776_9CDD_E4EE62F55488__INCLUDED_)
#define AFX_ERANK4TENSOR_H__77C42E1D_0099_4776_9CDD_E4EE62F55488__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CERank4Tensor : public CETensor  
{
	int m_Symmetry12; // 1: symmetric 1&2
	int m_Symmetry34; // 1: symmetric 1&2
public:
	CERank4Tensor(const CExpression* _base,
		const CExpression* index1, bool covariance1,
		const CExpression* index2, bool covariance2,
		const CExpression* index3, bool covariance3,
		const CExpression* index4, bool covariance4, int symm12=0, int symm34=0);
	virtual ~CERank4Tensor();

	virtual CExpression* clone() const;
	virtual const char* ClassName() const;
	static const char* CLASS_NAME;

	virtual CExpression* Arrange(int level); // for symmetric ones
};

#endif // !defined(AFX_ERANK4TENSOR_H__77C42E1D_0099_4776_9CDD_E4EE62F55488__INCLUDED_)
