////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESGammaProduct.h: interface for the CESGammaProduct class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESGAMMAPRODUCT_H__D549A3E0_C664_11D5_8A94_CC5D72783117__INCLUDED_)
#define AFX_ESGAMMAPRODUCT_H__D549A3E0_C664_11D5_8A94_CC5D72783117__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2C900AB
class CESGammaProduct : public CESProduct  
{
public:
	virtual unsigned long props_long();
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	virtual CExpression* Arrange(int level);
	virtual CExpression* exchange_subst(IETensor* other, bool other_is_at_right, bool bCalledByOther=false);
	static const char* CLASS_NAME;
	
	virtual bool equals(CExpression* other);
	virtual CExpression* clone() const;
	virtual CExpression* expand(bool recursive = true);
	CExpression* getBaseExpression();
	virtual const char* ClassName() const;
	CESGammaProduct(const CExpression* v);
	virtual ~CESGammaProduct();

	//##ModelId=3E3FF2C900B1
	virtual CEString* toString(int mode = 0);

protected:
	//##ModelId=3E3FF2C900AE
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);

};

#endif // !defined(AFX_ESGAMMAPRODUCT_H__D549A3E0_C664_11D5_8A94_CC5D72783117__INCLUDED_)
