////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESProduct.h: interface for the CESProduct class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESPRODUCT_H__BF8FC205_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_ESPRODUCT_H__BF8FC205_C3EE_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D40000
class CESProduct : public CEScalar  
{
protected:
	//##ModelId=3E3FF2D4000A
	CExpression* m_a;
	//##ModelId=3E3FF2D40005
	CExpression* m_b;

public:
	virtual CExpression* numeric();
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static const char* CLASS_TAG_NAME;
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

	//##ModelId=3E3FF2D40027
	CExpression* get_a();
	//##ModelId=3E3FF2D40026
	CExpression* get_b();
	//##ModelId=3E3FF2D40025
	virtual const char* ClassName() const;
	//##ModelId=3E3FF2D40002
	static const char* CLASS_NAME;

	virtual bool equals(CExpression* other);
	virtual bool less_than(CExpression* other);

	//##ModelId=3E3FF2D40023
	virtual CExpression* expand(bool recursive = true);
	//##ModelId=3E3FF2D40021
	virtual bool contain_vector(void * obj);
	//##ModelId=3E3FF2D4001F
	virtual CExpression* Arrange(int level);
	//##ModelId=3E3FF2D40016
	virtual CExpression* applyRule(CEAbstractRule* rule);
	//##ModelId=3E3FF2D40015
	virtual CExpression* clone() const;
	//##ModelId=3E3FF2D40013
	virtual CEString* toString(int mode = 0);
	//##ModelId=3E3FF2D40010
	CESProduct(const CExpression* a, const CExpression* b);
	//##ModelId=3E3FF2D4000F
	virtual ~CESProduct();

protected:
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
public:
	virtual unsigned long props_long();
};

#endif // !defined(AFX_ESPRODUCT_H__BF8FC205_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
