////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESpinor.h: interface for the CESpinor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESPINOR_H__320E6BF1_C4AB_453E_A123_A97DF40648BC__INCLUDED_)
#define AFX_ESPINOR_H__320E6BF1_C4AB_453E_A123_A97DF40648BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CESpinor : public CETensor  
{
	bool m_conjugated;
public:
	virtual unsigned long props_long();
	virtual CExpression* clone() const;
	bool is_conjugated() const { return m_conjugated; }
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	
	CExpression* couple_with_spinor(CESpinor* other, bool other_is_at_right = true);
	virtual CExpression* conjugated(int mode = 0);
	virtual bool contain_vector(void * obj);
	virtual CExpression* applyRule(CEAbstractRule* rule);
	virtual CEString* toString(int mode = 0);
	CESpinor(const CExpression* base, bool _is_conjugated);
	virtual ~CESpinor();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
protected:
	//##ModelId=3E3FF2DF013A
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_ESPINOR_H__320E6BF1_C4AB_453E_A123_A97DF40648BC__INCLUDED_)
