////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EVector.h: interface for the CEVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVECTOR_H__BF8FC202_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EVECTOR_H__BF8FC202_C3EE_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DD003E
class CEVector : public CETensor  
{
	//char* m_id;
public:
	virtual CExpression* Arrange(int level);
	virtual CExpression* expand(bool recursive = true);
	//##ModelId=3E3FF2DD0066
	virtual char* id();
	//##ModelId=3E3FF2DD0064
	static char* getVectorDataId(CExpression *base);
	//##ModelId=3E3FF2DD0062
	static CExpression* module(CExpression *base);
	//##ModelId=3E3FF2DD0060
	static CExpression* square(CExpression *base);
	//##ModelId=3E3FF2DD004F
	static const char* CLASS_NAME;

	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static const char* CLASS_TAG_NAME;
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

	static CEVector* CreateUnique(CExpression* ind, bool cov, bool commutative);

	//##ModelId=3E3FF2DD005D
	virtual CExpression* unite_with(IETensor* other, bool other_is_at_right=true, bool bCalledByOther=false);
	//##ModelId=3E3FF2DD005A
	virtual CExpression* clone() const;
	//##ModelId=3E3FF2DD0059
	virtual CExpression* index();
	//##ModelId=3E3FF2DD0058
	bool covariance() const;
	//##ModelId=3E3FF2DD0057
	virtual const char* ClassName() const;
	//##ModelId=3E3FF2DD0053
	CEVector(const CExpression* base, const CExpression* index, bool covariance);
	//##ModelId=3E3FF2DD0052
	virtual ~CEVector();
	//##ModelId=3E3FF2DD0050
	virtual CEString* toString(int mode = 0);

	virtual bool less_than(CExpression* other);

public:
	static CECache* m_VecSqrCache;
	static void InitVecSquareCache();
	static void ClearVecSquareCache();
	static void AddToVecSquareCache(CExpression *base, CExpression *val);
	static void RemoveVecSquareCached(CExpression *base);
	static CExpression* GetVecSquareCached(CExpression *base);
	static CExpression* get_predefined_square(CExpression *base); // returns cloned value or NULL
};

#endif // !defined(AFX_EVECTOR_H__BF8FC202_C3EE_11D5_90CB_00403393DD18__INCLUDED_)
