////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EComplexValue.h: interface for the CEComplexValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ECOMPLEXVALUE_H__22B09C51_563F_4362_B0A4_B2F573DB4593__INCLUDED_)
#define AFX_ECOMPLEXVALUE_H__22B09C51_563F_4362_B0A4_B2F573DB4593__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEComplexValue : public CEValue  
{
	double m_RE;
	double m_IM;

public:
	CEComplexValue(double _re, double _im);
	virtual ~CEComplexValue();
	
	double get_RE();
	double get_IM();
	void normalize();

	virtual DWORD get_val_type();
	virtual bool equals(CExpression* other);
	virtual double to_double();
	virtual CEValue* Sqrx(bool do_clone = false);
	virtual CEValue* multiply(double val);
	virtual CEValue* Absx(bool do_clone = false);
	virtual CEValue* Sqrtx(bool do_clone = false);
	virtual bool less_than(CExpression* other);
	virtual CExpression* clone() const;
	virtual CEString* toString(int mode = 0);
	virtual CEValue* inverse(bool do_coinverse_level = true);
	virtual CExpression* multiply(CExpression* other);
	virtual CExpression* add(CExpression* other);

public:
	virtual unsigned long props_long();
protected:
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_ECOMPLEXVALUE_H__22B09C51_563F_4362_B0A4_B2F573DB4593__INCLUDED_)
