////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EPowerReplRule.h: interface for the CEPowerReplRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EPOWERREPLRULE_H__F14CA7F0_2F11_480F_8027_BDBC8C417F4E__INCLUDED_)
#define AFX_EPOWERREPLRULE_H__F14CA7F0_2F11_480F_8027_BDBC8C417F4E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEPowerReplRule : public CERule  
{
	CExpression* m_base;
	long m_power;
	DWORD m_times_applied;
public:
	CEPowerReplRule(const CExpression* base, long nMaxPowerAllowed);
	virtual ~CEPowerReplRule();

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;

	virtual void ResetTimesApplied();
	virtual DWORD GetTimesApplied();
};

#endif // !defined(AFX_EPOWERREPLRULE_H__F14CA7F0_2F11_480F_8027_BDBC8C417F4E__INCLUDED_)
