////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERealValue.h: interface for the CERealValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EREALVALUE_H__FF5C9176_5D9C_4DEE_834D_543892249F86__INCLUDED_)
#define AFX_EREALVALUE_H__FF5C9176_5D9C_4DEE_834D_543892249F86__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CERealValue : public CEValue  
{
	double m_value;

private:
	void normalize();
	void Abs();
	CERealValue* Sqr();
	CERealValue* Sqrt();
	void apply_sign();

public:
	CERealValue(double val);
	virtual ~CERealValue();

public:
	virtual bool equals(CExpression* other);
	virtual bool less_than(CExpression* other);
	virtual CExpression* clone() const;
	virtual CExpression* multiply(CExpression* other);
	virtual CExpression* add(CExpression* other);
	virtual CEString* toString(int mode = 0);

	virtual DWORD get_val_type();
	virtual CEValue* multiply(double val);
	virtual double to_double();
	virtual CEValue* Sqrx(bool do_clone = false);
	virtual CEValue* Absx(bool do_clone = false);
	virtual CEValue* Sqrtx(bool do_clone = false);
	virtual CEValue* inverse(bool do_coinverse_level = true);
};

#endif // !defined(AFX_EREALVALUE_H__FF5C9176_5D9C_4DEE_834D_543892249F86__INCLUDED_)
