////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EReplasement.h: interface for the CEReplasement class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EREPLASEMENT_H__90A49725_8482_4275_B07B_C0A6ED737865__INCLUDED_)
#define AFX_EREPLASEMENT_H__90A49725_8482_4275_B07B_C0A6ED737865__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DA030D
class CEReplasement : public CERule  
{
	CExpression* m_a;
	CExpression* m_b;
	bool m_do_exchange;
	
	DWORD m_operation_flags;
	DWORD m_times_applied;
public:
	static const DWORD REPL_AVOID_NULL_DENOMINATORS; // greatly slows the calculation
	static const DWORD REPL_NOT_IN_SUBSUMS;
	static const DWORD REPL_NOT_IN_SUMS;

public:
	//	!!!!!!!!!!!!!!!!!!!!!!!!!!!!  The forward replacement means A is replaced by B.
	virtual CEString* toString(int mode = 0);
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CERule* GetRuleCopy() const;

	virtual void ResetTimesApplied();
	virtual DWORD GetTimesApplied();

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);
	void set_b(CExpression* _b, bool do_copy);
	void set_a(CExpression* _a, bool do_copy);
	bool exchange();
	CExpression* a();
	CExpression* b();
	CEReplasement(const CExpression* a, const CExpression* b, bool do_exchange = false);
	CEReplasement(const CExpression* a, const CExpression* b, bool do_exchange, DWORD _operation_flags);
	virtual ~CEReplasement();

	DWORD GetOperationFlags();
	void SetOperationFlags(DWORD _operation_flags);

	static CExpression* Replace(CExpression* source, CExpression* a, CExpression* b, bool do_exchange = false);
private:
	CExpression* do_replace(CExpression* src, bool do_delete_src);
};

#endif // !defined(AFX_EREPLASEMENT_H__90A49725_8482_4275_B07B_C0A6ED737865__INCLUDED_)
