////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ERulesList.h: interface for the CERulesList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ERULESLIST_H__8B2D83C4_F739_4DFD_8155_55DEC93ACB47__INCLUDED_)
#define AFX_ERULESLIST_H__8B2D83C4_F739_4DFD_8155_55DEC93ACB47__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CERulesList : public CERule  
{
protected:
	CEPtrArray* m_list;
	CERulesList(const CEPtrArray* _rules_list);
public:
	CERulesList();
	virtual ~CERulesList();

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);
	virtual CEString* toString(int mode = 0);
	virtual int GetRuleKind();
	virtual CERule* combine_with(CERule* other);
	void addRule(CERule* new_rule);
	CERule* getRule(int i);
	CERule* extractRule(int i);
	int getRulesNum();
	void RemoveAll();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CERule* GetRuleCopy() const;

	virtual void ResetTimesApplied();
	virtual DWORD GetTimesApplied();
};

#endif // !defined(AFX_ERULESLIST_H__8B2D83C4_F739_4DFD_8155_55DEC93ACB47__INCLUDED_)
