////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESocketRule.h: interface for the CESocketRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESOCKETRULE_H__828C00D9_32BD_46A8_893D_82172638F88C__INCLUDED_)
#define AFX_ESOCKETRULE_H__828C00D9_32BD_46A8_893D_82172638F88C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CESocketRule : public CERule
{
	CExpression* (*m_pFunction)(CExpression*, CEPtrArray*); // function pointer
	int m_settings;

	CEPtrArray* m_data_array;

public:
	static const int SR_APPLY_TO_CHANGED_SOURCE;
	static const int SR_APPLY_TO_SUBITEMS_FIRST;
	static const int USE_EXTERNAL_DATA_ARRAY;

	CESocketRule(void* pFunc, CEPtrArray* data_array=NULL, int _settings = 0);
	virtual ~CESocketRule();

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;
};

#endif // !defined(AFX_ESOCKETRULE_H__828C00D9_32BD_46A8_893D_82172638F88C__INCLUDED_)
