////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EValue.h: interface for the CEValue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVALUE_H__9F384400_47F6_11D6_9CE8_DDC31F3032EF__INCLUDED_)
#define AFX_EVALUE_H__9F384400_47F6_11D6_9CE8_DDC31F3032EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEValue : public CExpression  
{
protected:
	static CDebug* dbg;

public:
	static const DWORD VTYPE_REAL;
	static const DWORD VTYPE_COMPLEX;

public:
	static CEValue* Abs(CEValue* var, bool do_delete = true);
	static CEValue* Sqrt(CEValue* var, bool do_delete = true);

	virtual DWORD get_val_type();
	virtual unsigned long props_long();
	virtual double to_double() = 0;
	virtual CEValue* Sqrx(bool do_clone = false) = 0;
	virtual CEValue* multiply(double val) = 0;
	virtual CEValue* Absx(bool do_clone = false) = 0;
	virtual CEValue* Sqrtx(bool do_clone = false) = 0;

	virtual CEString* toString(int mode = 0);
	virtual CEValue* inverse(bool do_coinverse_level = true) = 0;
	virtual CExpression* Arrange(int level);
	virtual CExpression* numeric();
	virtual CExpression* multiply(CExpression* other) = 0;
	virtual CExpression* add(CExpression* other) = 0;

	CEValue();
	virtual ~CEValue();

protected:
	//##ModelId=3E3FF2D60138
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
};

#endif // !defined(AFX_EVALUE_H__9F384400_47F6_11D6_9CE8_DDC31F3032EF__INCLUDED_)
