////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// RCollectSymbols.h: interface for the CRCollectSymbols class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RCOLLECTSYMBOLS_H__ED42E017_59BA_41A9_857F_45FCE7B2B074__INCLUDED_)
#define AFX_RCOLLECTSYMBOLS_H__ED42E017_59BA_41A9_857F_45FCE7B2B074__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
*	Basic usage modes:
*	1. [Estimate object size]
*	long size=CRCollectSymbols::CountObjects(src);
*
*	2. [Collect objects]
*	CRCollectSymbols r(CRCollectSymbols::COLLECT_DENOMINATORS);
*	r.ApplyTo(expr,false);
*	CEPtrArray* res_list = r.getCollectedSymbols(true);
*/
class CRCollectSymbols : public CERule  
{
	CEPtrArray* m_ignore_list;
	CEPtrArray* m_result_list;
	int m_settings;
	const char* m_sClassName; // NULL or external link

	CRCollectSymbols(int _settings, const CEPtrArray* result_list, const CEPtrArray* _ignore_list, long _Counter, const char* _ClassName);
public:
	static const int COLLECT_UNIQUES;
	static const int COLLECT_DENOMINATORS;
	static const int COLLECT_TENSOR_INDICES_ONLY;
	static const int COUNT_OBJECTS;

	long m_Counter;

	CRCollectSymbols(int _settings, const CEPtrArray* _ignore_list=NULL, const char* _ClassName=NULL);
	virtual ~CRCollectSymbols();
	CEPtrArray* getCollectedSymbols(bool extract_res=false);

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;

	static long CountObjects(CExpression* src); // source is unaffected

private:
	bool CheckSymbol(CExpression* sym);
};

#endif // !defined(AFX_RCOLLECTSYMBOLS_H__ED42E017_59BA_41A9_857F_45FCE7B2B074__INCLUDED_)
