////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// RContainCheck.h: interface for the CRContainCheck class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RCONTAINCHECK_H__3AF61276_034C_4F77_8316_DD872706F191__INCLUDED_)
#define AFX_RCONTAINCHECK_H__3AF61276_034C_4F77_8316_DD872706F191__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRContainCheck : public CERule  
{
	CExpression* m_target_expr; // compared if (!= NULL)
	unsigned long m_target_props; // compared if (!= 0)
	bool m_search_res;
	const char* m_target_ClassName; // external link, compared if !=NULL (fast comparison only: "==") 

	CRContainCheck(const CExpression* target, unsigned long target_props, const char* target_ClassName, bool _search_res);
public:
	static bool search(CExpression* source, CExpression* target);
	static bool search(CExpression* source, unsigned long target_props);
	static bool search(CExpression* source, const char* target_ClassName);

	CRContainCheck(const CExpression* target);
	CRContainCheck(unsigned long target_props);
	CRContainCheck(const char* target_ClassName);
	virtual ~CRContainCheck();
	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);
	
	bool getSearchResult();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;
};

#endif // !defined(AFX_RCONTAINCHECK_H__3AF61276_034C_4F77_8316_DD872706F191__INCLUDED_)
