////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// RReplaceDenominators.h: interface for the CRReplaceDenominators class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RREPLACEDENOMINATORS_H__58E41280_C99A_4D07_AAF2_4040EB57FAC4__INCLUDED_)
#define AFX_RREPLACEDENOMINATORS_H__58E41280_C99A_4D07_AAF2_4040EB57FAC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
*	Rule is used to cache denominators  in composite expressions.
*	Replaces denominators with commutative unique symbols.
*/
class CRReplaceDenominators : public CERule  
{
	int m_settings;
	CEPtrArray* m_replaced_values;
	int m_dens_flags; // user remarks to be attached to replaced values as integer info #0.

public:
	static const int REPL_DENS_DEFAULT;
	CRReplaceDenominators(int _settings, const CEPtrArray* _replaced_values, int _dens_flags = 0);
	CRReplaceDenominators(int _settings, int _dens_flags = 0);
	virtual ~CRReplaceDenominators();
	CEPtrArray* getReplacedValues();
	
	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;
	void SetDensFlags(int _dens_flags); // user remarks to be attached to replaced values as integer info #0.

private:
	CExpression* GetSubstSym(CExpression* den_val); // searches denominator in previous data, NULL if not found
	CExpression* InvolveNewSubstSym(CExpression* den_val); // creates new symbol
};

#endif // !defined(AFX_RREPLACEDENOMINATORS_H__58E41280_C99A_4D07_AAF2_4040EB57FAC4__INCLUDED_)
