////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EProcessEnvironment.h: interface for the CEProcessEnvironment class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EPROCESSENVIRONMENT_H__F6FF80C0_ADC5_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EPROCESSENVIRONMENT_H__F6FF80C0_ADC5_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//#include "..\..\EObject.h"

//##ModelId=3E3FF2D40203
class CEProcessEnvironment : public CEObject
{
private:
	//##ModelId=3E3FF2D40217
	CEFunctionProvider* m_fp;
	//##ModelId=3E3FF2D40214
	long m_env;

	bool m_CALC_MASS_EXACT;
	CEPtrArray* m_mass_order_info;
public:
	void SetMassCalcOrder(int part_kind, int mass_order);
	int GetMassCalcOrder(int part_kind);
	void ClearMassCalcOrders(); // cancel all the SetMassCalcOrder() calls
	CEPtrArray* GetMassOrderInfo();
	void SetMassExactCalc();
	void RestoreMassCalcOrders(); // cancels SetMassExactCalc() flag only

	int m_mass_order;
	int m_photon_helisity_notation;
	//##ModelId=3E3FF2D40222
	long set_env(long _env);
	//##ModelId=3E3FF2D4021E
	long get_env();
	//##ModelId=3E3FF2D40213
	static const long ENV_EXPAND_ALL;

	//##ModelId=3E3FF2D4021D
	virtual CEFunctionProvider* getFunctionProvider();
	//##ModelId=3E3FF2D4021B
	CEProcessEnvironment(CEFunctionProvider* fp);
	//##ModelId=3E3FF2D4021A
	virtual ~CEProcessEnvironment();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
};

#endif // !defined(AFX_EPROCESSENVIRONMENT_H__F6FF80C0_ADC5_11D5_90CB_00403393DD18__INCLUDED_)
