////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LSymbolDataBank.cpp: implementation of the CLSymbolDataBank class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Static data
//////////////////////////////////////////////////////////////////////
CECharMap* CLSymbolDataBank::m_char_map = NULL;
CECharMap* CLSymbolDataBank::GetCharMap() { return m_char_map; }
void CLSymbolDataBank::ResetCharMap() {
	if (m_char_map != NULL) delete m_char_map;
	m_char_map = new CECharMap();
}

const DWORD CLSymbolDataBank::NO_MAP_FOR_UNIQUES	= 0x02;
void CLSymbolDataBank::init(DWORD _settings) {
	CESymbol::m_UseCharMap = true;
	CESymbol::m_NoCharMapForUniques = ((_settings & NO_MAP_FOR_UNIQUES) != 0);
	ResetCharMap();
}

void CLSymbolDataBank::finalize() {
	CESymbol::m_UseCharMap = false;
	CESymbol::m_NoCharMapForUniques = true;
	if (m_char_map != NULL) {
		CECharMap::dbg->log(7, "Symbol bank before deleting", m_char_map);
		delete m_char_map; m_char_map = NULL;
	}
}

const char* CLSymbolDataBank::GetCharOrigin(const char* copy, bool do_create) {
	const char* res = NULL;
	if (m_char_map != NULL)  res = m_char_map->getValueOrigin(copy, do_create);
	return res;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CLSymbolDataBank::CLSymbolDataBank() : CEObject(true) {}
CLSymbolDataBank::~CLSymbolDataBank() {}
