////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EMap.cpp: implementation of the CEMap class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
const int CEMap::NO_INTEGER_FOUND = INT_MIN;

CEMap::CEMap() : CESerializable() { }
CEMap::~CEMap() { }

const char* CEMap::ClassName() const { return "CEMap"; }

CEMap* CEMap::createNewMap()
{
	return new CESimpleMap();
}

void CEMap::put(CESerializable* id, CEObject* o)
{
	CEString* id_str = id->toString();
	put(id_str->getData(), o);
	delete id_str;
}

CEObject* CEMap::get(CESerializable* id)
{
	CEString* id_str = id->toString();
	CEObject* res = get(id_str->getData());
	delete id_str;
	return res;
}
