////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EPtrStack.cpp: implementation of the CEPtrStack class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEPtrStack::CEPtrStack()
{
	m_data = new CEPtrArray();
}

CEPtrStack::~CEPtrStack()
{
	delete m_data;
}

const char* CEPtrStack::CLASS_NAME = "CEPtrStack";
const char* CEPtrStack::ClassName() const { return CLASS_NAME; }
bool CEPtrStack::contain_vector(void * obj)
{
	if (m_data == obj) return true;
	return m_data->contain_vector(obj);
}

void CEPtrStack::push(CEObject *p)
{
	m_data->add(p);
}

CEObject* CEPtrStack::pop()
{
	long s = m_data->size();
	if (s > 0) {
		CEObject* res = m_data->GetAt(s-1);
		m_data->RemoveAt(s-1, false);
		return res;
	}
	return NULL;
}
