// RArrangeInfinity.cpp: implementation of the CRArrangeInfinity class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

CExpression* CRArrangeInfinity::ArrageInfinity(CExpression* src, bool del_src) {
	CRArrangeInfinity r;
	CExpression* res=r.ApplyTo(src,del_src);
	return res;
}

/*
*	same to ArrangeInfinity(ArrangeInfinity(src->add(CENumber::GetUnit()))->minus(CENumber::GetUnit()))
*/
CExpression* CRArrangeInfinity::ArrageInfinityToUnit(CExpression* src, bool del_src) { // 1/Inf->0
	CRArrangeInfinity r(true);
	//dbg->log(2,"CRArrangeInfinity::ArrageInfinityToUnit",src);
	//dbg->set_level(100);
	CExpression* res=r.ApplyTo(src,del_src);
	//dbg->set_level(5);
	//dbg->log(2,"CRArrangeInfinity::ArrageInfinityToUnit res",res);
	return res;
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRArrangeInfinity::CRArrangeInfinity(bool _bTruncateToUnit) : CERule() { m_bTruncateToUnit=_bTruncateToUnit; }
CRArrangeInfinity::~CRArrangeInfinity() {}

const char* CRArrangeInfinity::CLASS_NAME = "CRArrangeInfinity";
const char* CRArrangeInfinity::ClassName() const { return CLASS_NAME; }
CERule* CRArrangeInfinity::GetRuleCopy() const { return new CRArrangeInfinity(m_bTruncateToUnit); }
bool CRArrangeInfinity::contain_vector(void * obj) { return false; }
CEString* CRArrangeInfinity::toString(int mode) { CEString* res  = new CEString("{CRArrangeInfinity}"); return res; }

CExpression* CRArrangeInfinity::ApplyTo(CExpression* src, bool del_src) {
	if (src==NULL) return NULL;
	
	if (!CRContainCheck::search(src,CEInfinity::CLASS_NAME)) return src;

	// apply to sub-items
	CExpression* sub_res = src->applyRule(this);
	if (sub_res != src) { if(del_src){ delete src; }else{ del_src=true; } src=sub_res; if(src==NULL)return NULL; }
	
	// check again (Inf-ty may be already omitted)
	if (!CRContainCheck::search(src,CEInfinity::CLASS_NAME)) return src;

	//CExpression* res=src;
	CExpression* res=CExpression::arrge(src,false); // also calls CEProduct::inline_subproducts()
	if (res != src) { if(del_src){ delete src; }else{ del_src=true; } src=res; if(src==NULL)return NULL; }

	if (src->getProperty(CEProperties::PROP_MASK_IS_SUM)) {
		// Every item is: {F, Inf, F*Inf, F*Inf^P, CompicatedObject}
		long s=((CESum*)src)->size(); bool bIsComplicated=false;
		CExpression* eF=NULL; bool bArrgeF=false;
		CENumber* eP=NULL; // sign always: '+', level always: '+'
		if (m_bTruncateToUnit) {
			eF=CENumber::GetZero(); bArrgeF=true; // "bArrgeF=true" is unused now due to further (CEBasic::isZero(eF)) checks
			eP=CENumber::GetZero();
		}
		for(long i=0;i<s;i++) {
			CExpression* item=((CESum*)src)->GetAt(i); if(item==NULL) { bIsComplicated=true; break; }
			if (!CRContainCheck::search(item,CEInfinity::CLASS_NAME)) {
				CENumber nZero((long)0);
				if (eP!=NULL) {
					if (eF==NULL) { CEException::halt("Internal ERROR at CRArrangeInfinity::ApplyTo(): eF==NULL",__FILE__,__LINE__); }
					int cmp_res=0;
					if (!eP->CompareOtherN(&nZero,&cmp_res)) { bIsComplicated=true; break; }
					if (cmp_res<0) {
						delete eP; delete eF; bArrgeF=false;
						eP=CENumber::GetZero(); eF=item->clone();
					} else if (cmp_res==0) {
						if (CEBasic::isZero(eF)) { delete eF; eF=item->clone(); bArrgeF=false; } else { eF=eF->add(item->clone()); bArrgeF=true; }
					}
				} else {
					eP=CENumber::GetZero(); eF=item->clone(); bArrgeF=false;
				}
				continue;
			}
			CEProduct* pr=CEBasic::convertToProduct(item->clone()); if(pr==NULL) { bIsComplicated=true; break; }
			CExpression* ePi=ExtractInfinityPower(pr);
			if (ePi==NULL) { /*Can't extract factor*/ delete pr; bIsComplicated=true; break; }
			if (ePi->ClassName()==CENumber::CLASS_NAME) {
				CENumber* nPi=(CENumber*)ePi;
				if ( (nPi->getNumIm() != 0) ||
					(!nPi->getLevel()) ||
					(nPi->getDen() == 0) ) { delete ePi; delete pr; bIsComplicated=true; break; }
				if (eP!=NULL) {
					int cmp_res=0;
					if (!eP->CompareOtherN(nPi,&cmp_res)) { delete ePi; delete pr; bIsComplicated=true; break; }
					if (eF==NULL) { CEException::halt("Internal ERROR at CRArrangeInfinity::ApplyTo(): eF==NULL",__FILE__,__LINE__); }
					if (cmp_res<0) {
						delete eP; delete eF; bArrgeF=false;
						eP=nPi; ePi=NULL; eF=pr; pr=NULL;
					} else if (cmp_res==0) {
						if (CEBasic::isZero(eF)) { delete eF; eF=pr; bArrgeF=false; } else { eF=eF->add(pr); bArrgeF=true; }
						pr=NULL;
					}
				} else {
					if (eF!=NULL) { CEException::halt("Internal ERROR at CRArrangeInfinity::ApplyTo(): eF!=NULL",__FILE__,__LINE__); }
					eP=nPi; ePi=NULL; eF=pr; pr=NULL; bArrgeF=false;
				}
			} else {
				delete ePi; delete pr; bIsComplicated=true; break;
			}
			if(ePi!=NULL)delete ePi; if(pr!=NULL)delete pr;
		}
		if ((eP==NULL)||(eF==NULL)) bIsComplicated=true;
		if (bIsComplicated) {
			if(eP!=NULL)delete eP; if(eF!=NULL)delete eF;
		} else {
			if (bArrgeF) { eF=CExpression::arrge(eF); if(eF==NULL)CEException::halt("CRArrangeInfinity::ApplyTo",__FILE__,__LINE__); }
			if (CEBasic::isZero(eP)) {
				res=eF;
			} else {
				CExpression* InfPow=NULL;
				if (CEBasic::isUnit(eP)) {
					InfPow=new CEInfinity();
				} else {
					CEInfinity eInf; InfPow=new CEPower(&eInf,eP);
				}
				res=eF->multiply(InfPow);
			}
			src->copyAttributesTo(res,true);
			delete eP;
		}
	} else if ((m_bTruncateToUnit) && (src->getLevel())) { // non-sum bup Inf-containent {product, power}: 1/Inf->0
		/*
		*	Non-cloning pr=((CEProduct*)src) can not be involved for now!
		*	The error will occur there if (ExtractInfinityPower(pr)->ClassName()!=CENumber::CLASS_NAME)
		*	The factor Inf^Sym is dropped now => cloning required.
		*/
		CEProduct* pr=CEBasic::convertToProduct(src->clone());
		CExpression* eP=((pr!=NULL)?ExtractInfinityPower(pr):NULL);
		if (eP!=NULL) {
			if ((pr->getLevel()) && (eP->ClassName()==CENumber::CLASS_NAME)) { // (pr->getLevel()) is extra check here
				CENumber* nP=(CENumber*)eP;
				if ( (nP->getNumIm() == 0) && (nP->getLevel()) && (nP->getDen() != 0) ) {
					CENumber nZero((long)0);
					int cmp_res=0;
					if (nP->CompareOtherN(&nZero,&cmp_res)) {
						if (cmp_res<0) {
							res=CENumber::GetZero();
						}
					}
				}
			}
			delete eP;
		}
		delete pr;
	}
	/*
	else if (src->getProperty(CEProperties::PROP_MASK_IS_PRODUCT)) {
		long s=((CEProduct*)src)->size();
		bool bNeedReduce=false;
		for(long i=0;i<s;i++) {
			CExpression* item=((CEProduct*)src)->GetAt(i); if (item==NULL)continue;
			if (item->getProperty(CEProperties::PROP_MASK_IS_PRODUCT)) { bNeedReduce=true; break; }
		}
		if (bNeedReduce) {
			//CExpression* res=CExpression::reduce(src,false);
			CExpression* res=CExpression::arrge(src,false); // also calls CEProduct::inline_subproducts()
			if(res!=src){ if(del_src) { delete src; } else { del_src=true; } src=res; }
			res = ApplyTo(src,false); // src will be deleted further (if required)
		}
	}
	*/
	/*
	else if (src->getProperty(CEProperties::PROP_MASK_IS_PRODUCT)) {
		long s=((CEProduct*)src)->size();
		for(long i=0;i<s;i++) {
			CExpression* item=((CEProduct*)src)->GetAt(i);
			if ((item!=NULL)&&(item->ClassName()==CEInfinity::CLASS_NAME)) {
				if (item->getLevel()) {
					res=new CEInfinity(); if(!item->getFlag())res->inverseFlag(); src->copyAttributesTo(res,true);
				} else {
					res=CENumber::GetZero(); if(!item->getFlag())res->inverseFlag(); src->copyAttributesTo(res,true);
				} break;
			}
		}
	}
	*/
	/*
	else if (src->ClassName() == CEPower::CLASS_NAME) {
		CExpression* bas = ((CEPower*)src)->basis();
		if ((bas!=NULL)&&(bas->ClassName()==CEInfinity::CLASS_NAME)) {
			CExpression* pow = ((CEPower*)src)->power();
			if (pow->ClassName()==CENumber::CLASS_NAME) {
				CENumber* nPow=(CENumber*)pow;
				if ((nPow->getNumIm() == 0) && (nPow->getDen() != 0)) {
					int iPowSign=1;
					if (!nPow->getFlag()) iPowSign=-iPowSign;
					if (nPow->getNum()==0) {iPowSign=0;} else if (nPow->getNum()<0) {iPowSign=-iPowSign;}
					if (nPow->getDen()<0) iPowSign=-iPowSign;
					//long iPowSign=((CENumber*)pow)->getLong();
					if (!bas->getLevel()) iPowSign=-iPowSign;
					if (iPowSign>0) {
						res=new CEInfinity(); src->copyAttributesTo(res,true);
					} else if (iPowSign<0) {
						res=CENumber::GetZero(); src->copyAttributesTo(res,true);
					} // else Inf^0
				}
			}
		}
	}
	*/

	if (res != src) {
		dbg->log(7,"CRArrangeInfinity::ApplyTo res,src",res,src);
		if (del_src) delete src;
	}
	return res;
}

CExpression* CRArrangeInfinity::ExtractInfinityPower(CExpression* eProduct) { // finite factor remains
	if(eProduct==NULL)return NULL;
	CEProduct* pr=(CEProduct*)eProduct;
	if (!pr->getLevel()) return NULL;
	// Product should contain one (and the only) Infinity object (Inf or Inf^P)
	long s=pr->size();
	for(long i=0;i<s;i++) {
		CExpression* item=((CEProduct*)pr)->GetAt(i); if (item==NULL) return NULL;
		if (item->ClassName()==CEInfinity::CLASS_NAME) {
			if (!item->getFlag()) { pr->inverseFlag(); item->inverseFlag(); }
			bool l=item->getLevel();
			pr->RemoveAt(i);
			// No more infinity is expected
			if (CRContainCheck::search(pr,CEInfinity::CLASS_NAME)) return NULL;
			CExpression* res=CENumber::GetUnit(); if(!l)res->inverseFlag();
			return res;
		}
		
		if (item->ClassName() == CEPower::CLASS_NAME) {
			CExpression* bas = ((CEPower*)item)->basis(); if(bas==NULL)return NULL;
			if (bas->ClassName()==CEInfinity::CLASS_NAME) {
				if (!bas->getFlag()) return NULL;
				CExpression* pow=((CEPower*)item)->power(); if(pow==NULL)return NULL;
				if (!item->getFlag()) { pr->inverseFlag(); item->inverseFlag(); }
				CExpression* res=pow->clone();
				if(!item->getLevel())res->inverseFlag();
				if(!bas->getLevel())res->inverseFlag();
				pr->RemoveAt(i);
				// No more infinity is expected
				if (CRContainCheck::search(pr,CEInfinity::CLASS_NAME)) { delete res; return NULL; }
				return res;
			}
		}
	}
	return NULL; // Infinity not found
}
