////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// APtrSeq.h: interface for the CAPtrSeq class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APTRSEQ_H__1C9D22A3_4058_4952_83AF_88F5D6C87F83__INCLUDED_)
#define AFX_APTRSEQ_H__1C9D22A3_4058_4952_83AF_88F5D6C87F83__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CAPtrSeqCart : public CEObject
{
public:
	CEObject* m_Obj;
	CAPtrSeqCart* m_Next;
	CAPtrSeqCart(CEObject* _Obj, CAPtrSeqCart* _Next);
	CAPtrSeqCart(CEObject* _Obj);
	virtual ~CAPtrSeqCart();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEObject* copy() const;
	virtual bool contain_vector(void * obj);
};

class CAPtrSeq : public CEObject  
{
	class CASeqIterationCart : public CEObject {
	public:
		CASeqIterationCart();
		CAPtrSeqCart* m_Cart;
		long m_Pos;
		void Clear();
	};

	CAPtrSeqCart* m_CartFirst;
	CAPtrSeqCart* m_CartLast;
	long m_size;
	bool m_allow_NULLs;

	CASeqIterationCart m_itInfo[2]; //iterators

	CAPtrSeq(CAPtrSeqCart* _cart_first, bool allow_NULLs);
	void ToICart(long i); // set m_I-iterator & m_CartI;
	CAPtrSeqCart* ExtractCartAt(long i);
public:
	CAPtrSeq(bool allow_NULLs = false);
	virtual ~CAPtrSeq();

public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual char* toLine(int mode = 0);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	virtual bool contain_vector(void * obj);

	// plain-access operations
	long size();
	CEObject* GetAt(long i); //uses I-iterator
	CEObject* GetAt2(long i);  //uses J-iterator
	const CEObject* GetAtConst(long i) const; //uses I-iterator
	void SetAt(long i, CEObject *obj, bool delete_old = false); // no-clone
	void InsertAt(long i, CEObject* obj); // no-clone
	void MoveFromTo(long from, long to);
	void RemoveAt(long i, bool delete_old);
	CEObject* ExtractAt(long i);
	void add(CEObject* obj);
	//CEObject* get(long i);
	void add_sequence(CAPtrSeq* other); // does not affect other, differs from ARRAY!

	// iterator operations
	void reset_iterator();
	CEObject* next();
	bool has_next();
	//CEObject* first();
	//CEObject* last();
	
	CAPtrSeq* clone() const;
	void clearall_without_delete_objects();
	static CAPtrSeq* get_copy(CAPtrSeq* other, bool do_create = false);
	void clear_all();

	void SelfCheck();
};

#endif // !defined(AFX_APTRSEQ_H__1C9D22A3_4058_4952_83AF_88F5D6C87F83__INCLUDED_)
