////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ECache.h: interface for the CECache class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ECACHE_H__7F2B9326_62F3_4BAB_8477_5F76DA3A0CA3__INCLUDED_)
#define AFX_ECACHE_H__7F2B9326_62F3_4BAB_8477_5F76DA3A0CA3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define BUILD_CECACHE_AS_ARRAY
class CECache : public CESerializable  
{
#ifdef BUILD_CECACHE_AS_ARRAY
	CEPtrArray* m_cache_data;
#else
	CAPtrSeq* m_cache_data;
#endif //BUILD_CECACHE_AS_ARRAY
	bool m_keep_NULLs;

#ifdef BUILD_CECACHE_AS_ARRAY
	CECache(CEPtrArray* _cache_data,bool keep_NULLs);
#else
	CECache(CAPtrSeq* _cache_data,bool keep_NULLs);
#endif //BUILD_CECACHE_AS_ARRAY

public:
	CECache(bool keep_NULLs=true);
	virtual ~CECache();

	virtual CEString* toString(int mode = 0);
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEObject* copy() const;
	virtual bool contain_vector(void * obj);
	CECache* clone() const;

	/*
	*	replaces previous value if one exists
	*	set NULL value to mark source as uncalculatable
	*	does not affect parameters
	*/
	void put_value(CExpression* src, CExpression* val);

	/*
	*	doesn't differs "not in cache" & "NULL in cache" objects
	*/
	CExpression* get_val(CExpression* src);

	void remove_val(CExpression* src);
	void clear_all();

	/*
	*	value is get_val_container()->get_info_expr()
	*	NULL cart means result is "not in cache"
	*	NULL container-info value means result is "NULL"
	*/
	CExprContainer* get_val_container(CExpression* src);
};

#endif // !defined(AFX_ECACHE_H__7F2B9326_62F3_4BAB_8477_5F76DA3A0CA3__INCLUDED_)
