////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// EMap.h: interface for the CEMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EMAP_H__18C9C660_CE06_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_EMAP_H__18C9C660_CE06_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D2033C
class CEMap : public CESerializable  
{
public:
	static const int NO_INTEGER_FOUND;

	virtual CEObject* next() = 0;
	virtual bool has_next() = 0;
	virtual void reset_iterator() = 0;
	virtual long size() = 0;
	static CEMap* createNewMap();
	virtual void put(const char* id, CEObject* o) = 0;
	virtual void put_int(char* id, long _val, bool do_copy_id = true) = 0;
	virtual void put_ptr(const char* id, void* _p) = 0;
	virtual CEObject* get(const char* id) = 0;
	virtual long get_int(const char* id) = 0;
	virtual void* get_ptr(const char* id) = 0;
	void put(CESerializable* id, CEObject* o);
	CEObject* get(CESerializable* id);
	CEMap();
	virtual ~CEMap();

	virtual const char* ClassName() const;
};

#endif // !defined(AFX_EMAP_H__18C9C660_CE06_11D5_90CB_00403393DD18__INCLUDED_)
