////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ENamedItem.h: interface for the CENamedItem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENAMEDITEM_H__35F12EE1_CEEC_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_ENAMEDITEM_H__35F12EE1_CEEC_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

///////////////////////////////////////////////////////////// CENamedItem
class CENamedItem : public CEObject  
{
	unsigned m_item_type;
public:
	static unsigned NI_OBJECT;
	static unsigned NI_INT;
	static unsigned NI_VOID_PTR;

	long set_int(long _val);
	long get_int();
	void* set_ptr(void* _p);
	void* get_ptr();
	unsigned get_item_type();

	void set_object(CEObject* o);
	//virtual CEString* toString(int mode = 0);
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual char* toLine(int mode = 0);
	const char* getId();
	void setId(const char* id_new);
	CEObject* getObject();
	CENamedItem(CEObject* o, const char* id);
	CENamedItem(CEObject* o, bool do_copy_id, char* id);
	CENamedItem(long _val, char* id, bool do_copy_id = true);
	CENamedItem(void* _p, const char* id);
	virtual ~CENamedItem();

private:
	char* m_id;
	CEObject* m_obj;
	long m_int_val;
	void* m_ptr;
};

#endif // !defined(AFX_ENAMEDITEM_H__35F12EE1_CEEC_11D5_90CB_00403393DD18__INCLUDED_)
