////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ENumberArray.h: interface for the CENumberArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENUMBERARRAY_H__122DCFA0_4244_480B_8CD9_B0B6F18ABE23__INCLUDED_)
#define AFX_ENUMBERARRAY_H__122DCFA0_4244_480B_8CD9_B0B6F18ABE23__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CENumberArray : public CESerializable  
{
	int* m_numbers;
	int m_size;

	CENumberArray(int _size, int* _data_buf);
public:
	CENumberArray(int _size);
	CENumberArray(int _val_1, int _val_2);
	CENumberArray(int _val_1, int _val_2, int _val_3);
	virtual ~CENumberArray();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	CENumberArray* clone() const;
	virtual bool contain_vector(void * obj);

	void set_value(int i, int val);
	int get_value(int i);
	int get_size();
	void realloc_size(int _size);
	void move_value(int from, int to);
};

#endif // !defined(AFX_ENUMBERARRAY_H__122DCFA0_4244_480B_8CD9_B0B6F18ABE23__INCLUDED_)
