////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESimpleMap.h: interface for the CESimpleMap class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESIMPLEMAP_H__18C9C661_CE06_11D5_90CB_00403393DD18__INCLUDED_)
#define AFX_ESIMPLEMAP_H__18C9C661_CE06_11D5_90CB_00403393DD18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CESimpleMap : public CEMap  
{
public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;

	CEObject* next();
	bool has_next();
	void reset_iterator();
	static CDebug* dbg;
	virtual bool contain_vector(void * obj);
	virtual char* toLine(int mode = 0);
	virtual CEString* toString(int mode = 0);
	virtual long size();
	virtual void put(const char* id, CEObject* o);
	virtual CEObject* get(const char* id);
	CESimpleMap();
	virtual ~CESimpleMap();

	virtual void put_int(char* id, long _val, bool do_copy_id = true);
	virtual long get_int(const char* id);
	virtual void put_ptr(const char* id, void* _p);
	virtual void* get_ptr(const char* id);

	CENamedItem* get_NI(const char* id);
private:
	CEPtrArray* m_pitems;
};

#endif // !defined(AFX_ESIMPLEMAP_H__18C9C661_CE06_11D5_90CB_00403393DD18__INCLUDED_)
