////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ETimeMark.h: interface for the CETimeMark class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ETIMEMARK_H__077BC383_10F5_4D10_95AF_5859D82DB735__INCLUDED_)
#define AFX_ETIMEMARK_H__077BC383_10F5_4D10_95AF_5859D82DB735__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CETimeMark : public CEObject
{
	int m_hours;
	int m_minutes;
	int m_seconds;
	long m_millis;
public:
	CETimeMark(int _hours, int _minutes, int _seconds, long _millis);
	virtual ~CETimeMark();

	static const char* CLASS_NAME;
    virtual const char* ClassName() const;
	virtual char* toLine(int mode = 0);
	virtual CEObject* copy() const;

	int get_hours();
	int get_minutes();
	int get_seconds();
	long get_millis();

	void substrTimeMark(CETimeMark* other);
	void addTimeMark(CETimeMark* other);
	void addTimeValue(int h, int m, int s, int mill);
	bool greatherThan(CETimeMark* other);
	bool lessThan(CETimeMark* other);
	bool lessThanZero(); // is > 23h
	void copyFrom(CETimeMark* other); // fo aviod extra create/deletes (NULL sets zero)
	void divide(unsigned d);
	DWORD to_millis();

	void truncate(bool ahead); // to 1/2/5/10/20/30 sec, 1/2/5/10/20/30 min, 1/2/5/10/20h
	void truncate(CETimeMark* mod, bool ahead); // by 1/2/5/10/20/30 sec, 1/2/5/10/20/30 min, 1/2/5/10/20h

private:
	static CETimeMark* m_time_start;
public:
	static void SetStartTimeCurr();

	static CETimeMark* GetCurrTimeMark();
	static CETimeMark* GetCurrTimeAbs();
	static CETimeMark* GetZeroTimeMark();
	static CETimeMark* GetStartTimeAbs();

};

#endif // !defined(AFX_ETIMEMARK_H__077BC383_10F5_4D10_95AF_5859D82DB735__INCLUDED_)
