////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ExprContainer.h: interface for the CExprContainer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPRCONTAINER_H__50A5B8BE_9F4F_4183_9C4F_14F0FE49A547__INCLUDED_)
#define AFX_EXPRCONTAINER_H__50A5B8BE_9F4F_4183_9C4F_14F0FE49A547__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////// CEObjIdCart
class CEObjIdCart : public CEObject {
	CEObject* m_obj;
	long m_id;
public:
	CEObjIdCart(CEObject* _obj, int id);
	virtual ~CEObjIdCart();
	CEObject* GetObj() { return m_obj; }
	long GetId() { return m_id; }
	CEObjIdCart* clone() const;

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual char* toLine(int mode = 0);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	virtual bool contain_vector(void * obj);
};

//////////////////////////////////////////////////////// CExprContainer
class CExprContainer : public CESerializable
{
	CExpression* m_source;
	int* m_info;
	int m_info_num;
	CExpression* m_info_expr;

	CExprContainer(CExpression* _source, int _info_num, int* _info_buf, CExpression* _expr_info);
public:
	CExprContainer(CExpression* _source, int info);
	CExprContainer(CExpression* _source, int info_1, int info_2, CExpression* expr_info = NULL);
	CExprContainer(CExpression* _source, int info_1, int info_2, int info_3, CExpression* expr_info = NULL);
	CExprContainer(CExpression* _source, CExpression* expr_info);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	CExprContainer* clone() const;
	virtual bool contain_vector(void * obj);

	virtual ~CExprContainer();
	CExpression* get_expr();
	void set_expr(CExpression* val);
	void set_info(int i, int val);
	int get_info(int i = 0);
	int get_info_num();
	CExpression* get_info_expr();
	void set_info_expr(CExpression* info_val); // clones input
};

#endif // !defined(AFX_EXPRCONTAINER_H__50A5B8BE_9F4F_4183_9C4F_14F0FE49A547__INCLUDED_)
