////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// IntArray.h: interface for the CIntArray class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTARRAY_H__62BAA9A1_C02A_11D9_B9D8_88B1D8EB7A3A__INCLUDED_)
#define AFX_INTARRAY_H__62BAA9A1_C02A_11D9_B9D8_88B1D8EB7A3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
*	substitute for int[NN],
*/
class CIntArray : public CEObject
{
	long m_size;
	long m_size_allocated;
	long* m_data;
public:
	CIntArray();
	CIntArray(long sz); // pre-allocate to size (size remains 0)
	CIntArray(const CIntArray& arr);
	virtual ~CIntArray();
	virtual CEObject* copy() const; // CIntArray*
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
    virtual char* toLine(int mode = 0);

	long GetSize() const;
	long GetAt(long i) const;
	void SetAt(long i, long val);
	void Add(long val);
	/* AddValTo: add value fo cell's content, does not increase array size */
	void AddValTo(long val, long posFrom=-1, long posTo=-1);
	void PreAllocateTo(long sz);
	void ToSize(long sz);
	void RemoveAll();
	void RemoveAt(long i);
	void AddNItems(long n, long val=0);// == for(int i=0;i<n;i++)Add(val);
	void FillAll(long val = 0);
	void FillAllSeq(long first_val = 0);
	bool equals(CIntArray* other);
	bool equalsCommonItems(CIntArray* other); // compare till size of shortest
	void exchange(long a, long b);

	long operator()(long i) const { return GetAt(i); }

	long SprintfTo(char* s, long len_max=-1);

	bool AreAllGTZero(); // are all > 0
	bool AreAllGEZero(); // are all >= 0
};

#endif // !defined(AFX_INTARRAY_H__62BAA9A1_C02A_11D9_B9D8_88B1D8EB7A3A__INCLUDED_)
