////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MemoryManager.h: interface for the CMemoryManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEMORYMANAGER_H__95FC0556_190C_4832_B9A9_C29527D7376C__INCLUDED_)
#define AFX_MEMORYMANAGER_H__95FC0556_190C_4832_B9A9_C29527D7376C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMemoryWatchCart : public CEObject  
{
public:
	CEObject* get_obj();
	long get_id();
	CMemoryWatchCart(CEObject* o, long _id);
	virtual ~CMemoryWatchCart();

	CMemoryWatchCart* get_prev();
	CMemoryWatchCart* get_next();
	void set_prev(CMemoryWatchCart* wc);
	void set_next(CMemoryWatchCart* wc);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual char* toLine(int mode = 0);
private:
	long m_id;
	CEObject* m_obj;
	CMemoryWatchCart* m_prev;
	CMemoryWatchCart* m_next;
};

//##ModelId=3E3FF2D901F4
class CMemoryManager : public CEObject  
{
	static CMemoryWatchCart* m_obj_watch_first;
	static CMemoryWatchCart* m_obj_watch_last;
	static unsigned long m_watch_list_size;

	static bool m_is_inited;

	//##ModelId=3E3FF2D90205
	//static CEPtrArray* obj_data;
	static CEPtrArray* delete_data;
	//##ModelId=3E3FF2D901FD
	static CEPtrArray* str_data;

	// fast time-watch substitute
private:
	static long m_obj_counter; // counter of created objects
public:
	static long GetObjCounter();

private:
	static long CalcWatchesNum();

public:
	//static void add_to_delete_list(CEObject* obj); //Note: use CEProcessor::AddToDeleteList(obj);

	static void exclude_watch(CEObject* obj);
	static void examine_watches();
	static CDebug* dbg;
	static void finalize();
	static void init();
	static bool add_watch(CEObject* obj);
	static void mfree(void* p);
	static void* mrealloc(void* old, long new_len);
	static char* mReallocChar(char *old, long new_len);
	static void* mmalloc(long length);
	static void mmemcpy(void* to, const void* from, long length);	//'from' and 'to' MAY NOY overlap!
	static void mmemmove(void* to, const void* from, long length);
	CMemoryManager();
	virtual ~CMemoryManager();
};

#endif // !defined(AFX_MEMORYMANAGER_H__95FC0556_190C_4832_B9A9_C29527D7376C__INCLUDED_)
