////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// Pos2D.h: interface for the CPos2D class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POS2D_H__788ACBFC_12E4_4ADB_A362_10E4BE6473E5__INCLUDED_)
#define AFX_POS2D_H__788ACBFC_12E4_4ADB_A362_10E4BE6473E5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPos2D : public CESerializable  
{
	double m_dx;
	double m_dy;

	int m_ix;
	int m_iy;

	int m_x_max;
	int m_y_max;

	CPos2D(int ix, int x_max, int iy, int y_max, double dx, double dy);
	void reset_integers();

public:
	CPos2D(double x, double y);
	CPos2D(int x, int x_max, int y, int y_max);
	virtual ~CPos2D();

	void AddPos(CPos2D* other_pos);
	void SubtrPos(CPos2D* other_pos);
	void MultiplyFactor(double _factor, CPos2D* center_pos = NULL);
	void MultiplyFactors(double _factor_X, double _factor_Y, CPos2D* center_pos = NULL);
	
	CPos2D* clone() const;
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);

	void set_XY(double x, double y);
	int get_X(int x_max = -1);
	int get_Y(int y_max = -1);
	double get_double_X();
	double get_double_Y();
	
	void set_box_size(int x_max, int y_max);
};

#endif // !defined(AFX_POS2D_H__788ACBFC_12E4_4ADB_A362_10E4BE6473E5__INCLUDED_)
