// RArrangeInfinity.h: interface for the CRArrangeInfinity class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RARRANGEINFINITY_H__6F30E287_9CDA_457D_A689_6895698E2878__INCLUDED_)
#define AFX_RARRANGEINFINITY_H__6F30E287_9CDA_457D_A689_6895698E2878__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CRArrangeInfinity : public CERule  
{
	bool m_bTruncateToUnit; // 1/Inf->0
public:
	CRArrangeInfinity(bool _bTruncateToUnit=false);
	virtual ~CRArrangeInfinity();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;

public:
	static CExpression* ArrageInfinity(CExpression* src, bool del_src = true);
	static CExpression* ArrageInfinityToUnit(CExpression* src, bool del_src = true); // 1/Inf->0

public:
	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

private:
	CExpression* ExtractInfinityPower(CExpression* eProduct); // finite factor remains, NULL result means no Infinity
};

#endif // !defined(AFX_RARRANGEINFINITY_H__6F30E287_9CDA_457D_A689_6895698E2878__INCLUDED_)
