////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// RMaxPowerToSym.h: interface for the CRMaxPowerToSym class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RMAXPOWERTOSYM_H__9EB7A7E5_958F_4732_A14C_263D32C701C2__INCLUDED_)
#define AFX_RMAXPOWERTOSYM_H__9EB7A7E5_958F_4732_A14C_263D32C701C2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*
*	Searches for MAXIMUM power that can be replaced by single symbol
*/
class CRMaxPowerToSym : public CERule  
{
	CExpression* m_base;
	CExpression* m_repl;
	int m_max_power;
	int m_mode; // 1: search, 2: replace;

	CRMaxPowerToSym(const CExpression* _base, int _max_power, int _mode, const CExpression* _repl);
public:
	CRMaxPowerToSym(const CExpression* _base);
	virtual ~CRMaxPowerToSym();

	virtual CExpression* ApplyTo(CExpression* src, bool del_src = true);

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CERule* GetRuleCopy() const;

	int GetMaxPower();
	void setReplMode(CExpression* _repl);
public:
	static CExpression* MaxPowerToSym(CExpression* src,
		CExpression* base_sym, int* pow_found,
		CEPtrArray* arrNewSyms, // to add replacment symbol at arr[size()] (may be NULL)
		const char* pow_suffix = "P",
		bool del_src = true);
};

#endif // !defined(AFX_RMAXPOWERTOSYM_H__9EB7A7E5_958F_4732_A14C_263D32C701C2__INCLUDED_)
