// VMFileUtils.h: interface for the CVMFileUtil class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VMFILEUTIL_H_INCLUDED_)
#define AFX_VMFILEUTIL_H_INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////	CVMFileUtil
/*
*	File system operations
*/
class CVMFileUtil : public CEObject {
public:
	class CVMFileInfo : public CEObject {
		CEString m_name;
		bool m_bIsDir;
	public:
		CVMFileInfo(const char* fn, bool bIsDir);
		const char* Name() { return m_name.getData(); }
		bool IsDir() { return m_bIsDir; }
	public:
		static const char* CLASS_NAME;
		virtual const char* ClassName();
		//virtual CEObject* copy() const;
	};
public:
	static bool IsInitialDirChanged() { return m_bInitialDirChanged; }
	static const char* GetInitialPath();
	static bool GetCurrentPath(CEString& str);
	static bool MkDir(const char* dir);
	static bool ChDir(const char* path);
	static bool RmDir(const char* dir);
	static bool IsFileExist(const char* fn);	// warning: undefined return if 'fn' is a directory name
	static bool IsDirExist(const char* dir);
	// [Win] dir: "." (Current), ""(Root!!!), "/"(Error)
	static bool ReadDir(const char* dir, CAPtrSeq* files, bool bReadDirs=false);
private:
	static char* m_bufGetCurrentPath;			// used by GetCurrentPath
	static char* m_bufInitialPath;				// set automatically in GetInitialPath() or ChDir()
	static bool m_bInitialDirChanged;
	static void SetCurrPathAsInitial();
};

#endif // !defined(AFX_VMFILEUTIL_H_INCLUDED_)
