////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// TestCalculation.cpp: implementation of the CTestCalculation class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CTestCalculation::CTestCalculation() { }
CTestCalculation::~CTestCalculation() { }


//////////////////////////////////////////////////////////////////////
// Test workshop
//////////////////////////////////////////////////////////////////////

// may not affect parameters
CExpression* CTestCalculation::ScriptTestCommand(CExpression* a, CExpression* b) {
	CERule* r = new CESocketRule((void*)CTestCalculation::Test_ruleImpl);
	a = r->ApplyTo(a->clone());
	delete r;
	return a;

	//b = b->clone();
	//CExpression* res = CExpression::reduce(a->minus(b));
	//CExpression* res = CExpression::reduce(a);

	/*dbg->logperiod(0);
	CExpression* res = CExpression::reduce(a->clone()->minus(b->clone()));
	dbg->logperiod(0, "minus");
	delete res;
	res = CExpression::reduce(a->clone()->add(b->clone()));
	dbg->logperiod(0, "add");
	delete a; delete b; delete res;
	return NULL;*/
}

CExpression* CTestCalculation::ScriptTestCommandB() {
	CESymbol a("a"); CESymbol b("b"); CESymbol c("c"); CESymbol d("d");
	CESymbol a1("a1"); CESymbol a2("a2"); CESymbol a3("a3");
	CESymbol b1("b1"); CESymbol b2("b2"); CESymbol b3("b3");
	CESymbol c1("c1"); CESymbol c2("c2"); CESymbol c3("c3");
	CENumber z((long)0); CENumber u((long)1);
	long i; long j; long s;

	s=10000;
	CEString str;
	dbg->logperiod(0, "start");
	for(j=0; j<10; j++) {
		str.Reset();
		for(i=0; i<(s*10); i++) { str.AddString("<--test-->"); }
	}
	dbg->logperiod(0, "add (10x100000x10)");
	dbg->log(0, str.length(),"string len: %ld");
	
	for(j=0; j<1; j++) {
		for(i=0; i<(s/4); i++) { str.insertString("0",0); }
	}
	dbg->logperiod(0, "insert at 0 (x1/4)");
	dbg->log(0, str.length(),"string len: %ld");

	for(j=0; j<1; j++) {
		for(i=0; i<s; i++) { str.insertString("S",str.length()/2); }
	}
	dbg->logperiod(0, "insert at half (x1)");
	dbg->log(0, str.length(),"string len: %ld");

	for(j=0; j<200; j++) {
		for(i=0; i<s; i++) { str.insertString("E",str.length()-2); }
	}
	dbg->logperiod(0, "insert at end-1 (x200)");
	dbg->log(0, str.length(),"string len: %ld");

	/*
	delete x;
	x = new CEAntiSymmProd(sa, b, c, d);
	dbg->log(0, "x", x);
	x = CExpression::reduce(x);
	dbg->log(0, "x reduced", x);
	delete x;

	x = new CEAntiSymmProd(sa, sb, d, sc);
	dbg->log(0, "x", x);
	x = CExpression::reduce(x);
	dbg->log(0, "x reduced", x);
	delete x;

	x = new CEAntiSymmProd(sa, sb, d, z);
	dbg->log(0, "x", x);
	x = CExpression::reduce(x);
	dbg->log(0, "x reduced", x);*/

	//CExpression* p = a->clone()->divide(a->clone()->add(z->clone()));
	//dbg->log(0, "p", p);
	//p = CExpression::reduce(p);
	//dbg->log(0, "p", p);
	//delete a; delete z; delete p;
	return CENumber::GetUnit();
}

CExpression* CTestCalculation::Test_ruleImpl(CExpression* src, CEPtrArray* data_arr) {

	if (src->getProperty(CEProperties::PROP_MASK_IS_PRODUCT)) {
		CEProduct* pr = (CEProduct*)src;
		long i;
		for(i=0; i<pr->size(); i++) {
			CExpression* item = pr->GetAt(i);
			if ((!item->getLevel()) && (item->getProperty(CEProperties::PROP_MASK_IS_SUM))) {
				return CENumber::GetZero();
			}

			if (CEUtil::equals(item->ClassName(), CEPower::CLASS_NAME)) {
				if (((CEPower*)item)->basis()->getProperty(CEProperties::PROP_MASK_IS_SUM)) {
					return CENumber::GetZero();
				}
			}
		}
		return src;
	}

	return src;
}


/*
int len = 100000;
	int last = len-1;
	int times = 100;
	int i=0;
	int j=0;

	//printf("sizeof(CEObject*):%ld, ", sizeof(CEObject*)); printf("sizeof(void*):%ld", sizeof(void*));

	CExpression* obj = CENumber::GetUnit();
	CEPtrArray* arr = new CEPtrArray();
	dbg->log(0, times, "(Nx) = %ld");
	dbg->log(0, " **** CEPtrArray **** ");

	dbg->logperiod();
	for(i=0; i<len; i++) { arr->add(obj); }
	dbg->logperiod(0, "filled");

	for(j=0; j<times; j++) { for(i=0; i<len; i++) { arr->GetAt(i); } }
	dbg->logperiod(0, "sequential access (Nx)");
	for(j=0; j<times; j++) { for(i=0; i<len; i++) { arr->GetAt(0); } }
	dbg->logperiod(0, "0 access (Nx)");
	for(j=0; j<times; j++) { for(i=0; i<len; i++) { arr->GetAt(last); } }
	dbg->logperiod(0, "MAX access (Nx)");
	for(i=0; i<(len/1000); i++) { arr->RemoveAt(0, false); }
	dbg->logperiod(0, "remove 1/10000 from 0");

	//////////////////////
	//return CENumber::GetUnit();


	//Sleep(4000);

	CAPtrSeq* seq = new CAPtrSeq();
	dbg->log(0, " **** CAPtrSeq **** ");

	dbg->logperiod();
	for(i=0; i<len; i++) { seq->add(obj); }
	dbg->logperiod(0, "filled");

	for(j=0; j<times; j++) { for(i=0; i<len; i++) { seq->GetAt(i); } }
	dbg->logperiod(0, "sequential access (Nx)");
	//seq->SelfCheck();
	for(j=0; j<times; j++) { for(i=0; i<len; i++) { seq->GetAt(0); } }
	dbg->logperiod(0, "0 access (Nx)");
	//seq->SelfCheck();
	for(j=0; j<times; j++) { for(i=0; i<len; i++) { seq->GetAt(last); } }
	dbg->logperiod(0, "MAX access (Nx)");
	//seq->SelfCheck();
	for(i=0; i<(len/1000); i++) { seq->RemoveAt(0, false); }
	dbg->logperiod(0, "remove 1/10000 from 0");
	//seq->RemoveAt(0, false);
	//seq->SelfCheck();


	////////////////////////////

	seq->clearall_without_delete_objects(); dbg->log(0, "clear", seq);
	delete seq;

	//Sleep(4000);

	arr->clearall_without_delete_objects(); dbg->log(0, "clear", arr);
	delete arr;
*/


//////////////////////////////////////////////////////////////////////
// old test codes
//////////////////////////////////////////////////////////////////////
/*void CTestCalculation::test()
{
	dbg->log(10, "Test session started.");
	test_factors();return;

	test_gen_1();
	return;

	dbg->logperiod(20);
	
	//PM brems
	test_inel();
	
	//CExpression* born_me = CHEPLib::Calc_Born_Me();
	//CESupport::SaveResults(born_me);
	//dbg->logperiod(20);

	//CExpression* born = CHEPLib::Calc_Born(born_me);
	//CESupport::SaveResults(born);
	//delete born;
	//dbg->logperiod(20);

	//CExpression* born_2 = CFeynLib::test();
	//CESupport::SaveResults(born_2);
	//delete born_2;
	//dbg->logperiod(20);

	//test_integrals();
	//dbg->logperiod(20);

	//CExpression* v_term = CHEPLib::Calc_V_term(born_me);
	//CESupport::SaveResults(v_term);
	//dbg->logperiod(20);
	//test_v_int(v_term);
	//delete v_term;
	//dbg->logperiod(20);

	//calc_D_coupling();
	//dbg->logperiod(20);

	//delete born_me;

	dbg->log(10, "Test session finished.");
	dbg->logperiod(20);
	//CEProcessor::getDataStorage()->store_node();
}

void CTestCalculation::test_v_int(CExpression *v_int, bool log)
{
	CExpression* w = CHEPLib::repl_kin_invariants(v_int);
	CESupport::SaveResults(w);
	dbg->logperiod(20);
	w = CHEPLib::to_ultrarev(w, log);
	CESupport::SaveResults(w);
	dbg->logperiod(20);

	//CVirtIntegral::dbg->set_level(50);
	CExpression* w2 = w->evaluate();
	//CVirtIntegral::dbg->set_level(1);
	CESupport::SaveResults(w2);
	if (w2 != w) delete w;
	
	w = CHEPLib::repl_kin_invariants(w2);
	CESupport::SaveResults(w);
	dbg->logperiod(20);
	w = CHEPLib::to_ultrarev(w, log);
	CESupport::SaveResults(w);
	dbg->logperiod(20);
}

void CTestCalculation::test_integrals()
{
	CSequence* ds = new CSequence();
	//CSequence* ns = new CSequence();
	CExpression* p1 = new CESymbol("p\\_1");
	CExpression* p2 = new CESymbol("p\\_2");
	CExpression* p11 = new CESymbol("p\\_11");
	CExpression* p11m = p11->clone();
	p11m->inverseFlag();
	CExpression* p21 = new CESymbol("p\\_21");
	CExpression* m = new CESymbol("m");
	CExpression* p1d11 = p1->clone()->minus(p11->clone());


	CSequence* ts1 = new CSequence();
	ts1->addItem(CENumber::GetZero());
	ts1->addItem(CENumber::GetZero());
	ds->addItem(ts1);

	CSequence* ts2 = new CSequence();
	ts2->addItem(p11m->clone());
	ts2->addItem(m->clone());
	ds->addItem(ts2);

	//test_log_int(new CVirtInt1(new CVIDensData(ds), 1));

	CSequence* ts3 = new CSequence();
	ts3->addItem(p21->clone());
	ts3->addItem(m->clone());
	ds->addItem(ts3);

	//CSequence* ts4 = new CSequence();
	//ts4->addItem(p1d11->clone());
	//ts4->addItem(m->clone());
	//ds->addItem(ts4);

	test_log_int(new CVirtInt1(new CVIDensData(ds), 1));
	//test_log_int(new CVirtInt1(new CVIDensData(ds), 2));
	//test_log_int(new CVirtInt1(new CVIDensData(ds), 3));

	//test_log_int(new CVirtInt11(new CVIDensData(ds), 1));
	//test_log_int(new CVirtInt11(new CVIDensData(ds), 2));
	//test_log_int(new CVirtInt11(new CVIDensData(ds), 3));
	//test_log_int(new CVirtInt11(new CVIDensData(ds), 4));

	delete ds;
	delete p1;
	delete p2;
	delete p11;
	delete p11m;
	delete p21;
	delete m;
	delete p1d11;
}

void CTestCalculation::test_log_int(CExpression *vi, bool log)
{
	dbg->log(20, "CTestCalculation::test_log_int", vi);
	CESupport::SaveResults(vi);


	CExpression* temp = vi->evaluate();

	dbg->log(20, "CTestCalculation vi evaluated", temp);
	if (temp != vi) delete vi;
	//CESupport::SaveResults(temp);
	//temp = CExpression::reduce(temp);
	//CESupport::SaveResults(temp);
	//CESupport::SaveResults(temp);
	temp = CHEPLib::to_ultrarev(temp, log);

	dbg->log(20, "CTestCalculation -- UR", temp);
	//CESupport::SaveResults(temp);
	temp = CHEPLib::repl_kin_invariants(temp);
	dbg->log(20, "CTestCalculation KI replaced", temp);

	temp = CHEPLib::to_ultrarev(temp, log);
	dbg->log(20, "CTestCalculation -- UR 2", temp);
	//temp = CHEPLib::repl_kin_invariants(temp);
	CESupport::SaveResults(temp);
	delete temp;
}

void CTestCalculation::calc_D_coupling()
{
	CSequence* ds = new CSequence();
	CExpression* p1 = new CESymbol("p\\_1");
	CExpression* p2 = new CESymbol("p\\_2");
	CExpression* p11 = new CESymbol("p\\_11");
	CExpression* p11m = p11->clone();
	p11m->inverseFlag();
	CExpression* p21 = new CESymbol("p\\_21");
	CExpression* m = new CESymbol("m");
	CExpression* p1d11 = p1->clone()->minus(p11->clone());


	CSequence* ts1 = new CSequence();
	ts1->addItem(CENumber::GetZero());
	ts1->addItem(CENumber::GetZero());
	ds->addItem(ts1);

	CSequence* ts2 = new CSequence();
	ts2->addItem(p11m->clone());
	ts2->addItem(m->clone());
	ds->addItem(ts2);

	CSequence* ts3 = new CSequence();
	ts3->addItem(p21->clone());
	ts3->addItem(m->clone());
	ds->addItem(ts3);

	CSequence* ts4 = new CSequence();
	ts4->addItem(p1d11->clone());
	ts4->addItem(m->clone());
	ds->addItem(ts4);

	CSequence* cs = new CSequence();
	cs->addItem(p1->clone());

	test_log_int(CVIComposeLib::createVISeq(ds, cs));
	delete ds;
	delete p1;
	delete p2;
	delete p11;
	delete p11m;
	delete p21;
	delete m;
	delete p1d11;
}

void CTestCalculation::test_PM_box()
{
	CESupport::Save("PM box generation.");
	CExpression* k = new CESymbol("k");
	CExpression* p1 = new CESymbol("p\\_1");
	CExpression* p2 = new CESymbol("p\\_2");
	CExpression* p11 = new CESymbol("f\\_1");
	CExpression* p11m = p11->clone();
	p11m->inverseFlag();
	CExpression* p21 = new CESymbol("f\\_2");
	CExpression* m = new CESymbol("m\\_f");
	CExpression* p1d11 = p1->clone()->minus(p11->clone());
	CExpression* p2d11 = p2->clone()->minus(p11->clone());
	//CExpression* p11dk = p11->clone()->minus(k->clone());
	//CExpression* p1pk = p1->clone()->add(k->clone());
	//CExpression* p21pk = p21->clone()->add(k->clone());
	CExpression* pkd11 = k->clone()->minus(p11->clone());
	CExpression* pkp1 = k->clone()->add(p1->clone());
	CExpression* pkp21 = k->clone()->add(p21->clone());
	CExpression* p11dk = p11->clone()->minus(k->clone());

	CEProduct* seq1 = new CEProduct();
	// a.
	seq1->addItem(new CESGammaProduct(p11dk));
	seq1->addItem(new CESGammaProduct(p1));
	seq1->addItem(new CESGammaProduct(p11));
	seq1->addItem(new CESGammaProduct(pkp1));
	seq1->addItem(new CESGammaProduct(p21));
	seq1->addItem(new CESGammaProduct(p2));
	seq1->addItem(new CESGammaProduct(pkp21));
	seq1->addItem(new CESGammaProduct(p11));
	seq1->addItem(new CESGammaProduct(p1));
	seq1->addItem(new CESGammaProduct(p21));

	CEProduct* seq2= new CEProduct();
	// b.
	seq2->addItem(new CESGammaProduct(p11));
	seq2->addItem(new CESGammaProduct(k));
	seq2->addItem(new CESGammaProduct(p21));
	seq2->addItem(new CESGammaProduct(p2));
	seq2->addItem(new CESGammaProduct(p11dk));
	seq2->addItem(new CESGammaProduct(p1));
	seq2->addItem(new CESGammaProduct(p11));
	seq2->addItem(new CESGammaProduct(k));
	seq2->addItem(new CESGammaProduct(p21));
	seq2->addItem(new CESGammaProduct(p1));

	CSequence* dd1 = new CSequence();
	CENumber* zero = CENumber::GetZero();
	dd1->addItem(dd_seq(zero, zero));
	dd1->addItem(dd_seq(p11m, m));
	dd1->addItem(dd_seq(p21, m));
	dd1->addItem(dd_seq(p1d11, m));

	CSequence* dd2 = new CSequence();
	dd2->addItem(dd_seq(zero, zero));
	dd2->addItem(dd_seq(p11m, m));
	dd2->addItem(dd_seq(p21, m));
	dd2->addItem(dd_seq(p2d11, m));

	CESupport::SaveResults(seq1);
	CESupport::SaveResults(dd1);
	CESupport::SaveResults(seq2);
	CESupport::SaveResults(dd2);
	delete zero;

	CExpression* res = CDiracAlgebra::simplifyGammaSequence(seq1, NULL, NULL);
	delete seq1;
	res = CFSp::Spur(res);
	CESupport::Save("Trace (1) calculated:");
	CESupport::SaveResults(res);
	res = CHEPLib::ur_reduce(res);
	CESupport::Save("Trace (1) calculated & reduced:");
	CESupport::SaveResults(res);

	CVIDensData* dd_obj = new CVIDensData(dd1);
	delete dd1;
	CExpression* resX = CVIComposeLib::composeVI(dd_obj, res, k);
	delete res; delete dd_obj;
	res = CHEPLib::ur_reduce(resX);
	CESupport::Save("(1) integrated:");
	CESupport::SaveResults(res);

	CExpression* res_ev = res->evaluate();
	if (res_ev != res) delete res;

	res = CHEPLib::ur_reduce(res_ev);
	CESupport::Save("(1) evaluated:");
	CESupport::SaveResults(res);

	delete res;
	
	res = CDiracAlgebra::simplifyGammaSequence(seq2, NULL, NULL);
	delete seq2;
	res = CFSp::Spur(res);
	CESupport::Save("Trace (2) calculated:");
	CESupport::SaveResults(res);
	res = CHEPLib::ur_reduce(res);
	CESupport::Save("Trace (2) calculated & reduced:");
	CESupport::SaveResults(res);

	CVIDensData* dd_obj_2 = new CVIDensData(dd2); delete dd2;
	resX = CVIComposeLib::composeVI(dd_obj_2, res, k);
	delete res; delete dd_obj_2;
	res = CHEPLib::ur_reduce(resX);
	CESupport::Save("(2) integrated:");
	CESupport::SaveResults(res);

	res_ev = res->evaluate();
	if (res_ev != res) delete res;

	res = CHEPLib::ur_reduce(res_ev);
	CESupport::Save("(2) evaluated:");
	CESupport::SaveResults(res);

	//res = CViewSimplify::simp_view(res, true, false);
	//CESupport::Save("(2) simplified:");
	//CESupport::SaveResults(res);

	delete res;

	CESupport::Save("PM box generated.");

	delete m;
	delete k;
	delete p1;
	delete p2;
	delete p11;
	delete p11m;
	delete p21;
	delete p1d11;
	delete p2d11;
	delete pkd11;
	delete pkp1;
	delete pkp21;
	delete p11dk;
}

void CTestCalculation::test_sp()
{
	CExpression* k = new CESymbol("k");
	CExpression* p1 = new CESymbol("p\\_1");
	CExpression* p2 = new CESymbol("p\\_2");
	CExpression* p11 = new CESymbol("p\\_11");
	CExpression* p21 = new CESymbol("p\\_21");
	//CExpression* m = new CESymbol("m");
	CExpression* p1d11 = p1->clone()->minus(p11->clone());
	CExpression* p11dk = p11->clone()->minus(k->clone());
	CExpression* p1pk = p1->clone()->add(k->clone());
	CExpression* p21pk = p21->clone()->add(k->clone());

	CEProduct* seq = new CEProduct();

	seq->addItem(new CESGammaProduct(p11dk));
	seq->addItem(new CESGammaProduct(p21));
	seq->addItem(new CESGammaProduct(p1pk));
	seq->addItem(new CESGammaProduct(p11));
	seq->addItem(new CESGammaProduct(p21pk));
	seq->addItem(new CESGammaProduct(p1d11));

	CESupport::SaveResults(seq);
	CExpression* res = CFSp::Spur(seq);
	CESupport::SaveResults(res);
	res = CHEPLib::ur_reduce(res);
	CESupport::SaveResults(res);

	delete k;
	delete p1;
	delete p2;
	delete p11;
	delete p21;
	delete p1d11;
	delete p11dk;
	delete p1pk;
	delete p21pk;
}

CSequence* CTestCalculation::dd_seq(CExpression *p, CExpression *m)
{
	CSequence* res = new CSequence();
	res->addItem(p->clone());
	res->addItem(m->clone());
	return res;
}

void CTestCalculation::test_inel()
{
	CEProcessor::getEnvironment()->m_mass_order = 2;
	//CEProcessor::getEnvironment()->m_photon_helisity_notation = CPPhoton::PH_BERENDS_NOTATION;
	CEProcessor::getEnvironment()->m_photon_helisity_notation = CPPhoton::PH_VECTOR_NOTATION;

	CEProcessor::setKinematics(new CInelasticKinematics());
	//CEProcessor::setKinematics(new CElasticKinematics());

	CEProcessor::kinematics()->add_collinear_simpl_list();

	CExpression* sqr_x_re = NULL;//CMESquareLib::calc_ME_SQR(3, true);
	//sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	//dbg->log(20, "RES :", sqr_x_re);

	//CESupport::init_XML_TAG_structure();
	CESupport::store(sqr_x_re, "gg_ffg_vec_m2.xml", CESupport::SERIAL_EXPRESSION | CESupport::SERIAL_VERIFY);
	dbg->log(20, "XML file created.");

	return;

	int file_id_1 = CLFileManager::new_file("gg_ffg_vect.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(file_id_1, "GG_FFG_VECT", sqr_x_re, CLFileManager::FT_COMPLEX_16BIT);
	//CLFileManager::add_to_file(file_id_1, "MART_SQR_PP", sqr_x_re, CLFileManager::FT_REAL_8BIT);
	//int file_id_1 = CLFileManager::new_file("me_2.f90", CLFileManager::FT_F90);
	//CLFileManager::add_to_file(file_id_1, "MART_SQR_2", sqr_x_re, CLFileManager::FT_COMPLEX_16BIT);
	dbg->log(20, "FORTRAN file created.");
	return;

	CEProcessor::getEnvironment()->m_photon_helisity_notation = CPPhoton::PH_BERENDS_NOTATION;
	sqr_x_re = NULL;//CMESquareLib::calc_ME_SQR(3, true);
	sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	dbg->log(20, "RES :", sqr_x_re);

	int file_id_2 = CLFileManager::new_file("me2_PM_berends.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(file_id_2, "ME2_PM_BERENDS", sqr_x_re, CLFileManager::FT_REAL_8BIT);
	dbg->log(20, "FORTRAN file created.");
	
	return;

	sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	dbg->log(20, "UR RES :", sqr_x_re);

	sqr_x_re = CHEPLib::repl_kin_invariants(sqr_x_re, false);
	sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	sqr_x_re = CExpression::reduce(sqr_x_re);
	dbg->log(20, "UR invariants", sqr_x_re);

	return;

	sqr_x_re = CHEPLib::repl_kin_invariants(sqr_x_re, false);
	//sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	//sqr_x_re = CHEPLib::to_ultrarev(sqr_x_re);
	//dbg->log(20, "invariants", sqr_x_re);
	sqr_x_re = CExpression::reduce(sqr_x_re);
	dbg->log(20, "invariants reduced", sqr_x_re);

	//int file_id_2 = CLFileManager::new_file("me_2.f90", CLFileManager::FT_F90);
	//CLFileManager::add_to_file(file_id_2, "MART_SQR_2", sqr_x_re, CLFileManager::FT_COMPLEX_16BIT);
	//dbg->log(20, "FORTRAN file created.");

	CExpression* res = CLFactor::factor_simple(sqr_x_re);
	dbg->log(20, "factorized:", res);

	//int file_id_3 = CLFileManager::new_file("me_3.f90", CLFileManager::FT_F90);
	//CLFileManager::add_to_file(file_id_3, "MART_SQR_3", res, CLFileManager::FT_COMPLEX_16BIT);
	//dbg->log(20, "FORTRAN file created.");
	
	res = CLHEPBasics::KinSimplify(res, CLHEPBasics::KS_MASS_EXACT | CLHEPBasics::KS_FACTORIZE);
	//res = CSubstSimplify::simp_kin(res, true);
	dbg->log(20, "simplified:", res);

	//int file_id_4 = CLFileManager::new_file("me_4.f90", CLFileManager::FT_F90);
	//CLFileManager::add_to_file(file_id_4, "MART_SQR_4", res, CLFileManager::FT_COMPLEX_16BIT);
	//dbg->log(20, "FORTRAN file created.");
	CLFileManager::finalize();
	//delete res;
}

void CTestCalculation::test_gen_1()
{
	CEProcessor::setKinematics(new CInelasticKinematics());
	//CEProcessor::setKinematics(new CElasticKinematics());

	CExpression* ex3 = (CExpression*)CESupport::read_file("gg_ffg_vec_m2r.xml", CESupport::SERIAL_EXPRESSION);
	int file_id_3 = CLFileManager::new_file("gg_ffg_m2.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(file_id_3, "GG_FFG_M2", ex3, CLFileManager::FT_COMPLEX_16BIT);
	CExpression* ex4 = CHEPLib::get_mass_correction(ex3);
	CESupport::store(ex4, "gg_ffg_vec_m2_corr.xml", CESupport::SERIAL_EXPRESSION | CESupport::SERIAL_VERIFY);
	int file_id_4 = CLFileManager::new_file("gg_ffg_m2_corr.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(file_id_4, "GG_FFG_M2CORR", ex4, CLFileManager::FT_COMPLEX_16BIT);
	delete ex3;
	delete ex4;
	return;

	//						******************************		calc ME

	//						load/save tests
	CExpression* ex1 = (CExpression*)CESupport::read_file("gg_ffg_vec.xml", CESupport::SERIAL_EXPRESSION);
	if (ex1 == NULL) return;

	//ex1 = CHEPLib::to_ultrarev(ex1);
	//CESupport::store(ex1, "gg_ffg_vec_massless.xml", CESupport::SERIAL_EXPRESSION | CESupport::SERIAL_VERIFY);
	//return;

	int file_id_1 = CLFileManager::new_file("gg_ffg_s100.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(file_id_1, "GG_FFG_S100", ex1, CLFileManager::FT_COMPLEX_16BIT);
	return;

//	CExpression* expr_a = (CExpression*)CESupport::read_file("test_a.xml", CESupport::SERIAL_EXPRESSION);

//	CExpression* expr_1 = (CExpression*)CESupport::read_file("gg_ffg_vec.xml", CESupport::SERIAL_EXPRESSION);
//	CExpression* expr_2 = (CExpression*)CESupport::read_file("gg_ff_ber_urev.xml", CESupport::SERIAL_EXPRESSION);
	
	CExpression* expr_x = (CExpression*)CESupport::read_file("test_x.xml", CESupport::SERIAL_EXPRESSION);

//	dbg->log(20, "expr_a :", expr_a);
	dbg->log(20, "expr_x :", expr_x);

	//(1/p11_p2/p2_p21/p11_p21)*(1/p1_p11/p1_p21/p11_p21)*(1/16.)
	//(p11_p2/p1_p11+p1_p11/p11_p2)*4D0

	CAbstractGenerator* gen = new CAbstractGenerator();
	CEPtrArray* cs_arr = new CEPtrArray();
//	cs_arr->add(CENumber::GetUnit());
//	cs_arr->add(expr_1);
	cs_arr->add(ex1);
	cs_arr->add(expr_x);
//	cs_arr->add(expr_2);
//	cs_arr->add(expr_3);
//	cs_arr->add(expr_4);
//	cs_arr->add(expr_5);
//	cs_arr->add(expr_6);
	gen->compare_cs(cs_arr, 20);
	delete gen;
	delete cs_arr;
}

void CTestCalculation::FourPartTest()
{
	CEProcessor::setKinematics(new CFourParticleKinematics());
	CEProcessor::getEnvironment()->m_mass_order = 0;
	CEProcessor::getEnvironment()->m_photon_helisity_notation = CPPhoton::PH_VECTOR_NOTATION;

	CExpression* me = NULL;//CMESquareLib::calc_ME_SQR(4, true);
	if (me == NULL) {
		dbg->log(1, "NULL RES");
		return;
	}
	me = CHEPLib::to_ultrarev(me);
	dbg->log(20, "RES :", me);

	CESupport::store(me, "test_4.xml", CESupport::SERIAL_EXPRESSION | CESupport::SERIAL_VERIFY);

	int fid_1 = CLFileManager::new_file("me2_4particles.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(fid_1, "ME2_4PART", me, CLFileManager::FT_REAL_8BIT);
	dbg->log(20, "FORTRAN file created.");
	delete me;
}

void CTestCalculation::test_factors()
{
	factors_tests();
	return;

	//CExpression* a = (CExpression*)CESupport::read_file("gg_ffg_vec_m2_corr.xml", CESupport::SERIAL_EXPRESSION);
	CExpression* a = (CExpression*)CESupport::read_file("gg_ffg_vec_m2r.xml", CESupport::SERIAL_EXPRESSION);
	if (a == NULL) return;

	//CESupport::SaveResults(a);
	CExpression* b = NULL;
	
	CESupport::SaveResults(a);

	printf("2\n");
	b = CViewSimplify::factorize_partial(a->clone(),
		CViewSimplify::PART_FACT_DEFAULT | CViewSimplify::PART_FACT_VERIFY);
	//b = CViewSimplify::factorize_partial(a->clone(), CViewSimplify::PART_FACT_DEFAULT);
	CESupport::SaveResults(b);

	int fid_1 = CLFileManager::new_file("gg_ffg_m2_simp.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(fid_1, "GG_FFG_M2_SIMP", b, CLFileManager::FT_COMPLEX_16BIT);
	delete b;
	printf("3\n");

	//CESupport::store(a, "gg_ffg_vec_m2_corr_fact.xml", CESupport::SERIAL_EXPRESSION | CESupport::SERIAL_VERIFY);
	delete a;
}

void CTestCalculation::factors_tests()
{
	CExpression* a = (CExpression*)CESupport::read_file("gg_ffg_vec_m2r.xml", CESupport::SERIAL_EXPRESSION);
	if (a == NULL) return;
	a = CHEPLib::to_ultrarev(a);
	a = CExpression::reduce(a);
	CESupport::SaveResults(a);
	CExpression* b = CViewSimplify::factorize_partial(a->clone(),
		CViewSimplify::PART_FACT_DEFAULT | CViewSimplify::PART_FACT_VERIFY);
	CESupport::SaveResults(b);
	int fid_1 = CLFileManager::new_file("gg_ffg_m0_simp.f90", CLFileManager::FT_F90);
	CLFileManager::add_to_file(fid_1, "GG_FFG_M0_SIMP", b, CLFileManager::FT_COMPLEX_16BIT);
	delete b;
	delete a;
}

void CTestCalculation::test_debugs()
{
	CExpression* a = (CExpression*)CESupport::read_file("dbg_5.xml", CESupport::SERIAL_EXPRESSION);
	CExpression* c = (CExpression*)CESupport::read_file("dbg_6.xml", CESupport::SERIAL_EXPRESSION);
	if (a == NULL) return;
	if (c == NULL) return;
	CESupport::SaveResults(a);
	CESupport::SaveResults(c);

	CExpression* b = NULL;
	b = CLFactor::factorize(a->clone(), CLFactor::FACT_VERIFY);
	CESupport::SaveResults(b);
	delete b;
	delete a;
}*/
