////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DExtLineCorrRule.cpp: implementation of the CDExtLineCorrRule class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDExtLineCorrRule::CDExtLineCorrRule(CExpression* _corr_expr,
									 int _corr_kind,
									 long pk,
									 CSequence* _temp_syms)
									 : CDCorrRule(_corr_expr,
									 _corr_kind | CDiagCorrRules::CORR_RULE_EXT_LINE,
									 pk,
									 _temp_syms)
{}

CDExtLineCorrRule::~CDExtLineCorrRule() {}

const char* CDExtLineCorrRule::CLASS_NAME = "CDExtLineCorrRule";
const char* CDExtLineCorrRule::ClassName() const { return CLASS_NAME; }
CEString* CDExtLineCorrRule::toString(int mode) {
	CEString* res = NULL;
	const char* corr_title = NULL;
	if (m_corr_kind == CDiagCorrRules::CORR_RULE_EXT_LINE) { corr_title = "Ext: ";
	} else if (m_corr_kind == (CDiagCorrRules::CORR_RULE_EXT_LINE | CDiagCorrRules::CORR_RULE_FLAG_CONJUGATED)) { corr_title = "Ext*: ";
	} else { corr_title = "?: "; }
	res = new CEString(corr_title);
	
	res->AddString(CDiagramPhysics::get_particle_symbolA(m_ID, CDiagramPhysics::SYMBOL_STYLE_NB));
	res->AddString(" --> ");
	res->AddString(m_corr_expr->toString(mode));
	
	if (m_temp_syms != NULL) {
		res->AddString(", ");
		res->AddString(m_temp_syms->toString(mode));
	}
	return res;
}

CEObject* CDExtLineCorrRule::copy() const {
	return new CDExtLineCorrRule(m_corr_expr, m_corr_kind, m_ID, m_temp_syms);
}

bool CDExtLineCorrRule::obj_equals(CEObject* other) {
	if (!CDCorrRule::obj_equals(other)) return false;
	return true;
}

bool CDExtLineCorrRule::contain_vector(void * obj) {
	if (CDCorrRule::contain_vector(obj)) return true;
	return false;
}

