////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DPropagatorCorrRule.cpp: implementation of the CDPropagatorCorrRule class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDPropagatorCorrRule::CDPropagatorCorrRule(CExpression* corr_expr,
										   int _corr_kind,
										   long pk,
										   CSequence* temp_syms)
										   : CDCorrRule(corr_expr,
										   _corr_kind | CDiagCorrRules::CORR_RULE_INT_LINE,
										   pk,
										   temp_syms)
{}

CDPropagatorCorrRule::~CDPropagatorCorrRule() {}

const char* CDPropagatorCorrRule::CLASS_NAME = "CDPropagatorCorrRule";
const char* CDPropagatorCorrRule::ClassName() const { return CLASS_NAME; }
CEString* CDPropagatorCorrRule::toString(int mode) {
	CEString* res = NULL;
	const char* corr_title = NULL;
	if (m_corr_kind == CDiagCorrRules::CORR_RULE_INT_LINE) { corr_title = "Int: "; }
	else if (m_corr_kind == (CDiagCorrRules::CORR_RULE_INT_LINE | CDiagCorrRules::CORR_RULE_COUNTER_TERM)) { corr_title = "Int (CT): "; }
	else { corr_title = "?: "; }
	res = new CEString(corr_title);

	res->AddString(CDiagramPhysics::get_particle_symbolA(m_ID, CDiagramPhysics::SYMBOL_STYLE_NB));
	res->AddString(" --> ");
	res->AddString(m_corr_expr->toString(mode));

	if (m_temp_syms != NULL) {
		res->AddString(", ");
		res->AddString(m_temp_syms->toString(mode));
	}
	return res;
}

CEObject* CDPropagatorCorrRule::copy() const {
	return new CDPropagatorCorrRule(m_corr_expr, m_corr_kind, m_ID, m_temp_syms);
}

bool CDPropagatorCorrRule::obj_equals(CEObject* other) {
	if (!CDCorrRule::obj_equals(other)) return false;
	return true;
}

bool CDPropagatorCorrRule::contain_vector(void * obj) {
	if (CDCorrRule::contain_vector(obj)) return true;
	return false;
}
