////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DElementViewInfo.h: interface for the CDElementViewInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DELEMENTVIEWINFO_H__4803B5E3_8363_463E_8D66_29993C083EEB__INCLUDED_)
#define AFX_DELEMENTVIEWINFO_H__4803B5E3_8363_463E_8D66_29993C083EEB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDElementViewInfo : public CESerializable  
{
	CPos2D* m_pos;

	int m_repetition_ID;
	int m_repetition_factor;

	CDElementViewInfo(CPos2D* _pos, int _repetition_ID, int _repetition_factor);
public:
	CDElementViewInfo(CPos2D* _pos);
	CDElementViewInfo(double x_pos, double y_pos);
	CDElementViewInfo(); // constructor for internal lines info
	virtual ~CDElementViewInfo();

	CDElementViewInfo* clone() const;
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);

	CPos2D* get_pos();
	void set_pos(CPos2D* pos_new);
	void set_repetition(int _repetition_ID, int _repetition_factor);
	void inc_repetition_factor();
	int get_repetition_ID();
	int get_repetition_number();
};

#endif // !defined(AFX_DELEMENTVIEWINFO_H__4803B5E3_8363_463E_8D66_29993C083EEB__INCLUDED_)
