////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DExtLine.h: interface for the CDExtLine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DEXTLINE_H__DB98B71C_0669_42FA_8E20_AE49B3E4E57E__INCLUDED_)
#define AFX_DEXTLINE_H__DB98B71C_0669_42FA_8E20_AE49B3E4E57E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D40157
class CDExtLine : public CDLine  
{
	CEParticle* m_particle;
	long m_PK;

public:
	// returns the momentum of line goes to vertex.
	// for (vertex != NULL) returns CLONED value.
	// for "NULL" vertex also returns CLONED internal momentum value
	virtual CExpression* get_momentum(CDElement* vertex_to);

	// returns NON-cloned value
	// can be used for momentum existance check
	virtual CExpression* get_internal_momentum_val();

	virtual void set_momentum(CExpression* _momentum, CDElement* vertex_from);
	
	CDExtLine(CEParticle* _part, bool _is_initial, const CDElementViewInfo* view_info);
	virtual ~CDExtLine();
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CDElement* clone() const;
	virtual CEString* toString(int mode = 0);
	virtual CEString* draw(int settings = 0);
	virtual long get_particle_kind() const;
	virtual void set_particle_kind(long pk);
	virtual int get_particle_ID(); // returns ID of particle in kinematics
	virtual bool is_binded();
	bool is_initial() const;

	virtual CExpression* get_vector_index();

	// save/load
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	virtual const char* get_TAG_Name();
	static const char* CLASS_TAG_NAME;
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

	// old
	/*
	bool is_similar_to(CDExtLine* other);
	CExpression* get_vector_index();
	virtual CExpression* get_me_factor();
	CDVertex* get_vertex();
	virtual void bind(CDVertex* v);
	*/
};

#endif // !defined(AFX_DEXTLINE_H__DB98B71C_0669_42FA_8E20_AE49B3E4E57E__INCLUDED_)
