////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DLine.h: interface for the CDLine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DLINE_H__7C208603_4948_4F06_B0F8_DECEB091092D__INCLUDED_)
#define AFX_DLINE_H__7C208603_4948_4F06_B0F8_DECEB091092D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CDLine : public CDElement
{
public:
	CDLine(const CDElementViewInfo* view_info);
	virtual ~CDLine();
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual long get_particle_kind() const = 0;
	virtual void set_particle_kind(long pk) = 0;

	// Returns the momentum of line goes to vertex.
	// For (vertex != NULL) returns CLONED value.
	// For "NULL" vertex also returns CLONED internal momentum value
	virtual CExpression* get_momentum(CDElement* vertex_to) = 0;

	// used for cloning, returns NON-cloned value
	// can be used for check up momentum existance
	virtual CExpression* get_internal_momentum_val() = 0;

	// Treats momentum as OUTCOMING from "vertex_from" vertex.
	// If (vertex_from == NULL) the momentum can only be cleared (if _momentum -> NULL).
	virtual void set_momentum(CExpression* _momentum, CDElement* vertex_from) = 0;

	bool is_external();

protected:
	// drawing
	CEString* GetDrawCaption(int _draw_settings);

	// old
	//bool m_is_binded;
public:
	//virtual CExpression* get_momentum(CDVertex* v_to = NULL) = 0;
	//virtual bool is_binded();
	//virtual void bind(CDVertex* v) = 0;
	//##ModelId=3E3FF2D10290


};

#endif // !defined(AFX_DLINE_H__7C208603_4948_4F06_B0F8_DECEB091092D__INCLUDED_)
