////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DVertexCorrRule.h: interface for the CDVertexCorrRule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DVERTEXCORRRULE_H__B70683A6_17CD_4138_AC1D_A8866F827778__INCLUDED_)
#define AFX_DVERTEXCORRRULE_H__B70683A6_17CD_4138_AC1D_A8866F827778__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDVertexCorrRule : public CDCorrRule  
{
	bool m_vec_momenta_reqiured;
	bool m_all_momenta_reqiured;
public:
	CDVertexCorrRule(CExpression* _corr_expr, int _corr_kind, long _ID, CSequence* _temp_syms, bool need_vec_momenta, bool need_all_momenta);
	virtual ~CDVertexCorrRule();

	bool AreVecMomentaRequired();
	bool AreAllMomentaRequired();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	virtual bool contain_vector(void * obj);
};

#endif // !defined(AFX_DVERTEXCORRRULE_H__B70683A6_17CD_4138_AC1D_A8866F827778__INCLUDED_)
