////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LDiagLocateOrdinary.h: interface for the CLDiagLocateOrdinary class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LDIAGLOCATEORDINARY_H__DE59AC00_9F8F_47EE_A2CF_9BC665FF556B__INCLUDED_)
#define AFX_LDIAGLOCATEORDINARY_H__DE59AC00_9F8F_47EE_A2CF_9BC665FF556B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLDiagLocateOrdinary : public CLDiagLocateView  
{

public:
	static const int CALC_MEDIUM_NEGLECT_FINALS;

	static const int LOCATE_START_FROM_CENTER;
	static const int LOCATE_START_FROM_HALF_CENTER;
	static const int LOCATE_START_FROM_LINKS_POS;
	
	static const int LOCATE_FINALS_NEGLECT_POS;
	static const int LOCATE_FINALS_USE_X_POS_ONLY;
	static const int LOCATE_FINALS_USE_POS;
	static const int LOCATE_FINALS_ANY;

	static const int LOCATE_TRY_OTHER_SETTINGS;

private:
	int m_locate_settings;

	CEPtrArray* m_vertex_series;

	CEPtrArray* create_next_vertex_series();
	void allocate_vertex_series(CEPtrArray* series);
	void arrange_locations_of_series(int num);
	CPos2D* calc_vertex_move_vector(CDVertex* v);
	
	CPos2D* calc_medium_pos(CDVertex* v, int setts = 0);
	CPos2D* calc_best_vertex_pos(CDVertex* v);

	int CalcCloseVerticesNum();

public:
	static CDElementViewInfo* get_link_pos_info(CDVertex* v, int link_no);

protected:
	virtual bool do_locate_vertices();
	virtual bool do_update_vertices(); //DEBUG IT! fails if caled twice. What's wrong?
public:
	CLDiagLocateOrdinary(CFeynDiagram* diag, CKinematics* kin);
	virtual ~CLDiagLocateOrdinary();
};

#endif // !defined(AFX_LDIAGLOCATEORDINARY_H__DE59AC00_9F8F_47EE_A2CF_9BC665FF556B__INCLUDED_)
