////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LDiagLocateView.h: interface for the CLDiagLocateView class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LDIAGLOCATEVIEW_H__03D261B1_929C_467E_8D1F_0F59B7E0AE26__INCLUDED_)
#define AFX_LDIAGLOCATEVIEW_H__03D261B1_929C_467E_8D1F_0F59B7E0AE26__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLDiagLocateView : public CELibrary  
{
public:
	static const int ALGORITHM_DEFAULT;

	static CDebug* dbg;
	static bool LocateDiagramElements(CFeynDiagram* diag, int AlgorithmID = -1, int DrawFlags=0);

	static void scale_diagram(CFeynDiagram* diag, double scale, CPos2D* scale_center = NULL);

protected:
	CFeynDiagram* m_diag;
	CKinematics* m_kin;

	int m_l_num;
	int m_v_num;

	CPos2D* m_center_pos;

	CLDiagLocateView(CFeynDiagram* diag, CKinematics* kin);
	virtual bool do_locate_vertices() = 0;
	virtual bool do_update_vertices() = 0;
	virtual bool do_locate_internal_lines();
	virtual void localize_external_lines(bool bFinalsToPoint=false, bool bInits=true, bool bFinals=true, bool bInitsToMargins=false);
	virtual int localize_final_lines_by(bool by_vertices); // (or by self) returns number of changed lines
	void scale_vertex_points(); // to 0:1 box
public:
	virtual ~CLDiagLocateView();
};

#endif // !defined(AFX_LDIAGLOCATEVIEW_H__03D261B1_929C_467E_8D1F_0F59B7E0AE26__INCLUDED_)
