////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LDiagTopologyInspector.h: interface for the CLDiagTopologyInspector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LDIAGTOPOLOGYINSPECTOR_H__3535D87C_4770_44E7_8363_AEBEFF675F25__INCLUDED_)
#define AFX_LDIAGTOPOLOGYINSPECTOR_H__3535D87C_4770_44E7_8363_AEBEFF675F25__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLDiagTopologyInspector : public CELibrary  
{
	CLDiagTopologyInspector();

public:
	virtual ~CLDiagTopologyInspector();

	static CDebug* dbg;

public:
	static const DWORD NON_EULER_CIRCUIT;
	static const DWORD LOOPS_IN_EXTERNAL_LINES;
	static const DWORD ODD_LINEAR_FERMION_LOOP;

	static void FilterDiagrams(CDiagramSet* diags, DWORD diag_type);
	static bool CheckDiagram(CFeynDiagram* diag, DWORD diag_type);
	static bool CheckOpSeq(CMEOperatorSeq* seq, DWORD diag_type);
	static void FilterSimilarDiagrams(CDiagramSet* diags, bool arrange_factors, bool use_arrange_libs);

	static void DropSimilarDiagrams(CDiagramSet* diags1, CDiagramSet* diags2, CDiagramSet* dropped_list);

private:
	// check entries
	static bool CheckNonEulerGraph(CFeynDiagram* diag);
	static bool CheckNonEulerOpSeq(CMEOperatorSeq* seq);
	static bool CheckLoopsInExtLines(CFeynDiagram* diag);
	static bool CheckOddLinearFermionLoop(CFeynDiagram* diag);

	////
	static void MarkDiagramElementAndLinks(CDElement* el);
	static void MarkOpSeqPoints(CMEOperatorSeq* seq, int point_ID, int* _marks);
	static bool CheckLoopsInExtLine(CDExtLine* ext_l);
	static bool CheckOddFermionLoop(CDLine* l, CDLine* l_start, int lines_num);
};

#endif // !defined(AFX_LDIAGTOPOLOGYINSPECTOR_H__3535D87C_4770_44E7_8363_AEBEFF675F25__INCLUDED_)
