////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LDrawDiagView.h: interface for the CLDrawDiagView class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LDRAWDIAGVIEW_H__155ED633_B416_4A3E_A7FC_953D88EFDA42__INCLUDED_)
#define AFX_LDRAWDIAGVIEW_H__155ED633_B416_4A3E_A7FC_953D88EFDA42__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLDrawDiagView : public CELibrary  
{
	// Currently processed diagram (may not be cloned/deleted)
	static CFeynDiagram* m_current_diag;

	CLDrawDiagView();
public:
	virtual ~CLDrawDiagView();

	// note: no diagrams may cloned/deleted here
	static CFeynDiagram* GetCurrentDiagram();
	// returns old link (old link should be restored after diagram is drawed)
	static CFeynDiagram* SetCurrentDiagram(CFeynDiagram* _diag);

public:
	static const int LINE_FERMION;
	static const int LINE_BOSON;
	static const int LINE_GLUON;
	static const int LINE_SCALAR;
	static const int LINE_NO_ARROW;

private:
	static int get_line_kind(int particle_kind);

	//static void add_line_settings(CEString* str, CEString* _line_caption, int particle_kind);
	//static void add_settings_restore(CEString* str, int particle_kind);
	static void add_line_caption(CEString* str, CEString* _line_caption, int particle_kind,
		int x1, int y1, int x2, int y2, int settings, int line_width);
	static void add_line_caption_arc(CEString* str, CEString* _line_caption, int particle_kind,
		int xc, int yc, int r, double f1, double f2, int settings, int line_width);
	static void add_counterterm_mark(CEString* str,
		int x1, int y1, int x2, int y2, int settings);
	static void add_counterterm_mark_arc(CEString* str,
		int xc, int yc, int r, double f1, double f2, int settings);

public:
	//static CEString* draw_diagram(CFeynDiagram* diag, unsigned width, unsigned height);

	static CEString* draw_diagram_line(int particle_kind,
		CPos2D* pos_from,
		CPos2D* pos_to,
		int settings,
		CEString* _line_caption,
		bool _draw_CT_line);

	static CEString* draw_diagram_line(int particle_kind,
		CPos2D* pos_from,
		CPos2D* pos_to,
		int settings,
		CEString* _line_caption,
		int repetition_no, int multiplicity,
		bool _draw_CT_line);
};

#endif // !defined(AFX_LDRAWDIAGVIEW_H__155ED633_B416_4A3E_A7FC_953D88EFDA42__INCLUDED_)
