////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// OpFermionField.h: interface for the COpFermionField class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPFERMIONFIELD_H__729F371F_0876_4632_969D_29F23F883B3C__INCLUDED_)
#define AFX_OPFERMIONFIELD_H__729F371F_0876_4632_969D_29F23F883B3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class COpFermionField : public CEFieldOperator  
{
	// Note: m_is_conjugated is false for \psi, true for \bar{\psi}
protected:
	COpFermionField(long _particle_kind,
		int _vertex_ID,
		unsigned long _point_ID,
		bool _is_conjugated,
		int _coupling_no, // 0 means operator is not part of a coupling
		bool _is_CT_coupling // truncated for uncoupled field
		);

public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
	virtual unsigned long props_long();
	virtual CExpression* clone() const;
	virtual bool equals(CExpression *other);
#ifdef PF_LESS_THAN
	virtual bool less_than(CExpression* other);
#endif //PF_LESS_THAN
	
	COpFermionField(long _particle_kind,
		int _vertex_ID,
		unsigned long _point_ID = 0, // default for the abstract hamiltonian
		bool _is_conjugated = false // false for \psi, true for \bar{\psi}
		);
	virtual ~COpFermionField();

	virtual bool MayBeCoupledWith(CEFieldOperator* fo);
	virtual bool CanBeCoupledExternal(CEParticle* part, bool is_initial, bool bCheckClassesOnly);
	virtual CExpression* GetExtParticleCoupling(CEParticle* part, bool is_initial, bool bClassesSource);
};

#endif // !defined(AFX_OPFERMIONFIELD_H__729F371F_0876_4632_969D_29F23F883B3C__INCLUDED_)
