////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MELib.cpp: implementation of the CMELib class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

CDebug* CMELib::dbg = new CDebug("CMELib");

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CMELib::CMELib() {}
CMELib::~CMELib() {}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

/*
*	Noamal form is:
*	Sum{ Prod{const (...)* \hat(u)* (any, not containing 'u')* u... }}
*	I.e. All the \hat{u}--u tails in first-level product.
*	ME is checked for this structure & is reduced if structure is wrong.
*	Returns true if structure is normalized.
*	Processed inline.
*/
bool CMELib::ToNormalForm(CMatrixElement* me) {
	if(me==NULL) return false;

	me->Arrange();

	//me = CExpression::arrge(expr_me);

	//dbg->log(0, "{Warning} CMELib::ToNormalForm() not implemented");
	//......

	return true;
}

bool CMELib::checkContainSpinors(CExpression* me_expr) {
	if(me_expr==NULL) return false;
	bool res = CRContainCheck::search(me_expr, CEProperties::PROP_MASK_IS_SPINOR);
	return res;
}
