////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// HEPLib.h: interface for the CHEPLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HEPLIB_H__171FC773_8583_41B4_948C_06A1925B5C14__INCLUDED_)
#define AFX_HEPLIB_H__171FC773_8583_41B4_948C_06A1925B5C14__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHEPLib : public CELibrary  
{
	static bool m_do_ur_reduce;
public:
	static CExpression* get_rule_difference(CExpression *source, CERule* rule);
	static CExpression* get_mass_correction(CExpression* source);
	static bool ur_reduce_perform(bool do_UR);
	static CExpression* ur_reduce(CExpression* val);
	static CExpression* repl_kin_invariants(CExpression* source, bool do_reduce = true);
	static CExpression* repl_similar_kin(CExpression* source, bool do_reduce = true);
	static CExpression* to_ultrarev(CExpression* source, bool log_reducing = false);

	//[unused]static CExpression* Calc_V_term(CExpression* born);
	//[unused]static CExpression* Calc_Born_Me();
	//[unused]static CExpression* Calc_Born(CExpression* born_me);
	//[unused]static CExpression* Calc_Box(CExpression* box_me, CExpression* box_dens, CExpression* born_me);

	static void sum_spins_adv(CExpression* source);
	static void sum_fermion_spins(CEProduct* seq);

	static CDebug* dbg;

	//[unused]static CExpression* couple_me(CExpression* me_a, CExpression* me_b, bool do_delete_input = true);

	CHEPLib();
	virtual ~CHEPLib();
};

#endif // !defined(AFX_HEPLIB_H__171FC773_8583_41B4_948C_06A1925B5C14__INCLUDED_)
