////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LDiagOpSeqRestore.h: interface for the CLDiagOpSeqRestore class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LDIAGOPSEQRESTORE_H__180914B2_FB3D_40C0_9112_B198F6FC700F__INCLUDED_)
#define AFX_LDIAGOPSEQRESTORE_H__180914B2_FB3D_40C0_9112_B198F6FC700F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLDiagOpSeqRestore : public CELibrary  
{
	CDiagramPhysics* m_phys;
	CKinematics* m_kin;
	CFeynDiagram* m_res_diag;
	CMEOperatorSeq* m_source;

	CLDiagOpSeqRestore(CDiagramPhysics* _phys, CKinematics* _kin);
	CFeynDiagram* RestoreDiagramImpl(CMEOperatorSeq* source);

	void CreateVerticesList();
	void BindExtLines();
	void CreateIntLines();
public:
	virtual ~CLDiagOpSeqRestore();

public:
	static CDebug* dbg;

public:
	static CFeynDiagram* RestoreDiagram(CMEOperatorSeq* source,
		CDiagramPhysics* _phys, CKinematics* _kin);
};

#endif // !defined(AFX_LDIAGOPSEQRESTORE_H__180914B2_FB3D_40C0_9112_B198F6FC700F__INCLUDED_)
