////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LFermionSpinSum.h: interface for the CLFermionSpinSum class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LFERMIONSPINSUM_H__1DDE0BE0_2C0F_4515_9767_E862DF223E9E__INCLUDED_)
#define AFX_LFERMIONSPINSUM_H__1DDE0BE0_2C0F_4515_9767_E862DF223E9E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLFermionSpinSum : public CELibrary  
{
	CSequence* m_spinor_couplings;
	CEProduct* m_sum_couplings_result;
public:
	static void sum_spins_in_product(CEProduct* source);
	static CDebug* dbg;
	static void sum_fermion_spins(CExpression* source);
	static CSequence* ExtractSpinorCouplings(CEProduct* source); // source to be changed

	static CLFermionSpinSum* LibInstance;

	virtual CEObject* doTask();
	CLFermionSpinSum();
	virtual ~CLFermionSpinSum();

private:
	CEProduct* extract_coupling(int i, bool delete_spinor_left, bool delete_spinor_right);
	CESpinor* get_bracket_spinor(int i, bool at_right);
	bool sum_spins_in_selected_couplings();
	void extract_spinor_couplings(CEProduct *seq);
	void finalize_processing();
	void init_processing();
	static CExpression* ExtractGellMannObjects(CEProduct *seq);

	// basic library implementation
	CSequence* extract_couplings_task_impl(CEProduct* seq);
	void sum_spins_task_impl(CEProduct* seq);
};

#endif // !defined(AFX_LFERMIONSPINSUM_H__1DDE0BE0_2C0F_4515_9767_E862DF223E9E__INCLUDED_)
