////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LFiertzTransform.h: interface for the CLFiertzTransform class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LFIERTZTRANSFORM_H__E8217536_8D2E_4093_A1C5_A695DD5C62BA__INCLUDED_)
#define AFX_LFIERTZTRANSFORM_H__E8217536_8D2E_4093_A1C5_A695DD5C62BA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLFiertzTransform : public CELibrary  
{
public:
	CLFiertzTransform();
	virtual ~CLFiertzTransform();

	static CDebug* dbg;

	// static entry, deletes source, source must be reduced!
	// turns Sp[2N+1]->0
	static CExpression* DoFiertzTransform(CExpression* src, DWORD* nApplied=NULL);

private:
	static CExpression* NormalizeTraces(CExpression* src); // source parser
	static CExpression* DoFTImpl(CExpression* src, DWORD* nApplied); // source parser
	static CExpression* DoFTImplCore(CFSp* sp1, int i1, CFSp* sp2, int i2); // does not affects input
	static CExpression* DoFTFormula(CFSp* sp1, bool gP1, CFSp* sp2, bool gP2); // does not affects input
};

#endif // !defined(AFX_LFIERTZTRANSFORM_H__E8217536_8D2E_4093_A1C5_A695DD5C62BA__INCLUDED_)
