////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LGammaSeqSimplify.h: interface for the CLGammaSeqSimplify class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LGAMMASEQSIMPLIFY_H__62627471_B2F4_4DF8_B7C3_601F39535EBC__INCLUDED_)
#define AFX_LGAMMASEQSIMPLIFY_H__62627471_B2F4_4DF8_B7C3_601F39535EBC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLGammaSeqSimplify : public CELibrary  
{
public:
	static CDebug* dbg;

	CLGammaSeqSimplify();
	virtual ~CLGammaSeqSimplify();

	static CKinematics* m_Kin;// updated at every simplify() call
	static CExpression* simplify(CExpression* source);

private:
	static CExpression* doSimplifyGS(CExpression* source);
	static bool is_to_move_right(long i, CEProduct *source);
	static bool is_to_move_left(long i, CEProduct *source);
	static bool expandPairs(CEProduct *source);
	static bool excangePair(CEProduct* source, long first_pos);
	static bool replacePairs(CEProduct* source);
	static CExpression* getPairSubst(CExpression* expr_a, CExpression* expr_b);
};

#endif // !defined(AFX_LGAMMASEQSIMPLIFY_H__62627471_B2F4_4DF8_B7C3_601F39535EBC__INCLUDED_)
