////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MELib.h: interface for the CMELib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MELIB_H__4130B61A_DFAF_4AFB_BBC8_6EA1175CF4E1__INCLUDED_)
#define AFX_MELIB_H__4130B61A_DFAF_4AFB_BBC8_6EA1175CF4E1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMELib : public CELibrary  
{
public:
	static CDebug* dbg;

public:
	CMELib();
	virtual ~CMELib();

	/*
	*	Noamal form is:
	*	Sum{ Prod{const (...)* \hat(u)* (any, not containing 'u')* u... }}
	*	I.e. All the \hat{u}--u tails in first-level product.
	*	ME is checked for this structure & is reduced if structure is wrong.
	*	Returns true if structure is normalized.
	*	Processed inline.
	*/
	static bool ToNormalForm(CMatrixElement* me);

	static bool checkContainSpinors(CExpression* me_expr);
};

#endif // !defined(AFX_MELIB_H__4130B61A_DFAF_4AFB_BBC8_6EA1175CF4E1__INCLUDED_)
