////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MEOpSeqLoopsLib.h: interface for the CMEOpSeqLoopsLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEOPSEQLOOPSLIB_H__E9871EE0_112E_4B2E_840C_925809BC910B__INCLUDED_)
#define AFX_MEOPSEQLOOPSLIB_H__E9871EE0_112E_4B2E_840C_925809BC910B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMEOpSeqLoopsLib : public CELibrary  
{
	CKinematics* m_kin;
	CMEOperatorSeq* m_seq;
	CEPtrArray* m_loops_data;
	CEPtrArray* m_route_data;
	CEPtrArray* m_point_go_marks; // internal marks

	CMEOpSeqLoopsLib(CMEOperatorSeq* seq, CKinematics* kin);
public:
	virtual ~CMEOpSeqLoopsLib();
	static CDebug* dbg;
	
	static CEPtrArray* GetLoopsData(CMEOperatorSeq* seq, CKinematics* kin);
	static void InverseLoop(CMESeqFORoute* loop_data);
	static bool CanBeInversed(CMESeqFORoute* loop_data);
	static bool CheckLoopOrder(CMESeqFORoute* loop_data, CMEOperatorSeq* seq, CKinematics* kin);
	static bool ValidateLoopData(CMESeqFORoute* loop_data); // internal check
	static bool HaveCommonLines(CEPtrArray* loops_data);

private:
	CEPtrArray* GetLoopsData();
	void CalcRoutesFromPoint(int pID, CEFieldOperator* fo_prev);
	CMESeqFORoute* GetRoutesLoop(CMESeqFORoute* r1, CMESeqFORoute* r2);
};

#endif // !defined(AFX_MEOPSEQLOOPSLIB_H__E9871EE0_112E_4B2E_840C_925809BC910B__INCLUDED_)
