////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// VIComposeLib.h: interface for the CVIComposeLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VICOMPOSELIB_H__386C3D87_D0F2_46D5_B7AC_668AF2C3FEA3__INCLUDED_)
#define AFX_VICOMPOSELIB_H__386C3D87_D0F2_46D5_B7AC_668AF2C3FEA3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVIComposeLib : public CELibrary  
{
	CExpression* m_source;
	CExpression* m_virt_sym;

	CSequence* m_NeutrinoMassSyms; // used to cache mass symboll

	bool m_error_flag;

	CEPtrArray* m_DENSDATA_cache;

	//CExpression* m_P_curr;

public:
	static CDebug* dbg;
	static CDebug* dbg_parsing;

	static CExpression* composeVI(CExpression* source, CExpression* virt_sym);
	static CExpression* composeVI(CVIDensData* dens_data, CExpression* num, CExpression* virt_sym);
	static CVirtIntegral* createVISeq(CSequence *dens_data, CSequence *_couplings, CEPtrArray* v_indices);
	static CVirtIntegral* createVI(CVIDensData* dens_data, CSequence* _couplings, CEPtrArray* v_indices);

	virtual ~CVIComposeLib();
private:
	CVIComposeLib(CExpression* source, CExpression* virt_sym);
	CExpression* do_compose();

	CExpression* parse_expr(CExpression* source);
	CExpression* parse_product(CEProduct* prod_source);

	CVIDensData* extract_denominators_data(CEProduct* prod_source);
	CSequence* parse_denominator(CExpression* den_expr);
	CExpression* get_coupled_mom(CESProduct* val);
	CExpression* decl_error(CExpression* expr_to_delete_1 = NULL, CExpression* expr_to_delete_2 = NULL,
		CExpression* expr_to_delete_3 = NULL, CExpression* expr_to_delete_4 = NULL);

	CExpression* composeVI_impl(CVIDensData* dens_data, CExpression* num, bool skip_DD_arrange);
};

#endif // !defined(AFX_VICOMPOSELIB_H__386C3D87_D0F2_46D5_B7AC_668AF2C3FEA3__INCLUDED_)
