////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// VIScalarCalcLib.h: interface for the CVIScalarCalcLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VISCALARCALCLIB_H__05DCC318_ED14_4AD4_8A2B_2BC769D5F2AD__INCLUDED_)
#define AFX_VISCALARCALCLIB_H__05DCC318_ED14_4AD4_8A2B_2BC769D5F2AD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVIScalarCalcLib : public CELibrary  
{
	CVIScalarCalcLib();

	static CECache* m_scalar_VI_cache;
	static bool m_init_OK;
	static CExpression* m_XI0_symbol; // UV-divergent parameter
	static CExpression* m_IR_symbol; // IR-divergent parameter
public:
	static CDebug* dbg;

public:
	static CExpression* CalcScalarVI(CExpression* src);
	static CExpression* CalcScalarVI_ruleImpl(CExpression* src, CEPtrArray* data_arr);
	static CExpression* CalcVI(CVirtInt0* src);
	static void init();
	static void finalize();
	static CECache* GetScalarVICache();
	static CExpression* getUVSymbol(); // returns not-cloned value (never NULL)
	static CExpression* getIRSymbol(); // returns not-cloned value (never NULL)

private:
	static CExpression* GetScalarVIValue(CVirtInt0* src);
	static CExpression* GetScalarA(CVIDensData* dd);
	static CExpression* GetScalarB(CVIDensData* dd);
	static CExpression* GetScalarC(CVIDensData* dd);
	static CExpression* GetScalarD(CVIDensData* dd);

	static CExpression* GetXiVal(CExpression* m);
	static CExpression* GetXiValR(CExpression* r);
	static CExpression* GetDChiralFormula(CExpression* m, CExpression* t, CExpression* s);

public:
	virtual ~CVIScalarCalcLib();
};

#endif // !defined(AFX_VISCALARCALCLIB_H__05DCC318_ED14_4AD4_8A2B_2BC769D5F2AD__INCLUDED_)
