////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// VirtInt0.h: interface for the CVirtInt0 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIRTINT0_H__138950B4_062E_4377_8FC9_E024D5EA2580__INCLUDED_)
#define AFX_VIRTINT0_H__138950B4_062E_4377_8FC9_E024D5EA2580__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DA0242
class CVirtInt0 : public CVirtIntegral  
{
	static CExpression* m_a0_to_m;

	bool m_Invariant_Dens;
	bool m_isNormalized;
	CVirtInt0(const CVIDensData* ddata, bool _Invariant_Dens, bool _isNormalized);
	void toInvariantDens(); // for internal calls (after arangement)
public:
	static void finalize();
	static CExpression* get_a0m_cpy();
	static CVirtInt0* createInvVI(CVIDensData* inv_dd);

	virtual CExpression* Arrange(int level);
	virtual CExpression* evaluate(int level = 0);
	virtual CEString* toString(int mode = 0);
	virtual CExpression* clone() const;
	virtual CEString* getTitleAdv(unsigned conventions, int mode);
	virtual bool equals(CExpression* other);

	CExpression* NormalizeVI(int arr_level);

	CVirtInt0(const CVIDensData* ddata);
	virtual ~CVirtInt0();
	virtual CEString* GetHEPId(); // "?" for undefined, "0","1","2",11,21,111 ...
	void ConvertInvariant(); // for external calls
	virtual CExpression* GetSingularTermFactor(); // NULL for unknown

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	static const char* CLASS_TAG_NAME;
	virtual const char* get_TAG_Name();
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);
};

#endif // !defined(AFX_VIRTINT0_H__138950B4_062E_4377_8FC9_E024D5EA2580__INCLUDED_)
