////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// VirtInt1.h: interface for the CVirtInt1 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIRTINT1_H__DDEEEA69_8989_4C77_8C7D_3E7AFDE2A12E__INCLUDED_)
#define AFX_VIRTINT1_H__DDEEEA69_8989_4C77_8C7D_3E7AFDE2A12E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DB0138
class CVirtInt1 : public CVirtIntegral  
{
	int m_num;
	int m_order; // 1 for B_1, 3 for D_111
public:
	virtual CExpression* clone() const;
	virtual CExpression* Arrange(int level);
	virtual CExpression* evaluate(int level = 0);
	virtual CEString* toString(int mode = 0);
	virtual bool equals(CExpression* other);
	CVirtInt1(const CVIDensData* ddata, int _order, int _num);
	virtual ~CVirtInt1();
	virtual CEString* GetHEPId(); // "?" for undefined, "0","1","2",11,21,111 ...
	virtual CEString* getTitleAdv(unsigned conventions, int mode);
	virtual CExpression* GetSingularTermFactor(); // NULL for unknown
	void ConvertInvariant(); // for external calls
	int GetVI1Num();
	int GetVI1Order();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	static const char* CLASS_TAG_NAME;
	virtual const char* get_TAG_Name();
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);
};

#endif // !defined(AFX_VIRTINT1_H__DDEEEA69_8989_4C77_8C7D_3E7AFDE2A12E__INCLUDED_)
