////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// VirtIntegralLib.h: interface for the CVirtIntegralLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIRTINTEGRALLIB_H__633A9300_F417_4523_A12B_C3048231AD7C__INCLUDED_)
#define AFX_VIRTINTEGRALLIB_H__633A9300_F417_4523_A12B_C3048231AD7C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D800BB
class CVirtIntegralLib : public CELibrary  
{
public:
	static CDebug* dbg;

	static void fill_data_storage();

	static CExpression* normalize_integral(CVIDensData* dens_data, CExpression* num, CExpression* virt_sym);

	static CExpression* get_stored(CVirtIntegral* vi);
	static void store_vi(CVirtIntegral* vi, CExpression* vi_val);

	static CExpression* Evaluate_VI1(CVirtInt1* vi); // for order == 2
	static bool EvaluateVISet1(CVIDensData* dens_data);
	static CExpression* Evaluate_VI2(CVirtInt1* vi); // for order == 2
	static bool EvaluateVISet2(CVIDensData* dens_data);

	static CExpression* ReduceTensorVI(CExpression* src);

	static CExpression* ConvertVI0ToInvForm(CExpression* src);
	static CExpression* ConvertVI0Inv_ruleImpl(CExpression* src, CEPtrArray* data_arr);

	CVirtIntegralLib();
	virtual ~CVirtIntegralLib();

private:
	static void batch_vi(CVirtIntegral* vi, CExpression* vi_val, bool do_delete_vi = true);
};

#endif // !defined(AFX_VIRTINTEGRALLIB_H__633A9300_F417_4523_A12B_C3048231AD7C__INCLUDED_)
