////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MatrixElement.h: interface for the CMatrixElement class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATRIXELEMENT_H__61449267_067A_404C_AC9A_55E9DF4292EB__INCLUDED_)
#define AFX_MATRIXELEMENT_H__61449267_067A_404C_AC9A_55E9DF4292EB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMatrixElement : public CESerializable  
{
	CExpression* m_expr_val;
	CEPtrArray* m_virt_momenta_list;
	CEPtrArray* m_external_vector_indices;

public:
	static CDebug* dbg;

private:
public:
	CMatrixElement(CExpression* expr_val, CEPtrArray* list_virt_momenta, CEPtrArray* external_vector_indices);
	virtual ~CMatrixElement();

	////////////////////////////////////////////////////////
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEObject* copy() const;
	virtual bool obj_equals(CEObject* other);
	virtual CMatrixElement* clone() const;
	virtual CEString* toString(int mode = 0);

	////////////////////////////////////////////////////////
	CExpression* get_expr_val();
	void set_expr_val(CExpression* _val);
	CEPtrArray* get_virt_momenta_list();
	CEPtrArray* get_external_indices_list();

	CExpression* get_ext_vector_index(int part_ID);

	void AppendCrossings(CEPtrArray* cross_infos);
	void ChangeVolatileIndices(bool do_not_change_ext_vec_indices = false);

	////////////////////////////////////////////////////////
	bool addME(CMatrixElement* other); // false if non-compartible ME are summed, other is always deleted
	bool equals(CMatrixElement* other);
	void Arrange();
};

#endif // !defined(AFX_MATRIXELEMENT_H__61449267_067A_404C_AC9A_55E9DF4292EB__INCLUDED_)
