////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// PBosonW.cpp: implementation of the CPBosonW class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPBosonW::CPBosonW(long _pk,
				   CExpression* _momentum_sym,
				   CExpression* _mass_sym,
				   CExpression* _pol_vec_sym,
				   int _ID_kin,
				   CEPtrArray* params)
: CPAbstractBoson(_pk, _momentum_sym, _mass_sym, _pol_vec_sym, _ID_kin)
{
	if (CLMath::abs(m_boson_pk) != CEParticle::PARTICLE_W_BOSON) {
		dbg->log(0, m_boson_pk, "Error W-boson initialization (invalid PK: %ld)");
		throw(new CEException(CEException::INT_ERROR));
	}
	m_init_OK = true;
}

CPBosonW::~CPBosonW() {}
