////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// PAbstractBoson.h: interface for the CPAbstractBoson class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PABSTRACTBOSON_H__925A235D_A675_4A9A_A95E_9A9035307CBB__INCLUDED_)
#define AFX_PABSTRACTBOSON_H__925A235D_A675_4A9A_A95E_9A9035307CBB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPAbstractBoson : public CEParticle  
{
	//CESymbol* m_pol_vec_sym;
	//CESymbol* m_pol_vec_cjg_sym;
	//int m_helicity;

protected:
	CExpression* m_vector_index;
	long m_boson_pk;

public:
	CExpression* get_vector_index();
	void reset_vector_index(bool do_create);

	virtual long get_PK();

	virtual CExpression* getDensityMatrix(CEPtrArray* vars);
	virtual CExpression* getHelicityVector(CExpression* vector_index);

protected:
	CPAbstractBoson(long _pk, CExpression* _momentum_sym, CExpression* _mass_sym, CExpression* _pol_vec_sym,
		int _ID_kin, CEValue* _mass = NULL);
public:
	virtual ~CPAbstractBoson();

public:
	static int m_MassiveVecMatrixType; //0(g_ab), 1(g_ab-kk/M2)(default)
	static bool SetMassiveVecMatrixType(int val); //0(g_ab), 1(g_ab-kk/M2)
};

#endif // !defined(AFX_PABSTRACTBOSON_H__925A235D_A675_4A9A_A95E_9A9035307CBB__INCLUDED_)
