////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// RParticeReplasement.cpp: implementation of the CRParticeReplasement class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRParticeReplasement::CRParticeReplasement(CEParticle* _part_a, CEParticle* _part_b) : CERule()
{
	m_part_a = _part_a;
	m_part_b = _part_b;
}

CRParticeReplasement::~CRParticeReplasement()
{
	// nothing to delete
}

CERule* CRParticeReplasement::GetRuleCopy() const { return new CRParticeReplasement(m_part_a, m_part_b); }

CEObject* CRParticeReplasement::copy() const {
	return new CRParticeReplasement(m_part_a, m_part_b);
}

CExpression* CRParticeReplasement::ApplyTo(CExpression* src, bool del_src) {
	return src;
}

CEParticle* CRParticeReplasement::part_a() {
	return m_part_a;
}

CEParticle* CRParticeReplasement::part_b() {
	return m_part_b;
}
