////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// QuarkMixMatrix.h: interface for the CQuarkMixMatrix class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUARKMIXMATRIX_H__4D265DC4_5ADF_417B_B8CD_EB27061E9461__INCLUDED_)
#define AFX_QUARKMIXMATRIX_H__4D265DC4_5ADF_417B_B8CD_EB27061E9461__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CQuarkMixMatrix : public CExpression  
{
	long m_quark_PK_1;
	long m_quark_PK_2;
public:
	CQuarkMixMatrix(long quark_PK_1, long quark_PK_2);
	virtual ~CQuarkMixMatrix();

	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CExpression* clone() const;
	virtual CEString* toString(int mode = 0);
	virtual bool equals(CExpression* other);

	long GetQuarkPK1();
	long GetQuarkPK2();

	// for shorted creation
	static CQuarkMixMatrix* CreateDU();
	static CQuarkMixMatrix* CreateDC();
	static CQuarkMixMatrix* CreateDT();
	static CQuarkMixMatrix* CreateSU();
	static CQuarkMixMatrix* CreateSC();
	static CQuarkMixMatrix* CreateST();
	static CQuarkMixMatrix* CreateBU();
	static CQuarkMixMatrix* CreateBC();
	static CQuarkMixMatrix* CreateBT();

	static const char* CLASS_TAG_NAME;
	virtual const char* get_TAG_Name();
	virtual long store_stream(ofstream* p_ofs, DWORD settings);
	static CESerializable* restore_from_buffer(const char* data, long pos, CEMap* params, DWORD settings);

public:
	CExpression* ToSymbolForm();
	static CExpression* QMMConvertToSymbols(CExpression* src, bool del_src);
	static CExpression* QMMConvertSym_ruleImpl(CExpression* src, CEPtrArray* data_arr);
};

#endif // !defined(AFX_QUARKMIXMATRIX_H__4D265DC4_5ADF_417B_B8CD_EB27061E9461__INCLUDED_)
