////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ParticleWaveFunction.h: interface for the CParticleWaveFunction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARTICLEWAVEFUNCTION_H__476A4E7A_AE6B_4538_AC81_31DAE0A87F97__INCLUDED_)
#define AFX_PARTICLEWAVEFUNCTION_H__476A4E7A_AE6B_4538_AC81_31DAE0A87F97__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CParticleWaveFunction : public CEParticleFunction  
{
protected:
	CExpression* m_momentum_sym; // the only particle indentifier

protected:
	// PK < 0 means antiparticle for fermions
	CParticleWaveFunction(long _particle_kind, int _vertex_ID, unsigned long _point_ID, CExpression* _momentum_sym);

public:
	virtual ~CParticleWaveFunction();

public:
	static CDebug* dbg;
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
	virtual unsigned long props_long();
	virtual bool equals(CExpression *other);
	//virtual bool less_than(CExpression* other);
	virtual CExpression* conjugated(int mode = 0);
	virtual CExpression* applyRule(CEAbstractRule* rule);

	virtual long getLogicalPK();
	CExpression* getMomentumSym();
	void setMomentumSym(CExpression* mom_sym);
};

#endif // !defined(AFX_PARTICLEWAVEFUNCTION_H__476A4E7A_AE6B_4538_AC81_31DAE0A87F97__INCLUDED_)
