////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// WaveFuncBoson.h: interface for the CWaveFuncBoson class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEFUNCBOSON_H__233C027E_0945_4400_980D_862389A6CD79__INCLUDED_)
#define AFX_WAVEFUNCBOSON_H__233C027E_0945_4400_980D_862389A6CD79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWaveFuncBoson : public CParticleWaveFunction  
{
	CTIndex* m_vector_index;

public:
	// Note: NULL vector index means scalar particle wave function
	CWaveFuncBoson(long _particle_kind,
		int _vertex_ID,
		unsigned long _point_ID,
		CExpression* _momentum_sym,
		CTIndex* _vector_index);
	virtual ~CWaveFuncBoson();

public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	virtual CEString* toString(int mode = 0);
	virtual CExpression* clone() const;
	virtual bool equals(CExpression *other);
#ifdef PF_LESS_THAN
	virtual bool less_than(CExpression* other);
#endif //PF_LESS_THAN
	virtual CExpression* applyRule(CEAbstractRule* rule);
	CTIndex* getVectorIndex(); // Note: NULL vector index means scalar particle wave function
	bool isVectorBoson(); // (getVectorIndex() != NULL)
};

#endif // !defined(AFX_WAVEFUNCBOSON_H__233C027E_0945_4400_980D_862389A6CD79__INCLUDED_)
