////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// WaveFuncFermion.h: interface for the CWaveFuncFermion class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEFUNCFERMION_H__CB094D7E_2E5A_41B5_B053_F870B12677E8__INCLUDED_)
#define AFX_WAVEFUNCFERMION_H__CB094D7E_2E5A_41B5_B053_F870B12677E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CWaveFuncFermion : public CParticleWaveFunction  
{
public:
	// PK < 0 means conjugated wave function
	CWaveFuncFermion(long _particle_kind,
		int _vertex_ID,
		unsigned long _point_ID,
		CExpression* _momentum_sym);
	virtual ~CWaveFuncFermion();

public:
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual CEString* toString(int mode = 0);
	virtual void collectProperties(CEProperties* props, unsigned set = CEProperties::PROP_MASK_ALL);
	virtual unsigned long props_long();
	virtual CExpression* clone() const;
	bool isConjugated();

#ifdef PF_LESS_THAN
	virtual bool less_than(CExpression* other);
#endif //PF_LESS_THAN
};

#endif // !defined(AFX_WAVEFUNCFERMION_H__CB094D7E_2E5A_41B5_B053_F870B12677E8__INCLUDED_)
