////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// MathFileParser.h: interface for the CMathFileParser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MATHFILEPARSER_H__EF43FDCD_A734_4841_8AD6_AAB19041D085__INCLUDED_)
#define AFX_MATHFILEPARSER_H__EF43FDCD_A734_4841_8AD6_AAB19041D085__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMathFileParser : public CFileParserAdv  
{
public:
	CMathFileParser(const char* _source);
	virtual ~CMathFileParser();

	bool m_bUseRHand2Equs; // involve "==" as right-handed operation

protected:
	/*
	*	Used to modify read value in childs, called in read_next_operand().
	*	Returns 'false' to drop operand and call read_next_operand() again.
	*/
	virtual bool OnNewOperandRead(CENamedItem* item);
};

#endif // !defined(AFX_MATHFILEPARSER_H__EF43FDCD_A734_4841_8AD6_AAB19041D085__INCLUDED_)
