////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ParserSymbolsList.h: interface for the CParserSymbolsList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PARSERSYMBOLSLIST_H__9F451080_0DA8_11D8_9A76_908726B77B35__INCLUDED_)
#define AFX_PARSERSYMBOLSLIST_H__9F451080_0DA8_11D8_9A76_908726B77B35__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CParserSymbolsList : public CEObject  
{
	CEString* m_symbols_list;
	CEString* m_symbols_posterior;
	int m_symbols_type;// named type of symbols in list
	int m_list_spec;
	int m_spec_posterior;
	int m_read_mode;
public:
	static const int LIST_ORDINARY;
	static const int LIST_NUMBERS;
	static const int LIST_SYMBOLS;

	static const int READ_BY_STRING;
	static const int READ_BY_SYMBOL;

	static CParserSymbolsList* create_list(int type, const char* syms_string, int read_mode);
	static CParserSymbolsList* create_list(int type, int spec, int read_mode);
	static CParserSymbolsList* create_list(int type, int spec, const char* syms_string, int read_mode);
	static CParserSymbolsList* create_list(int type,
		int spec, const char* syms_string,
		int spec_posterior, const char* syms_posterior, // additional symbols that may occur in string
		int read_mode);

	bool contain_symbol(char sym, bool is_posterior_sym = false);
	int get_symbols_type();
	int get_read_mode();

	virtual ~CParserSymbolsList();
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
private:
	CParserSymbolsList(int _type, CEString* _symbols, int _spec,
		CEString* _syms_posterior, int _spec_posterior, int read_mode);
};

#endif // !defined(AFX_PARSERSYMBOLSLIST_H__9F451080_0DA8_11D8_9A76_908726B77B35__INCLUDED_)
