////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// AbstractGenerator.h: interface for the CAbstractGenerator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ABSTRACTGENERATOR_H__421AC0E0_4F17_11D6_BF5F_B9EE23B08735__INCLUDED_)
#define AFX_ABSTRACTGENERATOR_H__421AC0E0_4F17_11D6_BF5F_B9EE23B08735__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//##ModelId=3E3FF2CA01D4
class CAbstractGenerator : public CEAbstractTask  
{
	//##ModelId=3E3FF2CA0227
	static CDebug* dbg;
	//##ModelId=3E3FF2CA0222
	CEValue* zero;
	//##ModelId=3E3FF2CA021A
	CEValue* one;
	//##ModelId=3E3FF2CA0215
	CEValue* two;
	//##ModelId=3E3FF2CA020A
	CEValue* half;
	//##ModelId=3E3FF2CA0205
	CEValue* pi;
	//##ModelId=3E3FF2CA0200
	CEValue* two_pi;
	//##ModelId=3E3FF2CA01FB
	CEValue* cfn;

	//##ModelId=3E3FF2CA01F6
	CEPtrArray* m_smin;
	//##ModelId=3E3FF2CA01F0
	CEValue* m_s2min;
	//##ModelId=3E3FF2CA01EB
	CEValue* m_ph_f;
	//##ModelId=3E3FF2CA01E6
	CENumVector* m_p_in;
	//##ModelId=3E3FF2CA01DD
	CEValue* m_s;
	//CEPtrArray* m_q;

	//##ModelId=3E3FF2CA01D8
	CEValue* m_rand_prev;
public:
	virtual void load_event();
	void log_event();
	void compare_cs(CEPtrArray* p_cs, int num_evnts = 1);
	//##ModelId=3E3FF2CA02EE
	virtual bool cut_event(CKinematics* kin);
	//##ModelId=3E3FF2CA02BF
	void fill_hs(CExpression* cs, long num_events, CEHistogram* hs, int bank=0, bool do_delete_cs = true);
	//##ModelId=3E3FF2CA02A0
	double mid(CExpression *cs, long num_events, bool do_delete_cs);
	//##ModelId=3E3FF2CA0281
	static CEValue* maxx(CEValue* a, CEValue* b, bool do_delete = true);
	//##ModelId=3E3FF2CA0271
	static CEValue* minx(CEValue* a, CEValue* b, bool do_delete = true);
	//##ModelId=3E3FF2CA0263
	virtual CEValue* rand_next();
	//##ModelId=3E3FF2CA0262
	virtual CEObject* doTask();
	//##ModelId=3E3FF2CA0264
	virtual CEValue* rand_next(CEValue* prev);
	//##ModelId=3E3FF2CA0261
	CAbstractGenerator();
	//##ModelId=3E3FF2CA0252
	virtual ~CAbstractGenerator();

protected:
	//##ModelId=3E3FF2CA0242
	void log_item(int p, CExpression* item, bool do_delete = true);
	//##ModelId=3E3FF2CA0236
	CEValue* _zero();
	//##ModelId=3E3FF2CA0235
	CEValue* _one();
	//##ModelId=3E3FF2CA0234
	CEValue* _two();
	//##ModelId=3E3FF2CA0233
	void init_smin();
	//##ModelId=3E3FF2CA0232
	virtual bool generate_event();
private:
	//##ModelId=3E3FF2CA022A
	CEValue* get_smin(int i);
};

#endif // !defined(AFX_ABSTRACTGENERATOR_H__421AC0E0_4F17_11D6_BF5F_B9EE23B08735__INCLUDED_)
