////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DiracAlgebra.h: interface for the CDiracAlgebra class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIRACALGEBRA_H__68F91597_65A6_4F1A_A381_82C2851F43A8__INCLUDED_)
#define AFX_DIRACALGEBRA_H__68F91597_65A6_4F1A_A381_82C2851F43A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2DB02CE
class CDiracAlgebra : public CELibrary  
{
public:
	//##ModelId=3E3FF2DB0326
	static CExpression* simplify(CExpression* source);
	//##ModelId=3E3FF2DB02E1
	static CDebug* dbg;
	//##ModelId=3E3FF2DB0324
	static CExpression* gammaPM(bool sign);
	//##ModelId=3E3FF2DB031D
	static CExpression* get_3Gamma_Gamma5_subst(CExpression* ind1, bool cov1, CExpression* ind2, bool cov2, CExpression* ind3, bool cov3);
	//##ModelId=3E3FF2DB0319
	static bool arrangeGammaSpecial(CEProduct* seq);
	//##ModelId=3E3FF2DB0317
	static bool expandGammaProducts(CEProduct* data);
	//##ModelId=3E3FF2DB0313
	static bool expandPairs(CEProduct *source, CExpression *left, CExpression *right);
	//##ModelId=3E3FF2DB0310
	static bool excangePair(CEProduct* source, long first_pos);
	//##ModelId=3E3FF2DB0309
	static bool expandTriples(CEProduct* source, CExpression* left, CExpression* right);
	//##ModelId=3E3FF2DB0305
	static bool checkupBounds(CEProduct* seq, CExpression* left, CExpression* right);
	//##ModelId=3E3FF2DB0303
	static bool replacePairs(CEProduct* source);
	//##ModelId=3E3FF2DB02FF
	static CExpression* simplifyGammaSequence(CExpression* seq, CExpression* left, CExpression* right);
	//##ModelId=3E3FF2DB02FD
	static CExpression* Sp(CExpression* seq);
	//##ModelId=3E3FF2DB02FA
	CDiracAlgebra();
	//##ModelId=3E3FF2DB02F9
	virtual ~CDiracAlgebra();

protected:
	//##ModelId=3E3FF2DB02F6
	static CExpression* getPairSubst(CExpression* expr_a, CExpression* expr_b);
	//##ModelId=3E3FF2DB02F2
	static CExpression* doSimplifyGS(CExpression* source, CExpression* left, CExpression* right);
private:
	//##ModelId=3E3FF2DB02EE
	static bool is_to_move_right(long i, CEProduct *source, CExpression *border);
	//##ModelId=3E3FF2DB02E4
	static bool is_to_move_left(long i, CEProduct *source, CExpression *border);
};

#endif // !defined(AFX_DIRACALGEBRA_H__68F91597_65A6_4F1A_A381_82C2851F43A8__INCLUDED_)
