////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ENumVector.h: interface for the CENumVector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENUMVECTOR_H__04E97E83_4FBE_11D6_BF5F_FF4201E2DF5B__INCLUDED_)
#define AFX_ENUMVECTOR_H__04E97E83_4FBE_11D6_BF5F_FF4201E2DF5B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//##ModelId=3E3FF2DF005D
class CENumVector : public CSequence  
{
	//##ModelId=3E3FF2DF006F
	CEValue* m_mass;
	//##ModelId=3E3FF2DF0061
	static CDebug* dbg;
public:
	//##ModelId=3E3FF2DF00A2
	bool is_rest();
	//##ModelId=3E3FF2DF00A1
	void inverse_direction();
	//##ModelId=3E3FF2DF009F
	void lork0(CENumVector* k);
	//##ModelId=3E3FF2DF009D
	void lor0k(CENumVector* k);
	//##ModelId=3E3FF2DF0096
	double angle_cos(CENumVector* other);
	//##ModelId=3E3FF2DF0094
	virtual CEString* toString(int mode = 0);
	//##ModelId=3E3FF2DF0092
	void copy_values_from(CENumVector* other);
	//##ModelId=3E3FF2DF0091
	CEValue* square();
	//##ModelId=3E3FF2DF0090
	CENumVector* num_stub();

	//##ModelId=3E3FF2DF008E
	void set_mass(CEValue* m);
	//##ModelId=3E3FF2DF008D
	CEValue* mass();
	//##ModelId=3E3FF2DF008C
	CExpression* squarevector();
	//##ModelId=3E3FF2DF0084
	CExpression* couple(CENumVector* other, bool delete_other = true);
	//##ModelId=3E3FF2DF0081
	void addvector(CENumVector* other, bool delete_other = true);
	//##ModelId=3E3FF2DF007E
	void substvector(CENumVector* other, bool delete_other = true);
	//##ModelId=3E3FF2DF007D
	virtual CExpression* clone() const;
	//##ModelId=3E3FF2DF0073
	CENumVector(CEValue* _mass = NULL);

#ifdef USE_PLAIN_ARRAY_FORSEQ // biuld sequence-expressions on CAPtrArray* basis
	CENumVector(CEPtrArray* pPtrArray, CEValue* _mass = NULL);
#else
	CENumVector(CAPtrSeq* pPtrArray, CEValue* _mass = NULL);
#endif //USE_PLAIN_ARRAY_FORSEQ
	
	virtual ~CENumVector();

};

#endif // !defined(AFX_ENUMVECTOR_H__04E97E83_4FBE_11D6_BF5F_FF4201E2DF5B__INCLUDED_)
