////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// FeynLib.h: interface for the CFeynLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FEYNLIB_H__E5501340_03E6_11D6_8A94_C396077DC82A__INCLUDED_)
#define AFX_FEYNLIB_H__E5501340_03E6_11D6_8A94_C396077DC82A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D7036B
class CFeynLib : public CELibrary  
{
public:
	//##ModelId=3E3FF2D703B5
	static double total_cs(double mid_me_sqr, double csm_en, double m);
	//##ModelId=3E3FF2D703AC
	static CExpression* boson_vertex(CExpression* b1, CExpression* b2, CExpression* i1, bool c1, CExpression* i2, bool c2, CExpression* i3, bool c3);
	//##ModelId=3E3FF2D703A5
	static CExpression* boson_propagator(CExpression *base, CExpression* m, CExpression* ind1, bool c1, CExpression* ind2, bool c2);
	//##ModelId=3E3FF2D7039F
	static CExpression* matr_el(CExpression* in1, CExpression* in2, CExpression* f1, CExpression* f2, CExpression* f3);
	//##ModelId=3E3FF2D70397
	static CExpression* compose_matrix_element(CExpression* inda, CExpression* indb, CExpression* indk);
	//##ModelId=3E3FF2D70396
	static CExpression* test2();
	//##ModelId=3E3FF2D7039C
	static CExpression* compose_matrix_element(CExpression* inda, CExpression* indb);
	//##ModelId=3E3FF2D7036F
	static CDebug* dbg;
	//##ModelId=3E3FF2D7038F
	static CExpression* phot_helisity(CExpression* base, CExpression* v1, CExpression* v2, bool sign, CExpression* ind, bool cov);
	//##ModelId=3E3FF2D7038C
	static CExpression* ferm_matrix(CExpression* base, int helisity = 0);
	//##ModelId=3E3FF2D70380
	static CExpression* phot_helisity_gamma(CExpression* base, CExpression* v1, CExpression* v2, bool sign);
	//##ModelId=3E3FF2D7037F
	static CExpression* test();
	//##ModelId=3E3FF2D7037C
	static CExpression* ferm_propagator(CExpression* base, CExpression* m);
	//##ModelId=3E3FF2D7037B
	CFeynLib();
	//##ModelId=3E3FF2D7037A
	virtual ~CFeynLib();

};

#endif // !defined(AFX_FEYNLIB_H__E5501340_03E6_11D6_8A94_C396077DC82A__INCLUDED_)
