////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// SubstSimplify.h: interface for the CSubstSimplify class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SUBSTSIMPLIFY_H__39A38088_A42F_427C_B8D2_9EFAADC12DCF__INCLUDED_)
#define AFX_SUBSTSIMPLIFY_H__39A38088_A42F_427C_B8D2_9EFAADC12DCF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D302AF
class CSubstSimplify : public CELibrary  
{
	static int m_SIMP_SUM_LOOP_LEVEL; // Note: multi-sequence simplification is destroyed
public:
	//##ModelId=3E3FF2D302B3
	static CDebug* dbg;
	//##ModelId=3E3FF2D302D1
	static CExpression* simp_kin(CExpression* source, bool u_rev);
	//##ModelId=3E3FF2D302C8
	static CExpression* simp(CExpression* source, CEReplList* repls, bool do_del_repls);
	//##ModelId=3E3FF2D302C7
	CSubstSimplify();
	//##ModelId=3E3FF2D302C6
	virtual ~CSubstSimplify();
	
	static CExpression* SimpRepl(CExpression* source, CEReplList* r_simp_set,
		CERule* r_env = NULL,
		int loop_level = 1,
		bool bFast=false // simplify small objects only
		);
	static CExpression* SimpSumRuleProc(CExpression* src, CEPtrArray* data_arr);

private:
	static CExpression* SimpSumRuleProcImpl(CExpression* src,
		CEReplList* r_simp_set,
		CERule* r_env,
		int* rules_used_info,
		int loop_cnt=1);

	//##ModelId=3E3FF2D302C2
	static CExpression* simp_sums(CExpression *source, CEReplList *repls, bool del_src);
	//##ModelId=3E3FF2D302BF
	static bool is_a_simplier_b(CExpression* a, CExpression* b);
};

#endif // !defined(AFX_SUBSTSIMPLIFY_H__39A38088_A42F_427C_B8D2_9EFAADC12DCF__INCLUDED_)
