////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ElasticKinematics.h: interface for the CElasticKinematics class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ELASTICKINEMATICS_H__E3B01323_C06B_4D93_8D0F_44106883F5C4__INCLUDED_)
#define AFX_ELASTICKINEMATICS_H__E3B01323_C06B_4D93_8D0F_44106883F5C4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D6038A
class CElasticKinematics : public CKinematics  
{
public:
	//##ModelId=3E3FF2D603A3
	virtual CEReplList* getReplacements(int type);
	//##ModelId=3E3FF2D603A1
	virtual void set_CMS_energy(double energy);
	//##ModelId=3E3FF2D603A0
	virtual void fill_data_storage();
	//##ModelId=3E3FF2D6039E
	virtual void InitVectors(double energy);
	//##ModelId=3E3FF2D6039C
	virtual CExpression* getEqual(CExpression* expr);
	//##ModelId=3E3FF2D6039A
	virtual bool isPrimary(CExpression* expr);
	//##ModelId=3E3FF2D60399
	CElasticKinematics();
	//##ModelId=3E3FF2D6038C
	virtual ~CElasticKinematics();

};

#endif // !defined(AFX_ELASTICKINEMATICS_H__E3B01323_C06B_4D93_8D0F_44106883F5C4__INCLUDED_)
