////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// FourParticleKinematics.h: interface for the CFourParticleKinematics class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FOURPARTICLEKINEMATICS_H__B5940610_16C5_4E8B_85DE_0EA9221AD389__INCLUDED_)
#define AFX_FOURPARTICLEKINEMATICS_H__B5940610_16C5_4E8B_85DE_0EA9221AD389__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFourParticleKinematics : public CKinematics  
{
public:
	CFourParticleKinematics();
	virtual ~CFourParticleKinematics();

	virtual void set_CMS_energy(double energy);
	virtual void fill_data_storage();
	virtual void InitVectors(double energy);
	virtual CExpression* getEqual(CExpression* expr);
	virtual bool isPrimary(CExpression* expr);	
	virtual CEReplList* getReplacements(int type);
};

#endif // !defined(AFX_FOURPARTICLEKINEMATICS_H__B5940610_16C5_4E8B_85DE_0EA9221AD389__INCLUDED_)
