////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// GeneralKinematics.h: interface for the CGeneralKinematics class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENERALKINEMATICS_H__46B4BE71_0556_49E7_9043_AD9B64F129E0__INCLUDED_)
#define AFX_GENERALKINEMATICS_H__46B4BE71_0556_49E7_9043_AD9B64F129E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CGeneralKinematics : public CKinematics  
{
public:
	int init_kin(CEPtrArray* args);
	CGeneralKinematics();
	virtual ~CGeneralKinematics();

	virtual CEReplList* getReplacements(int type);
	virtual void set_CMS_energy(double energy);
	virtual void fill_data_storage();
	virtual void InitVectors(double energy);
	virtual CExpression* getEqual(CExpression* expr);
	virtual bool isPrimary(CExpression* expr);

	virtual int checkExprSign(CExpression* expr); // 0 for unknown result
};

#endif // !defined(AFX_GENERALKINEMATICS_H__46B4BE71_0556_49E7_9043_AD9B64F129E0__INCLUDED_)
