////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// DenCacheLib.h: interface for the CDenCacheLib class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DENCACHELIB_H__9A620F85_0F4A_409C_8FC8_018A767D032E__INCLUDED_)
#define AFX_DENCACHELIB_H__9A620F85_0F4A_409C_8FC8_018A767D032E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDenCacheLib : public CELibrary  
{
	CEPtrArray* m_denominators_cache;
	CERule* m_simpl_rule;

	bool m_isSimplified; // to avoid double-simplification
public:
	CDenCacheLib();
	virtual ~CDenCacheLib();
	static CDebug* dbg;
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);

	void AddSimplRule(CERule* r); // rule object is unaffected

	CExpression* InvolveDenominatorsCache(CExpression* val);
	void SimplifyCachedDenominators();
	CExpression* RestoreDenominators(CExpression* val);
};

#endif // !defined(AFX_DENCACHELIB_H__9A620F85_0F4A_409C_8FC8_018A767D032E__INCLUDED_)
