////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// LFactor.h: interface for the CLFactor class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LFACTOR_H__62479BC7_4EDC_4D98_87C1_1A4DDB61621B__INCLUDED_)
#define AFX_LFACTOR_H__62479BC7_4EDC_4D98_87C1_1A4DDB61621B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CLFactor : public CELibrary  
{
public:
	static const DWORD DONOT_FACT_NUMBERS;
	static const DWORD DONOT_FACT_FRACTIONS;
	static const DWORD FACT_ALL_DENOMINATORS;
	static const DWORD FACT_ALL_SINGLE_DENS; // but not factorize sums
	static const DWORD FACT_VERIFY;
	static const DWORD NO_EXPAND; // forced & not checked

	static CDebug* dbg;

	static CExpression* factor_simple(CExpression* source);//OLD
	CLFactor();
	virtual ~CLFactor();
	
	static CExpression* factorize(CExpression *source, DWORD settings = 0);

	static CExpression* extract_common_factors(CExpression *expr_a, CEProduct *prod_b, CEProduct *prod_common, DWORD settings);

	static CENumber* get_greatest_common_divisor(CENumber* a,
		CENumber* b,
		DWORD settings,
		bool treat_NULL_as_unit = false);

private:
	static CExpression* lower_power_on(CEPower* expr, bool is_inversed, long order);
	static CEProduct* update_factor(CExpression* item, CEProduct* factor, DWORD settings);
	static CExpression* factor_impl(CExpression* source, DWORD settings);
	static CENumber* calc_num_factor(CENumber* num_factor_old, CENumber* num);
	static CExpression* extract_common_factors_impl(CExpression *expr_a, CEProduct *prod_b, CEProduct *prod_common, DWORD settings);
	static bool allow_fact(CExpression *expr, DWORD settings); // note: settings should have FACT_SINGLE_DENOMINATORS or FACT_ALL_DENOMINATORS flag
};

#endif // !defined(AFX_LFACTOR_H__62479BC7_4EDC_4D98_87C1_1A4DDB61621B__INCLUDED_)
