////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ViewSimplify.h: interface for the CViewSimplify class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIEWSIMPLIFY_H__BBC09E0C_E288_4910_A75D_1477E94611B6__INCLUDED_)
#define AFX_VIEWSIMPLIFY_H__BBC09E0C_E288_4910_A75D_1477E94611B6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D10232
class CViewSimplify : public CELibrary  
{
	static CExpression* m_Unit;
public:
	static CDebug* dbg;
	
	CViewSimplify();
	virtual ~CViewSimplify();

	static const DWORD PART_FACT_NUMBERS;
	static const DWORD PART_FACT_FUNCTIONS;
	static const DWORD PART_FACT_DENOMINATORS;
	static const DWORD PART_FACT_ALL_DENOMINATORS; // involves appropriate flag of CLFactor library
	static const DWORD PART_FACT_ALL_SINGLE_DENS; // involves appropriate flag of CLFactor library
	static const DWORD PART_FACT_NUMERATORS;
	static const DWORD PART_FACT_DEFAULT;// no numbers
	static const DWORD PART_FACT_ALL;
	static const DWORD PART_FACT_VERIFY;
	static CExpression* factorize_partial(CExpression* source, DWORD settings, CSequence* f_syms=NULL);
	static CSequence* m_FactSyms; // (volatile link)

	static CExpression* simp_vi_view(CExpression* source, bool del_src, bool u_rev);
	static CExpression* simp_view(CExpression* old, bool u_rev, bool do_reduce_old = true);

private:
	static CExpression* fact_part_impl(CExpression *source, DWORD settings);
	static CExpression* fact_part_prod(CEProduct* pr, DWORD settings);
	static CExpression* fact_part_sum(CESum *ssum, DWORD settings);
	static void update_factors_list(CExpression* item, CEPtrArray* factors, bool item_lev, DWORD settings);
	static CExpression* extract_factor_from(CExpression* item, CExpression* factor, bool item_lev, DWORD settings);
};

#endif // !defined(AFX_VIEWSIMPLIFY_H__BBC09E0C_E288_4910_A75D_1477E94611B6__INCLUDED_)
