////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ScriptErrors.h: interface for the CScriptErrors class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTERRORS_H__39CA6E54_896F_4198_BE5B_043FDAE601C8__INCLUDED_)
#define AFX_SCRIPTERRORS_H__39CA6E54_896F_4198_BE5B_043FDAE601C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScriptErrors : public CELibrary  
{
public:
	CScriptErrors();
	virtual ~CScriptErrors();

	static const int UNCOUNTED_ERROR;
	static const int ILLEGAL_OPERATION;
	static const int NULL_OBJECT;
	static const int UNDEFINED_OBJECT;
	static const int INTERNAL_ERROR;
	static const int UNKNOWN_FUNCTION;
	static const int STATEMENT_ILLEGAL;
	static const int PARAMETER_INVALID;
	static const int PARAMETERS_NUMBER_INVALID;
	static const int HALT_COMMAND;

	static CEString* getStringMessage(int err_id, int i_param);
	static bool isBreakError(int err_id); // breaks are on errors & halt commands
};

#endif // !defined(AFX_SCRIPTERRORS_H__39CA6E54_896F_4198_BE5B_043FDAE601C8__INCLUDED_)
