////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ScriptException.h: interface for the CScriptException class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTEXCEPTION_H__8E9934F7_013A_4C01_B841_2D01650364AD__INCLUDED_)
#define AFX_SCRIPTEXCEPTION_H__8E9934F7_013A_4C01_B841_2D01650364AD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScriptException : public CEException  
{
	int m_id;
	int m_line;
	int m_line_pos;
	int m_i_param;
	char* m_c_param;

public:
	CScriptException(int id, int line, int line_pos, int i_param = -1, const char* c_param = NULL);
	virtual ~CScriptException();
	virtual bool isErrorBreak();
	static const char* CLASS_NAME;
	virtual const char* ClassName() const;
	virtual bool contain_vector(void * obj);
	
	virtual int getErrCode();
	int get_iParam();
	const char* get_cParam();
};

#endif // !defined(AFX_SCRIPTEXCEPTION_H__8E9934F7_013A_4C01_B841_2D01650364AD__INCLUDED_)
