////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ScriptFuncInfo.h: interface for the CScriptFuncInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTFUNCINFO_H__22818B67_FDCF_4B76_B50E_7154B13C1570__INCLUDED_)
#define AFX_SCRIPTFUNCINFO_H__22818B67_FDCF_4B76_B50E_7154B13C1570__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScriptFuncInfo : public CESerializable  
{
	CEPtrArray* (*m_pFunction)(CEPtrArray*); // function pointer, NULL means system function
	int m_args_num;
	int* m_args_type;
	int m_args_min_number;

	char* m_title;

public:
	static const char* CLASS_NAME;
	static const unsigned ERROR_HALT_FLAG;

	static CScriptFuncInfo* createFuncInfo(const char* f_title, void* p_func, int args_num, int min_args_number, ...);

private:
	CScriptFuncInfo(const char* f_title, void* p_func, int args_num, int min_args_number, int* args_type);

public:
	virtual ~CScriptFuncInfo();

	virtual CEString* toString(int mode = 0);
	virtual const char* ClassName() const;
	virtual CEObject* copy() const;
	virtual CScriptFuncInfo* clone() const;
	
	int check_args(CEPtrArray* args);
	CEPtrArray* invoke_function(CEPtrArray* args, bool do_check_args);
	bool isSystemFunction();
	const char* GetFuncTitle();

	// utilites
	static CEPtrArray* FReturnError(CEPtrArray* arg_list, int code);
	static CEPtrArray* FReturnInvalidParam(int parNo, CEPtrArray* arg_list);
};

#endif // !defined(AFX_SCRIPTFUNCINFO_H__22818B67_FDCF_4B76_B50E_7154B13C1570__INCLUDED_)
