////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESupport.h: interface for the CESupport class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESUPPORT_H__53236075_988A_42A7_819F_A17DAEBD70B4__INCLUDED_)
#define AFX_ESUPPORT_H__53236075_988A_42A7_819F_A17DAEBD70B4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D1002E
class CESupport : public CEObject  
{
	static CEMap* m_XML_tag_reference;
public:
	static CDebug* dbg;

	static long fing_item_end_pos(const char *data, const char *item_tag_name, long pos_after_tag);
	static const DWORD SERIAL_EXPRESSION;
	static const DWORD SERIAL_VERIFY;

	static void init_XML_TAG_structure();
	static CESerializable* read_file(const char *fn, DWORD settings);
	static CESerializable* read_buffer(const char *data, long pos, DWORD settings);
	static long skip_item_in_buffer(const char *data, long pos, DWORD settings);
	static void store(CESerializable* data, const char* fn, DWORD settings = 0);
	static long store_stream(CESerializable* data, ofstream* p_ofs, DWORD settings);
	static long store_flags_map(ofstream* p_ofs, CEMap* f_map);

	static long storeXMLLong(long val, ofstream* p_ofs, DWORD settings); // as CENumber
	static long storeLineBreak(ofstream* p_ofs); // returns number of bytes stored (1 or 2)

	// NoObjectOk means NO ERROR MESSAGE are reqiured if no object (of any type) are found.
	static bool readXMLLong(const char* data, long* ppos, long* pres, DWORD settings, const char* obj_id = NULL, bool NoObjectOk=false);// updates pos if success
	static CExpression* readXMLExpr(const char* data, long* ppos, DWORD settings, const char* obj_id = NULL, bool NoObjectOk=false);// updates pos if success
	static CESerializable* readXMLObj(const char* data, long* ppos, const char* check_CN, DWORD settings, const char* caller_id = NULL, bool NoObjectOk=false);// updates pos if success

	static bool checkAllRead(const char* data, long* ppos, DWORD settings, const char* caller_id = NULL);

	static void PrintLogoPage(); // to console output
	static void CreateVersionString(CEString* str); // "ALHEP 1.1.2"

	//##ModelId=3E3FF2D10044
	static void Save(CEString* s);
	static void savetex(CESerializable* obj);
	static void SaveGraphics(CESerializable* obj);
	//##ModelId=3E3FF2D10046
	static void Save(const char* data);
	//##ModelId=3E3FF2D1003F
	static bool finalize();
	//##ModelId=3E3FF2D1003E
	static bool m_resultsNBcreated;
	static bool initSupport();
	//##ModelId=3E3FF2D10034
	static void SaveResults(CExpression* result);
	static bool SaveExprToNB(const char* fn, CESerializable* item, int _flags);
	static bool SaveExprToM(const char* fn, CESerializable* item);
	static bool SaveTextToNB(const char* fn, const char* text, int _flags);
	static bool SaveHeadersToNB(const char* fn, int _flags);
	
	//static const int FILE_APPEND;
	static const int FILE_TRUNCATE;
	static const int FILE_CLOSE;

	static bool saveTeX(const char* fn, CESerializable* obj, int iFileSetts);
	static bool saveTeX(const char* fn, const char* msg, int iFileSetts, bool bConvertMsgToTex=true);
	static bool saveTeXAdv(const char* fn, CESerializable* obj, const char* msg, int iFileSetts, bool bConvertMsgToTex=true);

	//##ModelId=3E3FF2D10033
	CESupport();
	//##ModelId=3E3FF2D10032
	virtual ~CESupport();

public:
	static const char* getNBPostfix();
	static const char* getNBPrefix();

private:
	static void SaveNBPreface(void* p_ofs);
	static void SaveNBPostfix(void* p_ofs);
};

#endif // !defined(AFX_ESUPPORT_H__53236075_988A_42A7_819F_A17DAEBD70B4__INCLUDED_)
