////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ETestTask.cpp: implementation of the CETestTask class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CETestTask::CETestTask():CEAbstractTask()
{
}

CETestTask::~CETestTask()
{
}

CEObject* CETestTask::doTask()
{
	log("Test task started.");
	fillDataStorage();
	scanDataStorage();
	//CESimplifyGammaSequence* sgs_task = new CESimplifyGammaSequence();
	log("1");
	//CEString* s = new CEString("123456789");
	//log(s->getData());
	//s->insertString("aaa", s->length()-2);
	//log(s->getData());
	//log("1.5");
	//CExpression* res = sgs_task->doSimplify((CETensorProduct*)test(), data->getv("p\\_11"), data->getv("p\\_21"));
	CESupport::Save("CDiracAlgebra::simplifyGammaSequence...");
	CExpression* t = test();
	CExpression* res = CDiracAlgebra::simplifyGammaSequence(t, data->getv("p\\_11"), data->getv("p\\_21"));
	CESupport::SaveResults(res);
	delete t;
	delete res;
	log("2");
	CESupport::Save("CFSp::evaluate(...)");
	CExpression* _data = test();
	CESupport::SaveResults(_data);
	CEAbstractFunction* f_sp = new CFSp(_data);
	delete _data;
	_data = f_sp->evaluate();
	if (_data != f_sp) delete f_sp;
	CESupport::Save("Sp() result:");
	CESupport::SaveResults(_data);
	res = CExpression::reduce(_data);
	CESupport::Save("Sp() result reduced:");
	CESupport::SaveResults(res);
	delete res;
	log("3");
	CEProduct* prod = new CEProduct();
	prod->addItem(new CEAntisymmetric(
		data->gete(CConst::GL_ALPHA), true,
		data->gete(CConst::GL_BETA), true,
		data->gete(CConst::GL_CHI), true,
		data->gete(CConst::GL_ETA), true));
	prod->addItem(new CEAntisymmetric(
		data->gete(CConst::GL_ALPHA), false,
		data->gete(CConst::GL_LAMBDA), true,
		data->gete(CConst::GL_OMEGA), true,
		data->gete(CConst::GL_PHI), true));
	log("3.1");
	CESupport::SaveResults(prod);
	log("3.2");
	prod->arrangeTensors();	// Warning: arrangeTensors() interface & implementation changed
	log("3.3");
	CESupport::SaveResults(prod);
	res = CExpression::reduce(prod);
	CESupport::SaveResults(res);
	delete res;
	log("4");
	CFeynLib::test();
	return data;
}

void CETestTask::fillDataStorage()
{
	//log(data);
}

void CETestTask::scanDataStorage()
{
	log(data->gete(CConst::GL_DELTA));
	log(data->gete(CConst::GL_BETA));
	log(data->gete(CConst::DS_ANTISYMMETRIC_BASE));
	log(data->gete(CConst::DV_GAMMA5));
}

CExpression* CETestTask::test()
{
	CETensorProduct* res = new CETensorProduct();
	res->addItem(new CESGammaProduct(data->getv("p\\_1")));
	res->addItem(new CESGammaProduct(data->getv("p\\_2")));
	res->addItem(new CESGammaProduct(data->getv("p\\_11")));
	//res->addItem(data->gete(CConst::DV_GAMMA5)->clone());
	res->addItem(new CESGammaProduct(data->getv("p\\_21")));
	res->addItem(new CESGammaProduct(data->getv("p\\_12")));
	res->addItem(new CESGammaProduct(data->getv("p\\_22")));
	return res;
}
