////////////////////////////////////////////////////////
//	This file is a part of ALHEP project
//	Author: V.Makarenko (makarenko@hep.by)
//	See details at http://www.hep.by/alhep
////////////////////////////////////////////////////////

// ESimplifyGammaSequence.h: interface for the CESimplifyGammaSequence class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ESIMPLIFYGAMMASEQUENCE_H__936386B3_36A1_4713_8F91_471C608D8CBE__INCLUDED_)
#define AFX_ESIMPLIFYGAMMASEQUENCE_H__936386B3_36A1_4713_8F91_471C608D8CBE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//##ModelId=3E3FF2D50222
class CESimplifyGammaSequence : public CEAbstractTask  
{
public:
	//##ModelId=3E3FF2D50247
	CExpression* doSimplify(CETensorProduct* init_sequence, CExpression* left, CExpression* right);
	//##ModelId=3E3FF2D50246
	virtual CEObject* doTask();
	//##ModelId=3E3FF2D50245
	CESimplifyGammaSequence();
	//##ModelId=3E3FF2D50244
	virtual ~CESimplifyGammaSequence();

private:
	//##ModelId=3E3FF2D50243
	bool checkupBounds();
	//##ModelId=3E3FF2D50239
	CExpression* m_right;
	//##ModelId=3E3FF2D50234
	CExpression* m_left;
	//##ModelId=3E3FF2D50242
	bool expandTriples();
	//##ModelId=3E3FF2D5023D
	bool extractFactor();
	//##ModelId=3E3FF2D5022B
	CEProduct* factor;
	//##ModelId=3E3FF2D50226
	CExpression* curr;
	//##ModelId=3E3FF2D5023C
	bool replacePairs();
};

#endif // !defined(AFX_ESIMPLIFYGAMMASEQUENCE_H__936386B3_36A1_4713_8F91_471C608D8CBE__INCLUDED_)
